#include <bits/stdc++.h>

using namespace std;

struct Seg {
    int l, r;
    long long p;

    Seg(int l, int r, long long p) : l(l), r(r), p(p) {}

    Seg() {}
};

bool cmp(Seg &a, Seg &b) {
    return a.r < b.r;
}

const int INF = 1000000000;
vector<Seg> a;
int n, k;

bool check(long long val) {
    vector<int> dp(n + 1, INF);
    dp[0] = -1;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            long long sm = a[j].r < a[i].l ? max(a[j].p, a[i].p) : a[j].p + a[i].p;
            if (dp[j] < a[i].l && a[j].r + 1 >= a[i].l && sm <= val) {
                dp[i] = min(dp[i], a[j].r);
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        if (a[i].r == k - 1 && dp[i] != INF) {
            return true;
        }
    }
    return false;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif

    scanf("%d%d", &n, &k);
    a.resize(n);
    long long sum = 0;
    for (int i = 0; i < n; i++) {
        int l, r, p;
        scanf("%d%d%d", &l, &r, &p);
        l--;
        r--;
        a[i] = Seg(l, r, p);
        sum += p;
    }
    a.push_back(Seg(-1, -1, 0));
    sort(a.begin(), a.end(), cmp);

    long long L = 0;
    long long R = sum + 1;
    while (R - L > 1) {
        long long M = (R + L) / 2;
        if (check(M)) {
            R = M;
        } else {
            L = M;
        }
    }

    if (R == sum + 1) {
        cout << -1 << endl;
    } else {
        cout << R << endl;
    }

    return 0;
}