#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
const int MAXN = 1e5 + 100;
const int MAXL = 1e9 + 100;

struct V{
    int zn;
    int modify;
    int cl, cr;
};

struct DO{
    V tree[MAXN * 100];
    int sz = 1;

    void Build(int v, int l, int r){
        tree[v].zn = 1;
        tree[v].modify = -1;
        tree[v].cl = -1;
        tree[v].cr = -1;
    }

    void keks(int v){
        if (tree[v].cl == -1){
            tree[v].cl = sz++;
            tree[tree[v].cl].cl = -1;
            tree[tree[v].cl].cr = -1;
            tree[tree[v].cl].zn = 1;
            tree[tree[v].cl].modify = -1;
        }

        if (tree[v].cr == -1){
            tree[v].cr = sz++;
            tree[tree[v].cr].cl = -1;
            tree[tree[v].cr].cr = -1;
            tree[tree[v].cr].zn = 1;
            tree[tree[v].cr].modify = -1;
        }
    }
    void Push(int v, int cl, int cr){
        keks(v);
        if (cl + 1 < cr){
            if (tree[v].modify != -1){
                tree[tree[v].cl].zn = tree[v].modify;
                tree[tree[v].cr].zn = tree[v].modify;
                tree[tree[v].cl].modify = tree[v].modify;
                tree[tree[v].cr].modify = tree[v].modify;
                tree[v].modify = -1;
            }
        }
    }

    int Get(int v, int cl, int cr, int pos){
        if (pos < cl || pos >= cr){
            return 0;
        }

        Push(v, cl, cr);

        if (cl + 1 == cr){
            return tree[v].zn;
        } else {
            int cm = (cl + cr) / 2;

            return max(Get(tree[v].cl, cl, cm, pos), Get(tree[v].cr, cm, cr, pos));
        }
    }

    void Upd(int v, int cl, int cr, int l, int r, int zn){
        if (r <= cl || cr <= l){
            return;
        }

        Push(v, cl, cr);

        if (l <= cl && cr <= r){
            tree[v].modify = zn;
            tree[v].zn = zn;
        } else {
            int cm = (cl + cr) / 2;
            Upd(tree[v].cl, cl, cm, l, r, zn);
            Upd(tree[v].cr, cm, cr, l, r, zn);
        }
    }
};

int lnc[MAXN];
int n;
DO mas;

bool pr(int m){
    mas.Upd(0, 0, MAXL, 0, MAXL, 1);

    for (int i = 1; i < n; ++i){
        if (lnc[i] > lnc[i - 1]){
            mas.Upd(0, 0, MAXL, lnc[i - 1], lnc[i], 1);
        } else {
            int j = lnc[i] - 1;
            while (j >= 0 && mas.Get(0, 0, MAXL, j) == m){
                mas.Upd(0, 0, MAXL, j, j + 1, 1);
                j--;
            }

            if (j >= 0){
                mas.Upd(0, 0, MAXL, j, j + 1, mas.Get(0, 0, MAXL, j) + 1);
            } else {
                return false;
            }
        }
    }

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    for (int i = 0; i < n; ++i){
        cin >> lnc[i];
    }

    mas.Build(0, 0, MAXL);

    int l = 0;
    int r = MAXN;

    while (l + 1 < r){
        int m = (l + r) / 2;

        if (pr(m)){
            r = m;
        } else {
            l = m;
        }
    }

    cout << r << endl;
    return 0;
}
