#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
const long long MAXN = 1e5 + 100;

long long n, k;
vector<long long> mas[MAXN];
vector<pair<long long, long long>> sob;

map<long long, long long> szh;
set<long long> fz;

bool keks(){
    sort(sob.begin(), sob.end());
    long long bal = 0;

    for (long long i = 0; i < sob.size(); ++i){
        if (bal == 0 && i != 0){
            return false;
        }

        if (sob[i].second == 1){
            bal++;
        } else {
            bal--;
        }
    }

    return true;
}

long long kukareku(long long mask){
    vector<long long> kart(szh.size(), 0);

    for (long long j = 0; j < n; ++j){
        if ((1 << j) & mask){
            for (long long l = szh[mas[j][1]]; l <= szh[mas[j][0]]; ++l){
                kart[l] += mas[j][2];
            }
        }
    }

    long long ans = 0;
    for (auto e : kart){
        if (e == 0){
            return -1;
        } else {
            ans = max(ans, e);
        }
    }

    return ans;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    bool fl = true;
    bool lft = false;
    bool rght = false;

    for (long long i = 0; i < n; ++i){
        long long l, r, w;
        cin >> l >> r >> w;

        if (l == 1){
            lft = true;
        }

        if (r == k){
            rght = true;
        }

        mas[i].push_back(r - 1);
        mas[i].push_back(l - 1);
        mas[i].push_back(w);
        fz.insert(l - 1);
        fz.insert(r - 1);

        sob.push_back({l - 1, 1});
        sob.push_back({r, 2});

        if (w != 1){
            fl = false;
        }
    }

    if (!keks() || !lft || !rght){
        cout << -1 << endl;
        return 0;
    }

    if (fl){
        map<long long, bool> mp;
        sort(mas, mas + n);

        for (long long i = 0; i < n; ++i){
            if (mas[i][1] == 0){
                mp[mas[i][0]] = true;
            } else {
                if (mp.count(mas[i][1] - 1)){
                    mp[mas[i][0]] = true;
                }
            }
        }

        if (mp.count(k - 1)){
            cout << 1 << endl;
        } else {
            cout << 2 << endl;
        }
    } else {
        long long i = 0;
        for (auto e : fz){
            szh[e] = i;
            ++i;
        }

        long long ans = 1e18;
        for (long long i = 0; i < (1 << n); ++i){
            long long kek = kukareku(i);
            if (kek != -1) ans = min(kek, ans);
        }

        if (ans == 1e18){
            cout << -1 << endl;
        } else {
            cout << ans << endl;
        }
    }

    return 0;
}
