#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAX = 1000000000;

bool check(const vector<int> &ch)
{
    if (ch.size() == 1)
        return false;

    for (int i = 1; i < ch.size(); i++)
        if (ch[i] > ch[i-1])
            return false;

    return true;
}

bool next_perm(vector<int> &ch, int ptr, int alph)
{
    int i;
    bool modified = false;
    for (i = ptr-1; i >= 0; i--)
        if (ch[i] < alph-1) {
            ch[i]++;
            modified = true;
            break;
        }

    if (!modified)
        return false;

    i++;
    for (; i < ptr; i++)
        ch[i] = 0;

    return true;
}

bool valid(const vector<int> &v, int alphabet, int max_size, int n)
{
    vector<int> ch(max_size, 0);

    int ptr = 0;
    int res = 0;
    for (int i = 0; i < n; i++) {
        int last_ptr = ptr;
        ptr = v[i];

        if (ptr > last_ptr)
            for (int j = last_ptr; j < ptr; j++)
                ch[j] = 0;
        else
            if (!next_perm(ch, ptr, alphabet))
                return false;
    }

    return true;
}

int main()
{
    int n;
    cin >> n;

    vector<int> v(n);
    for (int &e : v)
        cin >> e;

    int max_e = *(max_element(v.begin(), v.end()));

    int l = 1, r = MAX;
    while (l < r-1) {
        int m = (l + r) / 2;

        if (valid(v, m, max_e, n))
            r = m;
        else
            l = m;
    }

    if (valid(v, l, max_e, n))
        cout << l << endl;
    else
        cout << r << endl;
}
