#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define eb emplace_back

typedef long long ll;
typedef long double ld;

const int INFint = 1e9;
const ll INF = 1e18;

struct SegmentTree {
    int n;
    vector<pair<ll, ll>> t;

    void modify(int pos, ll val) {
        pos += n;
        t[pos].F = min(val, t[pos].F);
        for (; pos > 1; pos /= 2) {
            t[pos / 2] = min(t[pos], t[pos ^ 1]);
        }
    }

    pair<ll, ll> query(int l, int r) {
        l += n;
        r += n;
        pair<ll, ll> res = {INF, -1};
        for (; l < r; l /= 2, r /= 2) {
            if (l & 1) res = min(res, t[l++]);
            if (r & 1) res = min(res, t[--r]);
        }
        return res;
    }

    SegmentTree(int n) : n(n) {
        t.resize(2 * n, {INF, -1});
    }

};

int n, k;
vector<pair<pair<int, int>, int> > v;

bool can(vector<pair<pair<int, int>, int> > &v) {
    vector<pair<int, int> > ev;
    bool fnd1 = 0, fndk = 0;
    for (auto x : v) {
        if (x.F.F == 1) fnd1 = 1;
        if (x.F.S == k) fndk = 1;
        ev.pb({x.F.F, 0});
        ev.pb({x.F.S + 1, 1});
    }

    if (!fnd1 || !fndk) return 0;
    sort(ev.begin(), ev.end());
    int cur = 0;
    for (auto e : ev) {
        if (e.S == 1) cur--;
        else cur++;
        if (e.F == k + 1) continue;
        if (!cur) return 0;
    }
    return 1;
}


int solve1() {
//    SegmentTree sg(n);
//    sort(v.begin(), v.end(),
//        [] (const pair<pair<int, int>, int> &a, const pair<pair<int, int>, int> &b) -> bool {
//            return a.F.S < b.F.S;
//        }
//    );
//
//    map<int, int> compx;
//
//    for (auto x : v) {
//        compx[x.F.F] = 0;
//        compx[x.F.S] = 0;
//    }
//
//    int sz = 0;
//    for (auto &x : compx) x.S = sz++;
//
//    for (auto &x : v) {
//        x.F.F = compx[x.F.F];
//        x.F.S = compx[x.F.S];
//    }
//    SegmentTree sg(sz);
//    for (auto s : v) {
//        int l = s.F.F;
//        int r = s.F.S;
//        auto pv = sg.query(l - 1, l);
//        if (pv.S != -1) sg.modify(max(1, pv.F));
//
//        sg.modify(sg)
//
//    }
//    return sg.query(sz - 1, sz);
    return 0;
}

ll brute() {
    ll res = INF;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<pair<pair<int, int>, int> > ev;
        vector<pair<pair<int, int>, int> > curV;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                ev.pb({{v[i].F.F, 0}, v[i].S});
                ev.pb({{v[i].F.S, 1}, v[i].S});
                curV.pb(v[i]);
            }
        }
        if (!can(curV)) continue;
        sort(ev.begin(), ev.end());
        ll sum = 0;
        ll cur = 0;
        for (auto e : ev) {
            if (e.F.S == 1) sum -= e.S;
            else sum += e.S;
            cur = max(cur, sum);
        }
        res = min(res, cur);

    }
    return res;
}


int main() {
     ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> k;
    bool isGr = 1;
    v.resize(n);
    for (auto &x : v) {
        cin >> x.F.F >> x.F.S >> x.S;
        if (x.S != 1) isGr = 0;
    }
    if (!can(v)) {
        cout << -1;
        return 0;
    }
    cout << brute() << endl;
    return 0;
    if (isGr) {
        cout << solve1();
        return 0;
    }

    return 0;
}
