#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

#define TASK "sample"

const int maxN = 1e6 + 100;
const int INF = 1e9;
const long long LINF = 3e18;
const long long MOD = 1e9 + 7;
const long long P = 257;
const int K = 1000;

int u[maxN], d[maxN], l[maxN], r[maxN];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	int n;
	cin >> n;
	string s;
	cin >> s;
	int x, y;
	cin >> x >> y;


	for (int i = 0; i < maxN; i++)
	{
		d[i] = u[i] = l[i] = r[i] = -1;
	}
	d[0] = u[0] = l[0] = r[0] = 0;
	
	int cu = 0, cd = 0, cl = 0, cr = 0;
	for (int i = 0; i < n; i++)
	{
		if (s[i] == 'L')
			cl++;
		if (s[i] == 'R')
			cr++;
		if (s[i] == 'U')
			cu++;
		if (s[i] == 'D')
			cd++;
		u[cu] = i + 1;
		d[cd] = i + 1;
		l[cl] = i + 1;
		r[cr] = i + 1;
	}

	int au = -1, ad = -1, al = -1, ar = -1;

	for (int i = 0; i <= n; i++)
	{

		if (i + y >= 0 && i + y < maxN && u[i + y] != -1 && d[i] != -1)
		{
			au = u[i + y];
			ad = d[i];
		}

		if (i + x >= 0 && i + x < maxN && l[i] != -1 && r[i + x] != -1)
		{
			al = l[i];
			ar = r[i + x];
		}
	}

	if (au == -1 || ad == -1 || al == -1 || ar == -1)
	{
		cout << -1;
	}
	else
	{
		cout << al << " " << au << " " << ar << " " << ad;
	}


	return 0;
}

