#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <random>
#include <ctime>
#include <queue>
using namespace std;

#define TASK "sample"

const int maxN = 1e5 + 100;
const int INF = 1e9;
const long long LINF = 3e18;
const long long MOD = 1e9 + 7;
const long long P = 257;
const int K = 1000;
const long long SIZE = (1LL << 31);

mt19937_64 gen;


long long random(long long l, long long r)
{
	uniform_int_distribution<long long> dist(l, r);
	return dist(gen);
}

struct seg
{
	long long l, r, cost;
	seg() {}
	seg(long long l, long long r, long long cost) : l(l), r(r), cost(cost) {}
};

bool comp(seg a, seg b)
{
	return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}
long long d[maxN];


//struct node_seg
//{
//	node_seg *l, *r;
//	long long val;
//	node_seg()
//	{
//		val = INF + 100;
//		l = r = 0;
//	}
//};
//
//struct node_cost
//{
//	node_cost *l, *r;
//	node_seg *t;
//	node_cost()
//	{
//		l = r = t = 0;
//	}
//};
//
//
//node_cost *root = 0;
//
//long long get_seg(long long l, long long r, long long vl, long long vr, node_seg *v)
//{
//	if (l <= vl && vr <= r)
//		return v->val;
//	if (r <= vl || vr <= l)
//		return INF + 100;
//	long long m = (vl + vr) / 2;
//	return min(get_seg(l, r, vl, m, v->l), get_seg(l, r, m, vr, v->r));
//}
//
//long long get_cost(int lc, int rc, int ls, int rs, long long vl = 0, long long vr = SIZE, node_cost *v = root)
//{
//	if (lc <= vl && vr <= rc)
//		return get_seg(ls, rs, 0, SIZE, v->t);
//	if (rc <= vl || vr <= lc)
//		return INF + 100;
//	long long m = (vl + vr) / 2;
//	return min(get_cost(lc, rc, ls, rs, vl, m, v->l), get_cost(lc, rc, ls, rs, m, vr, v->r));
//}
//
//node_seg* add_seg(long long pos, long long val, long long vl, long long vr, node_seg *v)
//{
//	if (v == 0)
//	{
//		v = new node_seg();
//	}
//	v->val = min(v->val, val);
//	if (vr - vl == 1)
//	{
//		return v;
//	}
//	long long m = (vl + vr) / 2;
//	if (pos < m)
//		v->l = add_seg(pos, val, vl, m, v->l);
//	else
//		v->r = add_seg(pos, val, m, vr, v->r);
//	return v;
//}
//
//node_cost* add_cost(long long cost, long long pos, long long val, long long vl = 0, long long vr = SIZE, node_cost *v = root)
//{
//	if (v == 0)
//		v = new node_cost();
//	v->t
//}

struct node
{
	node* l, *r;
	priority_queue<int> val;
	node()
	{
		l = 0, r = 0;
	}
};

node *root = 0;

long long border = 0;

long long get(long long l, long long r, long long vl = 0, long long vr = SIZE, node *v = root)
{
	if (v == 0)
		v = new node();
	if (l <= vl && vr <= r)
	{
		while (!v->val.empty())
		{
			if (v->val.top() < border)
				v->val.pop();
			else
				break;
		}
		if (!v->val.empty())
			return v->val.top();
		else
			return INF + 100;
	}
	if (r <= vl || vr <= l)
		return INF + 100;
	long long m = (vl + vr) / 2;
	return min(get(l, r, vl, m, v->l), get(l, r, m, vr, v->r));
}

node* add(long long pos, long long val, long long vl = 0, long long vr = SIZE, node* v = root)
{
	if (v == 0)
		v = new node();
	v->val.push(val);
	if (vr - vl == 1)
		return v;
	long long m = (vl + vr) / 2;
	if (pos < m)
		v->l = add(pos, val, vl, m, v->l);
	else
		v->r = add(pos, val, m, vr, v->r);
	return v;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif

	int n;
	long long k;

	scanf("%d%lld", &n, &k);
	vector<seg> segs(n);

	for (int i = 0; i < n; i++)
	{
		scanf("%lld%lld%lld", &segs[i].l, &segs[i].r, &segs[i].cost);
		segs[i].l--;
	}

	sort(segs.begin(), segs.end(), comp);

	long long l = 0, r = 2 * INF + 100;

	while (r - l > 1)
	{
		long long m = (l + r) / 2;
		border = 0;
		root = 0;
		priority_queue<pair<pair<long long, long long>, pair<long long, long long> > > ev;
		for (int i = 0; i < n; i++)
		{
			ev.push(make_pair(make_pair(-segs[i].l, 1), make_pair(i, 0)));
		}
		bool flag = false;

		while (!ev.empty())
		{
			auto curr = ev.top();
			ev.pop();
			int t = curr.first.second;
			border = -curr.first.first;
			if (t == 1)
			{
				int i = curr.second.first;
				long long l = -curr.first.first;
				long long mn = INF + 100;
				if(m - segs[i].cost >= 0)
					mn = get(0, m - segs[i].cost + 1);
				if (mn != INF + 100)
				{
					ev.push(make_pair(make_pair(-mn, 0), make_pair(segs[i].cost, segs[i].r)));
					if (segs[i].r == k)
					{
						flag = true;
					}
				}
				mn = get(0, SIZE);
				if (mn == border && segs[i].cost <= m)
				{
					ev.push(make_pair(make_pair(-mn, 0), make_pair(segs[i].cost, segs[i].r)));
					if (segs[i].r == k)
					{
						flag = true;
					}
				}
				if (segs[i].l == 0 && segs[i].r == k && segs[i].cost <= m)
				{
					flag = true;
				}
				if (segs[i].l == 0 && segs[i].cost <= m)
				{
					root = add(segs[i].cost, segs[i].r);
				}
			}
			else if (t == 0)
			{
				long long x = curr.second.first;
				long long r = curr.second.second;
				root = add(x, r);
			}
		}
		if (flag)
			r = m;
		else
			l = m;
	}


	if (r == 2 * INF + 100)
	{
		printf("-1");
	}
	else
	{
		printf("%lld", r);
	}
	return 0;
}

