#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#define fi first
#define se second
using namespace std;
typedef long long ll;

const int INF = 2 * 1e9 + 1e7 + 1e5 + 1e3;
struct segm{
    int l, r;
    int p;
    segm(int l, int r, int p): l(l), r(r), p(p) {}
    segm(){l=0;r=0;p=0;}

    bool operator< (segm s){
        if (l == s.l){
            return r < s.r;
        }
        return l < s.l;
    }
};

vector<segm> s;
int n, k;

void solve1(){
    int x = 1;
    int j = 0;
    while (x < k + 1 && j < n){
        int new_x = 0;
        while (j < n && x >= s[j].l){
            if (s[j].r > new_x){
                new_x = s[j].r;
            }
            j++;
        }
        if (x >= new_x){
            break;
        }
        x = new_x;
    }

    if (x < 1 + k){
        printf("-1\n");
        return;
    }

    set<int> b;

    b.insert(1);

    for (int i = 0; i < n; i++){
        if (b.count(s[i].l) > 0){
            b.insert(s[i].r);
        }
    }
    if (b.count(k + 1) > 0){
        printf("%d\n", 1);
        return;
    }

    printf("%d\n", 2);
    return;

}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d %d", &n, &k);

    s.assign(n, segm());
    for (int i = 0; i < n; i++){
        scanf("%d %d %d", &s[i].l, &s[i].r, &s[i].p);
        s[i].r++;;
    }

    sort(s.begin(), s.end());

    solve1();


    fclose(stdin);
    fclose(stdout);
    return 0;
 }
