#include <iostream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <set>
#define fi first
#define se second
using namespace std;
typedef long long ll;
const ll LINF = 1000 * (1ll) * 1000 * 1000 * (1ll) * 1000 * 1000 * (1ll) * 1000 + 100000;
const int INF = 2 * 1e9 + 1e7 + 1e5 + 1e3;
struct segm{
    int l, r;
    int p;
    segm(int l, int r, int p): l(l), r(r), p(p) {}
    segm(){l=0;r=0;p=0;}

    bool operator< (segm s){
        if (l == s.l){
            return r < s.r;
        }
        return l < s.l;
    }
};

ll min(ll a, ll b){
    if (a < b){
        return a;
    }
    return b;
}
ll max(ll a, ll b){
    if (a > b){
        return a;
    }
    return b;
}

vector<int> v;
vector<bool> dp;
vector<segm> s;
int n, k;

void solve1(){
    int x = 1;
    int j = 0;
    while (x < k + 1 && j < n){
        int new_x = 0;
        while (j < n && x >= s[j].l){
            if (s[j].r > new_x){
                new_x = s[j].r;
            }
            j++;
        }
        if (x >= new_x){
            break;
        }
        x = new_x;
    }

    if (x < 1 + k){
        printf("-1\n");
        return;
    }

    set<int> b;

    b.insert(1);

    for (int i = 0; i < n; i++){
        if (b.count(s[i].l) > 0){
            b.insert(s[i].r);
        }
    }
    if (b.count(k + 1) > 0){
        printf("%d\n", 1);
        return;
    }

    printf("%d\n", 2);
    return;

}

ll check(vector<segm> ve){
    int x = 1;
    int j = 0;
    while (x < k + 1 && j < ve.size()){
        int new_x = 0;
        while (j < ve.size() && x >= ve[j].l){
            if (ve[j].r > new_x){
                new_x = ve[j].r;
            }
            j++;
        }
        if (x >= new_x){
            break;
        }
        x = new_x;
    }

    if (x < 1 + k){
        return LINF;
    }

    ll mx = -1;
    //cerr << v.size() << endl;
    for (int i = 0; i < v.size(); i++){
        //cerr << v[i] << endl;
        ll sm = 0;
        for (int j = 0; j < ve.size(); j++){
            if (ve[j].l <= v[i] && v[i] <= ve[j].r){
                sm += ve[j].p;
            }
        mx = max(mx, sm);
    }
    }

    if (mx <= 0){
        return LINF;
    }
    return mx;

}

void solve2(){
    /*int x = 1;
    int j = 0;
    while (x < k + 1 && j < n){
        int new_x = 0;
        while (j < n && x >= s[j].l){
            if (s[j].r > new_x){
                new_x = s[j].r;
            }
            j++;
        }
        if (x >= new_x){
            break;
        }
        x = new_x;
    }

    if (x < 1 + k){
        printf("-1\n");
        return;
    }*/

    v.assign(2 * n, 0);
    dp.assign(2*n, 0);
    for (int i = 0; i < n; i++){
        v[i * 2] = s[i].l;
        v[i * 2 + 1] = s[i].r;
    }
    sort(v.begin(), v.end());
    //cerr << v.size() << endl;

/*
    int left = 0;
    int right = INF;
    while (left + 1 < right){
        int mid = (left * (1ll) + right) / 2;
        if (check(mid)){
            right = mid;
        } else {
            left = mid;
        }
    }

    return right;*/
    ll mx = LINF;

    for (int i = 0; i < (1 << (n + 1)); i++){
        vector<segm> ve;
        for (int j = 0; j < n; j++){
            if ((i >> j) & 1 != 0){
                ve.push_back(s[j]);
            }
        }
        mx = min(mx, check(ve));
        //cerr << mx << " " << i << endl;
    }

    if (mx == LINF || mx < 0 || mx == INF){
        printf("%d\n", -1);
        return;
    }
    printf("%d\n", mx);
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d %d", &n, &k);

    s.assign(n, segm());
    bool first_m = true;
    for (int i = 0; i < n; i++){
        scanf("%d %d %d", &s[i].l, &s[i].r, &s[i].p);
        s[i].r++;
        if (s[i].p != 1){
            first_m = false;
        }
    }

    sort(s.begin(), s.end());

    if (first_m){
        solve1();
    } else {
        solve2();
    }


    fclose(stdin);
    fclose(stdout);
    return 0;

 }
