#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>

struct Point
{
    int l;
    int r;
    int p;
    Point(int l, int r, int p)
    {
        this->l = l;
        this->r = r;
        this->p = p;
    }
};

bool compair(Point *p1, Point *p2)
{
    return (p1->l < p2->l);
}

class Compair
{
public:
    bool operator() (Point *p1, Point *p2) const
    {
        return (p1->r < p2->r);
    }
};

struct Node
{
    int x;
    bool flag;
    Node(int x, bool flag)
    {
        this->x = x;
        this->flag = flag;
    }
};

bool compair3(Node *n1, Node *n2)
{
    return (n1->x < n2->x || ((n1->x == n2->x) && (n1->flag && !n2->flag)));
}

int main()
{
    int n, k, l, r, p, a = 1;
    scanf("%d%d", &n, &k);
    std::vector<Point*> data, ans;
    std::priority_queue<Point*, std::vector<Point*>, Compair> cont;
    for (int i = 0; i < n; i++) {
        scanf("%d%d%d", &l, &r, &p);
        data.push_back(new Point(l, r, p));
    }
    std::sort(data.begin(), data.end(), compair);
    n = data.size();
    r = 1;
    int i = 0;
    while ((i < n) && (data[i]->l == 1))
        cont.push(data[i++]);
    while (r <= k) {
        while (cont.size() && cont.top()->r < r)
            cont.pop();
        if (!cont.size()) {
            printf("-1\n");
            return 0;
        }
        ans.push_back(cont.top());
        r = cont.top()->r + 1;
        while ((i < n) && (data[i]->l <= r))
            cont.push(data[i++]);
    }
    std::vector<Node*> vec;
    for (int i = 0; i < ans.size(); i++) {
        vec.push_back(new Node(ans[i]->l, true));
        vec.push_back(new Node(ans[i]->r, false));
    }
    std::sort(vec.begin(), vec.end(), compair3);
    int col = 0, mm = 0;
    for (int i = 0; i < vec.size(); i++)
        if (vec[i]->flag) {
            col++;
            if (col > mm)
                mm = col;
        }
        else
            col--;
    printf("%d\n", mm);
    return 0;
}
