#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

int dp[4][MAXN];

int main() {
//	freopen(".in", "r", stdin);

	int n; cin >> n;

	string a = next_token();
	for(int i = a.size() - 1; i >= 0; i--) {
        dp[0][i] = dp[0][i + 1] + (a[i] == 'U');
        dp[1][i] = dp[1][i + 1] + (a[i] == 'D');
        dp[2][i] = dp[2][i + 1] + (a[i] == 'L');
        dp[3][i] = dp[3][i + 1] + (a[i] == 'R');
	}
	int Y = dp[0][0] - dp[1][0], X = dp[3][0] - dp[2][0];

	int x, y; cin >> x >> y;

    map<int, int> q, w;
    for(int i = 0; i <= n; i++) {
        q[dp[1][i]] = i;
        w[dp[2][i]] = i;
    }

    int ans[4] = {-1, -1, -1, -1};
    for(int i = 0; i <= n; i++) {
        int xe = X - dp[3][i];
        int ye = Y - dp[0][i];

        if(q.find(y - ye) != q.end()) {
            ans[1] = i;
            ans[3] = q[y - ye];
        }
        if(w.find(x - xe) != w.end()) {
            ans[2] = i;
            ans[0] = w[x - xe];
        }
    }

    if(ans[0] == -1 || ans[1] == -1)
        puts("-1");
    else
        cout << ans[0] << " " << ans[1] << " " << ans[2] << " " << ans[3] << "\n";
}
