#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <iomanip>

#define sqr(a) (a)*(a)
#define all(a) (a).begin(), (a).end()
using namespace std;

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do { ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch >= '0' && ch <= '9') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

string next_token() {
    char ch;
    string ans = "";
    do { ch = getchar(); } while(ch <= ' ') ;
    while(ch >= ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const long long INF = (long long)1e18 + 227 + 1;
const int INFINT = (int)1e9 + 227 + 1;
const int MAXN = (int)1e6 + 227 + 1;
const int MOD = (int)1e9 + 7;
const long double EPS = 1e-9;

pair<pair<int, int>, int> q[MAXN];

struct tree {
    struct node {
        node() {
            l = r = -1;
            k = 0;
            mn = 0;
            push = 0;
        }

        int l, r;
        int k;
        int mn;
        int push;
    };

    int len;

    tree(int len) : len(len) {
        t.push_back(node());
    }

    vector<node> t;

    void push(int v) {
        if(t[v].l == -1) {
            t[v].l = t.size();
            t.push_back(node());
        }
        if(t[v].r == -1) {
            t[v].r = t.size();
            t.push_back(node());
        }

        t[t[v].l].push += t[v].push;
        t[t[v].l].mn += t[v].push;
        t[t[v].l].k += t[v].push;

        t[t[v].r].push += t[v].push;
        t[t[v].r].mn += t[v].push;
        t[t[v].r].k += t[v].push;

        t[v].push = 0;
    }

    void add(int v, int l, int r, int _l, int _r) {
        if(_l > _r) return;
        if(l == _l && r == _r) {
            t[v].push++;
            t[v].k++;
            t[v].mn++;

            return;
        }

        push(v);

        int mid = (l + r) / 2;
        add(t[v].l, l, mid, _l, min(mid, _r));
        add(t[v].r, mid + 1, r, max(mid + 1, _l), _r);

        t[v].mn = min(t[t[v].l].mn, t[t[v].r].mn);
    }

    void add(int l, int r) {
        add(0, 1, len, l, r);
    }

    int get(int v, int l, int r, int p) {
        if(l == r)
            return t[v].k;

        push(v);

        int mid = (l + r) / 2;
        if(p <= mid)
            return get(t[v].l, l, min(mid, r), p);
        else
            return get(t[v].r, max(mid + 1, l), r, p);
    }

    int get(int p) {
        return get(0, 1, len, p);
    }
} ;

int n, k;

bool f(int c) {
    tree t(k);

    for(int i = 0; i < n; i++) {
        int l = q[i].first.first;
        int r = -q[i].first.second;

        if(t.get(l) < c)
            t.add(l, r);
    }

    return (t.t[0].mn > 0);
}

int main() {
//	freopen(".in", "r", stdin);

	cin >> n >> k;
	for(int i = 0; i < n; i++) {
		q[i].first.first = next_int<int>();
		q[i].first.second = -next_int<int>();
		q[i].second = next_int<int>();
	}

	sort(q, q + n);

    int l = 1;
    int r = n;
    while(r - l > 1) {
        int c = (l + r) / 2;
        if(f(c))
            r = c;
        else
            l = c;
    }

    if(f(l))
        cout << l << "\n";
    else
        cout << r << "\n";
}
