#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector <int> l_raw, l, sz;


struct arr {
private:
    vector <int> a, mod;
    int N;
    inline void push(int u) {
        if (mod[u]) {
            if (u < N) {
                a[u * 2] = a[u * 2 + 1] = 0;
                mod[u * 2] = mod[u * 2 + 1] = 1;
            }
            mod[u] = 0;
        }
    }
public:
    arr(int _n) {
        N = 1;
        while (N < _n)
            N *= 2;
        a.resize(N * 2, 0);
        mod.resize(N * 2, 0);
    }
    int get(int id, int v = 1, int cl = 0, int cr = -1) {
        if (cr == -1)
            cr = N;
        if (cr - cl == 1 || mod[v])
            return a[v];
        push(v);
        if (id < (cl + cr) / 2)
            return get(id, v * 2, cl, (cl + cr) / 2);
        else
            return get(id, v * 2 + 1, (cl + cr) / 2, cr);
    }
    void add(int id, int d, int v = 1, int cl = 0, int cr = -1) {
        if (cr == -1)
            cr = N;
        //cout << "ADD " << id << ' ' <<d << ' ' << v << ' ' << cl << ' ' << cr << endl;
        push(v);
        if (cr - cl == 1) {
            a[v] += d;
            return;
        }
        if (id < (cl + cr) / 2)
            add(id, d, v * 2, cl, (cl + cr) / 2);
        else
            add(id, d, v * 2 + 1, (cl + cr) / 2, cr);
    }
    void set0(int st, int ed, int v = 1, int cl = 0, int cr = -1) {
        if (cr == -1)
            cr = N;
        if (st <= cl && cr <= ed) {
            mod[v] = 1;
            return;
        }
        if (cr <= st || ed <= cl)
            return;
        push(v);
        set0(st, ed, v * 2, cl, (cl + cr) / 2);
        set0(st, ed, v * 2 + 1, (cl + cr) / 2, cr);
    }
};

bool check(int al) {
    int64_t pows[32];
    pows[0] = 1;
    for (int i = 1; i < 32; i++) {
        if (pows[i - 1] * al > n)
            pows[i] = n + 1;
        else
            pows[i] = pows[i - 1] * al;
    }
    int digs[sz.size()];
    for (int i = 0; i < sz.size(); i++)
        if (sz[i] > 31)
            digs[i] = n + 1;
        else
            digs[i] = pows[sz[i]];
    //cout << "CH " << al << endl;
    arr a(sz.size());
    for (int i = 1; i < n; i++) {
        //cout << "STEP " << i << endl;
        if (l[i] > l[i - 1]) {
            a.set0(l[i - 1], l[i]);

        } else {
            a.add(l[i] - 1, 1);
            for (int j = l[i] - 1; j >= 0; j--) {
                if (a.get(j) < digs[j])
                    break;
                if (j == 0)
                    return false;
                a.add(j, -digs[j]);
                a.add(j - 1, 1);
            }
        }
    }
    return true;
}

int main() {
    //ifstream cin("input.txt");
    //ofstream cout("output.txt");
    cin >> n;
    l.resize(n);
    vector <int> ls(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        ls[i] = l[i];
    }
    for (int i = 1; i < n; i++) {
        if (l[i] <= l[i - 1])
            break;
        if (i == n - 1) {
            cout << 1;
            return 0;
        }
    }
    sort(ls.begin(), ls.end());
    ls.resize(unique(ls.begin(), ls.end()) - ls.begin());
    sz.resize(ls.size());
    sz[0] = ls[0];
    for (int i = 1; i < ls.size(); i++)
        sz[i] = ls[i] - ls[i - 1];
    for (int i = 0; i < n; i++)
        l[i] = upper_bound(ls.begin(), ls.end(), l[i]) - ls.begin();
    /*for (int i = 0; i < ls.size(); i++)
        cout << sz[i] << ' ';
    cout << endl;
    for (int i = 0; i < ls.size(); i++)
        cout << l[i] << ' ';
    cout << endl;*/
    int bl = 1, br = n, mid;
    while (br - bl > 1) {
        mid = (bl + br) / 2;
        if (check(mid))
            br = mid;
        else
            bl = mid;
    }
    cout << br;
    return 0;
}
