#include <cstdio>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;

const long long INF = 2e18;

struct dot
{
	int x, type, index, p, next;
	dot(int _x = 0, int _type = 0, int _index = 0, int _p = 0, int _next = 0)
	{
		x = _x;
		type = _type;
		index = _index;
		p = _p;
		next = _next;
	}
};

bool comp(dot &a, dot &b)
{
	return ((a.x < b.x) || (a.x == b.x) && (a.type < b.type));
}

bool is_bit(int mask, int i)
{
	return (((1 << i) & mask) != 0);
}

int main()
{
	freopen("input.txt", "rt", stdin);
	int n, k;
	scanf("%d%d", &n, &k);
	vector < int > l(n), r(n), p(n);
	vector < dot > a(2 * n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d%d", &l[i], &r[i], &p[i]);
		a[2 * i] = dot(l[i], 0, i, p[i]);
		a[2 * i + 1] = dot(r[i], 1, i, p[i]);
	}
	a.push_back(dot(1, -1, -1, 0, 0));
	a.push_back(dot(k, INF, -1, 0, 0));
	sort(a.begin(), a.end(), comp);
	if (n <= 10)
	{
		int step = (1 << n);
		long long ans = INF;
		for (int mask = 1; mask < step - 1; ++mask)
		{
			int l_x = INF, r_x = INF;
			vector < pair < pair < int, int >, int > > b;
			for (int i = 0; i < n; ++i)
			{
				if (is_bit(mask, i))
				{
					b.push_back(make_pair(make_pair(l[i], r[i]), p[i]));
				}
			}
			bool f = true;
			long long max_p = 0;
			for (int i = 0; i < a.size() - 1; ++i)
			{
				int x = a[i].x, y = a[i + 1].x;
				long long cur = 0;
				int kol = 0;
				for (int j = 0; j < b.size(); ++j)
				{
					if ((b[j].first.first <= x) && (b[j].first.second >= x))
						cur += 1ll * b[j].second;
				}
				if (cur == 0)
					kol++;
				max_p = max(max_p, cur);

				cur = 0;
				for (int j = 0; j < b.size(); ++j)
				{
					if ((b[j].first.first <= y) && (b[j].first.second >= y))
						cur += 1ll * b[j].second;
				}
				if (cur == 0)
					kol++;
				max_p = max(max_p, cur);

				cur = 0;
				for (int j = 0; j < b.size(); ++j)
				{
					if ((b[j].first.first < x) && (b[j].first.second > y))
						cur += 1ll * b[j].second;
				}
				if (cur == 0)
					kol++;
				max_p = max(max_p, cur);
				if (kol == 3)
					f = false;
			}
			if (f)
				ans = min(ans, max_p);
		}
		if (ans == INF)
			ans = -1;
		printf("%lld", ans);

	}
	else
	{
		for (int i = 0; i < 2 * n; ++i)
			for (int j = 0; j < 2 * n; ++i)
			{
				if ((a[i].index == a[j].index) && (a[i].type == 0))
					a[i].next = j;
			}
		vector < long long > dp(2 * n, INF);
		dp[0] = 0;
	}
	return 0;
}