#include <cstdio>
#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const long long INF = 2e18;

struct dot
{
	int x, type, index, p, next;
	dot(int _x = 0, int _type = 0, int _index = 0, int _p = 0, int _next = 0)
	{
		x = _x;
		type = _type;
		index = _index;
		p = _p;
		next = _next;
	}
};

bool comp(dot &a, dot &b)
{
	return ((a.x < b.x) || (a.x == b.x) && (a.type < b.type));
}

bool is_bit(int mask, int i)
{
	return (((1 << i) & mask) != 0);
}

void dfs(map < int, vector < int > > &g, set < int > &used, int v)
{
	if (used.find(v) != used.end())
		return;
	used.insert(v);
	for (int i = 0; i < g[v].size(); ++i)
	{
		dfs(g, used, g[v][i]);
	}
}

bool try_one(vector < pair < int, int > > &b, int n, int k)
{
	map < int, vector < int > > g;
	int i = 0;
	while ((i < n) && (b[i].first == 1))
	{
		g[0].push_back(b[i].second + 1);
		i++;
	}
	for (i = 0; i < n; ++i)
	{
		int to = b[i].second;
		int l = to, r = n;
		while (r - l > 1)
		{
			int m = (r + l) / 2;
			if (b[m].first <= to)
				m = l;
			else
				m = r;
		}
		int j = l;
		while ((j > 0) && (j < n) && (b[j].first == to))
		{
			g[b[i].first].push_back(b[j].second);
			j--;
		}
	}
	set < int > used;
	dfs(g, used, 0);
	if (used.find(k) != used.end())
		return true;
	else
		return false;
}

bool try_two(vector < pair < int, int > > &b, int n, int k)
{
	if (b[0].first != 1)
		return false;
	int cur = 1;
	int last = 1;
	for (int i = 0; i < n; ++i)
	{
		if (b[i].first > cur)
		{
			if (last <= cur)
				return false;
			cur = last;
		}
		else
			last = max(last, b[i].second);
	}
	if (last == k)
		return true;
	else
		return false;
}


int main()
{
	freopen("input.txt", "rt", stdin);
	int n, k;
	scanf("%d%d", &n, &k);
	vector < int > l(n), r(n), p(n);
	vector < dot > a(2 * n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d%d", &l[i], &r[i], &p[i]);
		a[2 * i] = dot(l[i], 0, i, p[i]);
		a[2 * i + 1] = dot(r[i], 1, i, p[i]);
	}
	a.push_back(dot(1, -1, -1, 0, 0));
	a.push_back(dot(k, INF, -1, 0, 0));
	sort(a.begin(), a.end(), comp);
	if (n <= 1)
	{
		int step = (1 << n);
		long long ans = INF;
		for (int mask = 1; mask < step; ++mask)
		{
			int l_x = INF, r_x = INF;
			vector < pair < pair < int, int >, int > > b;
			for (int i = 0; i < n; ++i)
			{
				if (is_bit(mask, i))
				{
					b.push_back(make_pair(make_pair(l[i], r[i]), p[i]));
				}
			}
			bool f = true;
			long long max_p = 0;
			for (int i = 0; i < a.size() - 1; ++i)
			{
				int x = a[i].x, y = a[i + 1].x;
				long long cur = 0;
				int kol = 0;
				if (y - x == 1)
				{
					for (int j = 0; j < b.size(); ++j)
					{
						if ((b[j].first.first <= x) && (b[j].first.second >= x))
							cur += 1ll * b[j].second;
					}
					if (cur == 0)
						f = false;
					max_p = max(max_p, cur);

					cur = 0;
					for (int j = 0; j < b.size(); ++j)
					{
						if ((b[j].first.first <= y) && (b[j].first.second >= y))
							cur += 1ll * b[j].second;
					}
					if (cur == 0)
						f = false;
					max_p = max(max_p, cur);
				}
				else
				{
					for (int j = 0; j < b.size(); ++j)
					{
						if ((b[j].first.first <= x) && (b[j].first.second >= y))
							cur += 1ll * b[j].second;
					}
					if (cur == 0)
						f = false;
					max_p = max(max_p, cur);
				}

				
			}
			if (f)
				ans = min(ans, max_p);
		}
		if (ans == INF)
			ans = -1;
		printf("%lld", ans);

	}
	else
	{
		vector < pair < int, int > > b;
		for (int i = 0; i < n; ++i)
		{
			b.push_back(make_pair(l[i], r[i]));
		}
		sort(b.begin(), b.end());
		bool f = try_one(b, n, k);
		if (f)
		{
			printf("1");
			return 0;
		}
		f = try_two(b, n, k);
		if (f)
		{
			printf("2");
			return 0;
		}
		printf("-1");
	}
	return 0;
}