#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
const int M = 1e5 + 7;
int l[M];

const int LIM = 2e5 + 7;
int mx[4 * LIM];
int st[4 * LIM];

void build(int v, int l, int r)
{
    if (r - l == 1)
    {
        st[v] = -1;
        mx[v] = 0;
    }
    else
    {
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        mx[v] = 0;
        st[v] = -1;
    }
}

void pesh(int v)
{
    if (st[v] != -1)
    {
        mx[v * 2 + 1] = st[v];
        mx[v * 2 + 2] = st[v];
        st[v * 2 + 1] = st[v];
        st[v * 2 + 2] = st[v];
        st[v] = -1;
    }
}

int get(int v, int l, int r, int tl, int tr)
{
    if (tl >= r || tr <= l)
    {
        return 0;
    }
    if (tl >= l && tr <= r)
    {
        return mx[v];
    }
    else
    {
        int tm = (tl + tr) / 2;
        pesh(v);
        return max(get(v * 2 + 1, l, r, tl, tm), get(v * 2 + 2, l, r, tm, tr));
    }
}

void upd(int v, int l, int r, int tl, int tr, int x)
{
    if (tl >= r || tr <= l)
    {
        return;
    }
    if (tl >= l && tr <= r)
    {
        mx[v] = st[v] = x;
    }
    else
    {
        int tm = (tl + tr) / 2;
        pesh(v);
        upd(v * 2 + 1, l, r, tl, tm, x);
        upd(v * 2 + 2, l, r, tm, tr, x);
        mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
    }
}

int get_pos(int v, int l, int r)
{
    if (r - l == 1)
    {
        return l;
    }
    else
    {
        int m = (l + r) / 2;
        pesh(v);
        if (mx[v * 2 + 2] != 0)
        {
            return get_pos(v * 2 + 2, m, r);
        }
        if (mx[v * 2 + 1] != 0)
        {
            return get_pos(v * 2 + 1, l, m);
        }
    }
}

const int N = 1e9 + 7;

struct tree
{
    tree *l, *r;
    int tl, tr;
    int val;
    int st;
    tree(int x, int l, int r): val(x), st(-1), l(0), r(0), tl(l), tr(r) {}
};

void push(tree *t)
{
    if (t->st != -1)
    {
        t->l->val = t->st;
        t->r->val = t->st;
        t->l->st = t->st;
        t->r->st = t->st;
        t->st = -1;
    }
}

void hello(tree *t)
{
    int m = (t->tl + t->tr) / 2;
    if (!t->l)
    {
        t->l = new tree(0, t->tl, m);
    }
    if (!t->r)
    {
        t->r = new tree(0, m, t->tr);
    }
}

int get_pos(tree *t)
{
    if (t->tr - t->tl == 1)
    {
        return t->tl;
    }
    hello(t);
    push(t);
    if (t->r->val != 0)
    {
        return get_pos(t->r);
    }
    else
    {
        return get_pos(t->l);
    }
}

int get(tree *t, int l, int r)
{
    if (t->tl >= r || t->tr <= l)
    {
        return 0;
    }
    if (t->tl >= l && t->tr <= r)
    {
        return t->val;
    }
    else
    {
        hello(t);
        push(t);
        return max(get(t->l, l, r), get(t->r, l, r));
    }
}

void upd(tree *t, int l, int r, int x)
{
    if (t->tl >= r || t->tr <= l)
    {
        return;
    }
    if (t->tl >= l && t->tr <= r)
    {
        t->st = x;
        t->val = x;
    }
    else
    {
        hello(t);
        push(t);
        upd(t->l, l, r, x), upd(t->r, l, r, x);
        t->val = max(t->l->val, t->r->val);
        return;
    }
}

bool smartest_check(int x)
{
    build(0, 0, LIM);
    upd(0, 0, l[n - 1], 0, LIM, x);
    for (int i = n - 2; i >= 0; i--)
    {
        if (l[i] < l[i + 1])
        {
            upd(0, l[i], LIM, 0, LIM, 0);
            continue;
        }
        else
        {
            if (mx[0] == 0)
            {
                return 0;
            }
            int ind = get_pos(0, 0, LIM);
            int who = get(0, ind, ind + 1, 0, LIM);
            upd(0, ind + 1, l[i], 0, LIM, x);
            upd(0, ind, ind + 1, 0, LIM, who - 1);
        }
    }
    return 1;
}

bool smart_check(int x)
{
    tree *t = new tree(0, 0, N);
    upd(t, 0, l[n - 1], x);
    for (int i = n - 2; i >= 0; i--)
    {
        if (l[i] < l[i + 1])
        {
            upd(t, l[i], N, 0);
            continue;
        }
        else
        {
            if (get(t, 0, N) == 0)
            {
                return 0;
            }
            int ind = get_pos(t);
            int who = get(t, ind, ind + 1);
            upd(t, ind + 1, l[i], x);
            upd(t, ind, ind + 1, who - 1);
        }
    }
    return 1;
}

int main()
{
    scanf("%d", &n);
    int mx = 0;
    for (int i = 0; i < n; i++)
    {
        scanf("%d", &l[i]);
        mx = max(mx, l[i]);
    }
    if (mx <= 200000)
    {
        int l = -1, r = n;
        while (l < r - 1)
        {
            int m = (l + r) / 2;
            if (smartest_check(m))
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        printf("%d\n", r + 1);
        return 0;
    }
    int l = -1, r = n;
    while (l < r - 1)
    {
        int m = (l + r) / 2;
        if (smart_check(m))
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    printf("%d\n", r + 1);
}
