#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

struct mac
{
    long long l, r, p;
};

inline bool operator<(mac a, mac b)
{
    return a.r < b.r;
}

int n, k;
long long ans = 1e18;
vector <mac> m;
vector <set <pair <int, long long> > > v;

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr);

    cin >> n >> k;
    m.resize(n);
    v.resize(n);
    for (int i = 0; i < n; i++)
        cin >> m[i].l >> m[i].r >> m[i].p;

    sort(m.begin(), m.end());

    if (n > 3000)
    {
        set <int> s;
        s.insert(0);

        for (int i = 0; i < n; i++)
            if (s.find(m[i].l - 1) != s.end())
                s.insert(m[i].r);

        if (s.find(k) != s.end())
            return cout << 1, 0;

        s.clear();
        for (int i = 0; i < n; i++)
            if (s.lower_bound(m[i].l - 1) != s.end())
                s.insert(m[i].r);

        if (s.find(k) != s.end())
            cout << 1;
        else
            cout << 2;

        return 0;
    }

    for (int i = 0; i < n; i++)
        if (m[i].l == 1)
            v[i].insert({0, m[i].p});

    for (int i = 0; i < n; i++)
    {
        for (int j = i - 1; j >= 0; j--)
        {
            if (m[j].r < m[i].l - 1)
                break;

            long long now = 1e18, nowp = max(m[i].p, m[j].p);
            if (m[j].r >= m[i].l)
                nowp = m[i].p + m[j].p;

            for (auto a : v[j])
                if (a.first < m[i].l)
                    now = min(now, max(a.second, nowp));
                else
                    break;

            if (now != 1e18)
                v[i].insert({m[j].r, now});
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (m[i].r == k)
        {
            //cout << i << endl;
            long long ansnow = 1e18;
            for (auto a : v[i])
            {
                //cout << a.first << ' ' << a.second << "   ";
                ansnow = min(ansnow, a.second);
            }
            //cout << endl;
            ans = min(ansnow, ans);
        }
    }

    if (ans != 1e18)
        cout << ans;
    else
        cout << -1;
    return 0;
}
