#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <fstream>

using namespace std;

const int MAX = 1e5 + 13;

int n, k;

struct seg{
	int l, r, p;
	seg() {}
};

seg s[MAX];

pair<int, int> p[MAX];

map<int, vector<int> > mp;

map<int, int> dp;

bool dfs(int x) {
	if (dp.find(x) != dp.end())
		return dp[x];

	if (x == k + 1) {
		dp[x] = 1;
		return 1;
	}

	for (int i = 0; i < mp[x].size(); i++) {
		int to = s[mp[x][i]].r + 1;
		if (dfs(to))
			return true;
	}

	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n >> k;

	for (int i = 1; i <= n; i++) {
		int a;
		cin >> p[i].first >> p[i].second >> a;
		s[i].l = p[i].first;
		s[i].r = p[i].second;
		s[i].p = a;
		mp[s[i].l].push_back(i);
	}
	
	sort(p + 1, p + n + 1);
	
	if (p[1].first > 1) {
		cout << -1;
		return 0;
	}

	int r = p[1].second;

	for (int i = 2; i <= n; i++) {
		if (p[i].first - r > 1) {
			cout << -1;
			return 0;
		}
		r = max(r, p[i].second);
	}

	if (r < k) {
		cout << -1;
		return 0;
	}

	if (dfs(1)) {
		cout << 1;
		return 0;
	}

	cout << 2;
	return 0;
}