#include <iostream>
#include <string>
#include <vector>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <fstream>

using namespace std;

const int MAX = 1e5 + 13;

int n, k;

struct seg{
	int l, r, p;
	seg() {}
};

seg s[MAX];

pair<int, int> p[MAX];

map<int, vector<int> > mp;

map<int, int> dp;

bool dfs(int x) {
	if (dp.find(x) != dp.end())
		return dp[x];

	if (x == k + 1) {
		dp[x] = 1;
		return 1;
	}

	for (int i = 0; i < mp[x].size(); i++) {
		int to = s[mp[x][i]].r + 1;
		if (dfs(to))
			return true;
	}

	return false;
}

int x[13];

bool can(vector<pair<int, int> > se) {
	if (se.size() == 0)
		return 0;

	sort(se.begin(), se.end());

	if (se[0].first > 1) 
		return 0;

	int r = se[0].second;

	for (int i = 1; i < se.size(); i++) {
		if (se[i].first - r > 1) 
			return 0;
		r = max(r, se[i].second);
	}

	if (r < k) 
		return 0;

	return 1;
}

long long stupid_solve(int i) {
	if (i == n) {
		vector<pair<int, int> > vec;

		for (int i = 1; i <= n; i++) 
			if (x[i])
				vec.push_back(make_pair(s[i].l, s[i].r));
		

		if (!can(vec)) 
			return -1;
		
		vector<pair<int, int> > e;
		for (int i = 1; i <= n; i++) {
			if (x[i]) {
				e.push_back(make_pair(s[i].l, -s[i].p));
				e.push_back(make_pair(s[i].r, s[i].p));
			}
		}
		sort(e.begin(), e.end());

		int ans = -1;
		int bal = 0;
		for (int i = 0; i < e.size(); i++) {
			ans = max(ans, bal);
			if (e[i].second > 0) {
				bal -= e[i].second;
			}
			else {
				bal -= e[i].second;
			}
		}
		return ans;
	}

	long long ans = 1e18;

	x[i + 1] = 0;
	long long ans1 = stupid_solve(i + 1);
	if (ans1 != -1)
		ans = min(ans, stupid_solve(i + 1));

	x[i + 1] = 1;
	ans1 = stupid_solve(i + 1);
	if (ans1 != -1)
		ans = min(ans, stupid_solve(i + 1));
	
	if (ans == 1e18) {
		ans = -1;
	}

	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n >> k;

	for (int i = 1; i <= n; i++) {
		int a;
		cin >> p[i].first >> p[i].second >> a;
		s[i].l = p[i].first;
		s[i].r = p[i].second;
		s[i].p = a;
		mp[s[i].l].push_back(i);
	}
	
	if (n <= 10) {
		cout << stupid_solve(0);
		return 0;
	}

	sort(p + 1, p + n + 1);
	
	if (p[1].first > 1) {
		cout << -1;
		return 0;
	}

	int r = p[1].second;

	for (int i = 2; i <= n; i++) {
		if (p[i].first - r > 1) {
			cout << -1;
			return 0;
		}
		r = max(r, p[i].second);
	}

	if (r < k) {
		cout << -1;
		return 0;
	}

	if (dfs(1)) {
		cout << 1;
		return 0;
	}

	cout << 2;
	return 0;
}