#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct STree {
	int val, upd, mxc;
};

vector<STree> tree;
int cnt;

inline void recalc(int v, int l, int r) {
	int m = (l + r) / 2;
	tree[v].val = tree[v * 2 + 1].val + tree[v * 2 + 2].val;
	tree[v].mxc = tree[v * 2 + 2].mxc + (tree[v * 2 + 2].mxc == r - m ? tree[v * 2 + 1].mxc : 0);
}

inline void push(int v, int l, int r) {
	if (l + 1 == r || tree[v].upd == -1) return;

	int m = (l + r) / 2;

	tree[v * 2 + 1].val = (m - l) * tree[v].upd;
	tree[v * 2 + 1].upd = tree[v].upd;
	tree[v * 2 + 1].mxc = (tree[v].upd == cnt ? m - l : 0);
	tree[v * 2 + 2].val = (r - m) * tree[v].upd;
	tree[v * 2 + 2].upd = tree[v].upd;
	tree[v * 2 + 2].mxc = (tree[v].upd == cnt ? r - m : 0);

	tree[v].upd = -1;
	recalc(v, l, r);
}

void update(int v, int l, int r, int ql, int qr, int x) {
	if (ql >= r || l >= qr) return;

	push(v, l, r);

	if (ql <= l && r <= qr) {
		tree[v].val = (r - l) * x;
		tree[v].upd = x;
		tree[v].mxc = (x == cnt ? r - l : 0);
		return;
	}

	int m = (l + r) / 2;

	update(v * 2 + 1, l, m, ql, qr, x);
	update(v * 2 + 2, m, r, ql, qr, x);

	recalc(v, l, r);
}

int getVal(int v, int l, int r, int ind) {
	if (l + 1 == r) return tree[v].val;

	push(v, l, r);

	int m = (l + r) / 2;

	if (ind < m) {
		return getVal(v * 2 + 1, l, m, ind);
	} else {
		return getVal(v * 2 + 2, m, r, ind);
	}
}

int getC(int v, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr) return 0;

	push(v, l, r);

	if (ql <= l && r <= qr) return tree[v].mxc;

	int m = (l + r) / 2;

	int rightC = getC(v * 2 + 2, m, r, ql, qr);

	return rightC + (rightC == max(0, min(r, qr) - m) ? getC(v * 2 + 1, l, m, ql, qr) : 0);
}

int n, mxl = 0;
vector<int> a;

inline bool check() {
	tree.assign(mxl * 4, {0, -1, 0});
	// update(0, 0, mxl, 0, mxl, 0);
	int right = 0;

	for (int i = 0; i < n; i++) {
		if (getVal(0, 0, mxl, a[i] - 1) == 0) {
			update(0, 0, mxl, right, a[i], 1);
			right = a[i];
		} else {
			int c = getC(0, 0, mxl, 0, a[i]);

			if (c == a[i]) return 0;

			update(0, 0, mxl, a[i] - c - 1, a[i] - c, getVal(0, 0, mxl, a[i] - c - 1) + 1);

			update(0, 0, mxl, a[i] - c, a[i], 1);
			update(0, 0, mxl, a[i], mxl, 0);
			right = a[i];
		}
	}

	return 1;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	cin >> n;

	a.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mxl = max(mxl, a[i]);
	}

	tree.resize(mxl * 4, {0, -1, 0});

	// cnt = 2;
	// cout << check() << "\n";

	int l = 0, r = n + 1;

	while (r - l > 1) {
		int m = (l + r) / 2;
		cnt = m;

		if (check()) {
			r = m;
		} else {
			l = m;
		}
	}

	cout << r << "\n";

	return 0;
}
