#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Segment {
	ll l, r, p;
};

struct Event {
	ll x, t, c;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	ll n, k;
	cin >> n >> k;

	vector<ll> xs(2, 1);
	xs[1] = k;
	vector<Segment> a(n);

	for (ll i = 0; i < n; i++) {
		ll l, r, p;
		cin >> l >> r >> p;

		xs.push_back(l);
		xs.push_back(r);
		xs.push_back(r + 1);

		a[i] = {l, r, p};
	}

	ll ans = INF;

	for (ll i = 0; i < (1 << n); i++) {
		vector<Event> events;
		bool g1 = 0, g2 = 0;

		for (ll j = 0; j < n; j++) {
			if ((i >> j) & 1) {
				g1 |= (a[j].l == 1);
				g2 |= (a[j].r == k);
				events.push_back({a[j].l, -1, a[j].p});
				events.push_back({a[j].r, 1, a[j].p});
			}
		}

		sort(all(events), [](const Event &a, const Event &b) {
			return make_pair(a.x, a.t) < make_pair(b.x, b.t);
		});

		ll now = 0, p = 0, tmp = 0;
		bool bad = 0;

		for (ll i = 0; i < (ll)events.size(); i++) {
			auto e = events[i];

			now -= e.t;

			if (i && now == 1 && e.x - events[i - 1].x > 1) {
				bad = 1;
				break;
			}

			p -= e.t * e.c;
			tmp = max(tmp, p);
		}

		if (!bad && g1 && g2) ans = min(ans, tmp);
	}

	cout << (ans == INF ? -1 : ans) << "\n";
	return 0;

	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());

	for (ll i = 0; i < n; i++) {
		a[i].l = lower_bound(all(xs), a[i].l) - xs.begin() + 1;
		a[i].r = lower_bound(all(xs), a[i].r) - xs.begin() + 1;
	}

	sort(all(a), [](const Segment &a, const Segment &b) {
		return a.r < b.r;
	});

	vector<ll> dp(xs.size() + 1, INF);
	dp[0] = 0;

	for (auto t : a) {
		for (ll i = t.r; i >= t.l; i--) {
			dp[t.r] = min(dp[t.r], max(dp[i - 1], (dp[i] == INF ? 0 : dp[i]) + t.p));
		}
	}

	ll ind = lower_bound(all(xs), k) - xs.begin() + 1;

	cout << (dp[ind] == INF ? -1 : dp[ind]) << "\n";

	return 0;
}
