#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const ll INF = 2e18;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);

struct Segment {
	ll l, r, p;
};

struct Event {
	ll x, t, c;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

#ifdef _GOPEN
	freopen("/home/olymp/prjs/file.in", "r", stdin);
	freopen("/home/olymp/prjs/file.out", "w", stdout);
#endif

	ll n, k;
	cin >> n >> k;

	vector<ll> xs(2, 1);
	xs[1] = k;
	vector<Segment> a(n);

	for (ll i = 0; i < n; i++) {
		ll l, r, p;
		cin >> l >> r >> p;

		xs.push_back(l);
		xs.push_back(r);
		xs.push_back(r + 1);

		a[i] = {l, r, p};
	}

	sort(all(xs));
	xs.resize(unique(all(xs)) - xs.begin());

	for (ll i = 0; i < n; i++) {
		a[i].l = lower_bound(all(xs), a[i].l) - xs.begin() + 1;
		a[i].r = lower_bound(all(xs), a[i].r) - xs.begin() + 1;
	}

	sort(all(a), [](const Segment &a, const Segment &b) {
		return a.r < b.r;
	});

	vector<vector<pair<ll, ll> > > dp(xs.size() + 1, vector<pair<ll, ll> >(xs.size() + 1, {INF, -1LL}));
	dp[0][0] = {0, 0};

	for (auto t : a) {
		ll nowmx = dp[t.l - 1][t.l - 1].first, nowsm = t.p;
		for (int i = t.l; i <= t.r; i++) {
			if (max(dp[t.l][i].first, dp[t.l][i].second + t.p) < nowmx || (max(dp[t.l][i].first, dp[t.l][i].second + t.p) == nowmx && dp[t.l][i].second + t.p < nowsm)) {
				nowmx = max(dp[t.l][i].first, dp[t.l][i].second + t.p);
				nowsm = dp[t.l][i].second + t.p;
			}
		}

		for (int i = t.l; i <= t.r; i++) {
			dp[i][t.r] = min(dp[i][t.r], {nowmx, nowsm});
		}
	}

	ll ind = lower_bound(all(xs), k) - xs.begin() + 1;

	ll ans = INF;

	for (int i = 0; i <= ind; i++) {
		ans = min(ans, dp[i][ind].first);
	}

	cout << (ans == INF ? -1 : ans) << "\n";

	return 0;
}
