#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

#define size(a) int(a.size())

using namespace std;

struct cafe{
    int l, r;
    long long p;
};

bool operator <(cafe a, cafe b) {
    return a.l < b.l || a.l == b.l && a.r < b.r;
}

int main() {
    ios_base::sync_with_stdio(false);

    int n, k;
    cin >> n >> k;

    vector<cafe> v(n);
    vector<long long> dp(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].p;
    }

    sort(v.begin(), v.end());
    int mx_r = v[0].r;

    for (int i = 1; i < n; i++) {
        if (v[i].l > mx_r + 1) {
            cout << -1;
            return 0;
        }
        mx_r = max(mx_r, v[i].r);
    }

    if (v[0].l > 1 || mx_r < k) {
        cout << -1;
        return 0;
    }

    dp[0] = v[0].p;

    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (v[j].r >= v[i].l) {
                dp[i] = max(dp[j], v[j].p + v[i].p);
            } else if (v[j].r == v[i]. l - 1) {
                dp[i] = max(dp[j], v[i].p);
            }
        }
    }

    cout << dp[n - 1];
 }
