#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>

#define size(a) ll(a.size())

using namespace std;

typedef long long ll;

struct cafe{
    ll l, r, p;
};

bool operator <(cafe a, cafe b) {
    return a.l < b.l || a.l == b.l && a.r < b.r;
}

ll pow(ll x, ll p) {
    ll answ = 1;

    for (ll i = 0; i < p; i++) {
        answ *= x;
    }
    return answ;
}

int main() {
    ios_base::sync_with_stdio(false);

    ll n, k;
    cin >> n >> k;

    vector<cafe> v(n);
    vector<ll> dp(n, 0);
    bool all_p1 = true;

    for (ll i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r >> v[i].p;
        if (v[i].p != 1) all_p1 = false;
    }

    sort(v.begin(), v.end());

    ll mx_r = v[0].r;

    if (n <= 10) {
        ll mn = 1e18 + 239;
        for (ll i = 0; i < pow(2, n); i++) {
            vector<pair<ll,pair<ll,ll>>> events;
            ll mn_l = 1e18 + 239, mx_r = -1;
            for (ll j = 0; j < n; j++) {
                if ((i >> j) & 1) {
                    if (v[j].l > mx_r + 1 && mx_r != -1) {
                        mn_l = 0;
                    }
                    mn_l = min(mn_l, v[j].l);
                    mx_r = max(mx_r, v[j].r);

                    events.push_back({v[j].l, {0, v[j].p}});
                    events.push_back({v[j].r, {1, v[j].p}});
                }
            }
            sort(events.begin(), events.end());
            ll balance = 0;
            ll mx = 0;
            for (ll j = 0; j < size(events); j++) {
                balance += events[j].second.second * (events[j].second.first ? -1 : 1);
                //cout << mx << endl;
                mx = max(mx, balance);
            }
            //cout << endl;
            if (mx_r >= k && mn_l == 1)
                mn = min(mn, mx);
        }
        cout << (mn == 1e18 + 239 ? -1 : mn);
        return 0;
    } else if (all_p1) {
        for (int i = 1; i < n; i++) {
            if (v[i].l > mx_r + 1) {
                cout << -1;
                return 0;
            }
            mx_r = max(mx_r, v[i].r);
        }
        if (v[0].l > 1 || mx_r < k) {
            cout << -1;
            return 0;
        }

        dp[0] = v[0].p;

        for (int i = 1; i < size(dp); i++)
            dp[i] = 1e18 + 239;

        for (int i = 1; i < n; i++) {
            for (int j = 0; j < i; j++) {
                if (v[j].r >= v[i].l) {
                    dp[i] = min(dp[i], max(dp[j], 2LL));
                } else if (v[j].r == v[i]. l - 1) {
                    dp[i] = min(dp[i], dp[j]);
                }
            }
        }
    }

    for (int i = 1; i < n; i++) {
        if (v[i].l > mx_r + 1) {
            cout << -1;
            return 0;
        }
        mx_r = max(mx_r, v[i].r);
    }

    if (v[0].l > 1 || mx_r < k) {
        cout << -1;
        return 0;
    }

    dp[0] = v[0].p;

    for (int i = 1; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (v[j].r >= v[i].l) {
                dp[i] = max(dp[j], v[j].p + v[i].p);
            } else if (v[j].r == v[i]. l - 1) {
                dp[i] = max(dp[j], v[i].p);
            }
        }
    }

    cout << dp[n - 1];
 }
