#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back
#define int ll

const int INF = 1e9 + 10;

struct elem {
    int x, tp, id, p;
    elem() {}
    elem(int x, int tp, int id, int p): x(x), tp(tp), id(id), p(p) {}
};
const bool operator <(const elem a, const elem b) {
    if (a.x != b.x) { return a.x < b.x; }
    if (a.tp != b.tp) { return a.tp < b.tp; }
    return a.id < b.id;
}

struct seg_tree {
    vec<int> a;
    int N;

    seg_tree(int n) {
        for (N = 1; N < n; N <<= 1) {}
        a.resize(N << 1, INF);
    }
    void _update(int v, int val) {
        a[v] = val;
        while (v > 0) {
            v /= 2;
            a[v] = min(a[v * 2], a[v * 2 + 1]);
        }
    }
    void update(int ind, int val) {
        _update(ind + N, val);
    }
    int _query(int v, int L, int R, int l, int r) {
        if (l > r) { return INF; }
        if (l == L && r == R) { return a[v]; }

        int mid = (L + R) / 2;
        return min(_query(v * 2, L, mid, l, min(mid, r)),
                   _query(v * 2 + 1, mid + 1, R, max(mid + 1, l), r));
    }
    int query(int l, int r) { return _query(1, 0, N - 1, l, r); }
    void print() {
        for (int k = N; k < N * 2; k++) { cout << a[k] << " "; }
        cout << '\n';
    }
};

struct seg {
    int l, r, p;
    seg() {}
    void read() { cin >> l >> r >> p; }
};
bool operator <(const seg a, const seg b) {
    if (a.l != b.l) { return a.l < b.l; }
    return a.r < b.r;
}


main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vec<seg> segs(n);
    for (int k = 0; k < n; k++) { segs[k].read(); }
    sort(segs.begin(), segs.end());

    vec<int> dp(n, INF);
    if (segs[0].l != 1) { cout << -1; return 0; }
    if (segs[n - 1].r != m) { cout << -1; return 0; }

    dp[0] = segs[0].p;
    for (int k = 1; k < n; k++) {
        if (segs[k].l == 1) { dp[k] = segs[k].p; }
        for (int i = 0; i < k; i++) {
            if (dp[i] == INF) { continue; }
            if (segs[i].r + 1 == segs[k].l) { dp[k] = min(dp[k], max(dp[i], segs[k].p)); }
            else if (segs[i].r >= segs[k].l) { dp[k] = min(dp[k], dp[i] + segs[k].p); }
        }
    }
    int res = INF;
    for (int k = 0; k < n; k++) {
        if (segs[k].r == m) { res = min(res, dp[k]); }
    }
    cout << (res == INF ? -1 : res);
    return 0;
}
