#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Query
{
    int l, r;
    ll p;
};

Query query[maxN];

vector<pair<int, int>> event;
vector<int> coords;

map<int, vector<Query>> qarr;
map<int, int> dp;

namespace Kek
{
    const int maxN = 3005;

    vector<int> coords;

    bool dp[maxN][maxN];
    bool pref[maxN][maxN];
    int check(ll P, int n, int K)
    {
        for(int i = 0; i <= n; i++) for(int j = 0; j <= n; j++) dp[i][j] = 0;
        for(int i = 0; i <= n; i++) for(int j = 0; j <= n; j++) pref[i][j] = 0;

        for(int i = 1; i <= n; i++)
        {
            if(query[i].p > P) continue;

            int ind = lower_bound(query, query + n, query[i].l, [](Query q, int l){return q.r < l;}) - query;

            dp[i][0] = (query[i].l == 1);
            for(int k = 1; k < i; k++)
            {
                if(query[k].r < query[i].l - 1) continue;
                if(query[k].r == query[i].l - 1)
                {
                    dp[i][k] = pref[k][k];
                    continue;
                }
                if(query[i].p + query[k].p > P) continue;

                dp[i][k] = pref[k][ind];
            }

            pref[i][0] = 0;
            for(int j = 1; j <= i; j++) pref[i][j] = pref[i][j - 1] || dp[i][j - 1];
        }

        for(int i = 1; i <= n; i++)
        {
            if(query[i].r == K && pref[i][i])
            {
                return 1;
            }
        }
        return 0;
    }
}

int main()
{
    //freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    if(n <= 3000)
    {
        query[0].l = 0;
        query[0].r = 0;
        query[0].p = 0;
        for(int i = 1; i <= n; i++)
        {
            cin >> query[i].l >> query[i].r >> query[i].p;
        }

        sort(query, query + n + 1, [](Query q1, Query q2){return q1.r < q2.r;});

        ll l = 0, r = INF;
        while(r - l > 1)
        {
            ll m = (l + r) / 2;
            if(Kek::check(m, n, k)) r = m;
            else l = m;
        }

        if(r != INF) cout << r << endl;
        else cout << -1 << endl;

        return 0;
    }

    k++;

    for(int i = 0; i < n; i++)
    {
        cin >> query[i].l >> query[i].r >> query[i].p;

        event.push_back(make_pair(query[i].l, 1));
        event.push_back(make_pair(query[i].r + 1, -1));

        qarr[query[i].l].push_back(query[i]);
    }


    sort(event.begin(), event.end());

    int ok = 1;
    int cnt = 0;
    for(int i = 0; i < event.size();)
    {
        int j = i;
        while(j < event.size() && event[i].first == event[j].first) j++;

        for(int k = i; k < j; k++) cnt += event[k].second;

        if(cnt == 0 && event[i].first < k)
        {
            ok = 0;
        }

        i = j;
    }

    if(event.front().first > 1) ok = 0;
    if(event.back().first < k) ok = 0;

    dp[1] = 1;
    for(auto& it : qarr)
    {
        if(!dp[it.first]) continue;

        for(auto& q : it.second)
        {
            dp[q.r + 1] = 1;
        }
    }

    if(dp[k]) cout << 1 << endl;
    else if(ok) cout << 2 << endl;
    else cout << -1 << endl;





    return 0;
}
