  {$MODE FPC}
  {$OPTIMIZATION ON}
  Uses Math;
  const MAX_N = 100000;
  //             12345
        MAX_RANGE = 1000000000;
		//           123456789
        MAX_TREE_SIZE = 100000 * 32;
		//               12345
  
  
  
  var MAX_VAL : LongInt;
  
  // Segement Tree
  
  
  type tNode = record
    LSon , RSon , L , R : LongInt;
	Lazy , Clr : LongInt;
	NOT_MAX : LongInt;
  end;
  
  var T : array [ 1 .. MAX_TREE_SIZE ] of tNode;
      tt : LongInt;
  
  function NewNode ( L , R : LongInt ) : LongInt;
  begin
    inc ( tt  ) ; 
	T[tt].L := L ;
	T[tt].R := R;
	T[tt].NOT_MAX := -1;
	T[tt].LSon := 0 ; 
	T[tt].RSon := 0;
	T[tt].Lazy := 0;
	T[tt].Clr := 0;
	exit ( tt ) ; 
  end;
  
  function Get_last_not_max( v : LongInt ) : LongInt;
  begin
    if ( v = 0 ) then
	  exit ( -1 ) 
	else
	  exit ( T[v].NOT_MAX );
  end;
  
  procedure Push ( v : LongInt ) ; 
    var med : LongInt;
  begin
    
	if ( T[v].L = T[v].R ) then
	begin
	  
	  T[v].Clr := T[v].Lazy;
	  if ( T[v].Clr <> MAX_VAL ) then
	    T[v].NOT_MAX := T[v].L
	  else
	    T[v].NOT_MAX := -1;
	  
	end
	else
	begin
	  
	  med := ( T[v].L + T[v].R ) div 2 ;
	  
	  if ( T[v].LSon = 0 ) then
	    T[v].LSon := NewNode ( T[v].L , med ) ; 
	  if ( T[v].RSon = 0 ) then 
	   T[v].RSon := NewNode ( med+1 , T[v].R );
	  
	  T[ T[v].LSon ].Lazy := T[v].Lazy;
	  T[ T[v].RSon ].Lazy := T[v].Lazy;
	  if ( T[v].Lazy <> MAX_VAL ) then
	  begin
	    T [ T[v].LSon ].NOT_MAX := med;
		T [ T[v].RSon ].NOT_MAX := T[v].R;
	  end;
	  
      T[v].NOT_MAX := Max ( Get_last_not_max(T[v].LSon) , Get_last_not_max(T[v].RSon) );
	  
	end;
	
	T[v].Lazy := 0;
	
	
  end;
  
  procedure Cut ( v , lb , rb : LongInt ) ; 
    var med : LongInt;
  begin
    
    if ( T[v].Lazy > 0 ) then
	  Push ( V ) ; 
    
	med := ( T[v].L + T[v].R ) div 2;
	
	if ( T[v].LSon <> 0 ) then
	begin
	  if ( LB <= T[ T[v].LSon ].L ) and ( T[ T[v].LSon ].R <= RB ) then
	    T[v].LSon := 0
	  else if ( LB <= med ) then
	    Cut ( T[v].LSon , lb ,rb );
	end;
	if ( T[v].RSon <> 0 ) then
	begin
	  if ( LB <= T[ T[v].RSon ].L ) and ( T[ T[v].RSon ].R <= RB ) then
	    T[v].RSon := 0 
	  else if ( med+1 <= RB ) then
	    Cut ( T[v].RSon , lb , rb ) ; 
	end;
	
	T[v].NOT_MAX := Max ( Get_last_not_max( T[v].LSon ) , Get_last_not_max(T[v].RSon ) );
	
  end;
  
  procedure Splay ( v , lb , rb , clr : LongInt ) ; 
    var med : LongInt;
  begin
	
	if ( lb <= T[v].L ) and ( T[v].R <= RB ) then
	begin
	   // No need to push cuz we'll overwrite it anyway
	  T[v].Lazy := Clr;
	  
	  if ( clr <> MAX_VAL ) then
	    T[v].NOT_MAX := T[v].R
	  else
	    T[v].NOT_MAX := -1;
	  
	end
	else
	begin
	  if ( T[v].Lazy > 0 ) then
	    Push ( v ) ; 
	  
	  med := ( T[v].L + T[v].R ) div 2 ; 
	  
	  if ( lb <= med ) then
	  begin
	    if ( T[v].LSon = 0 ) then
		  T[v].LSon := NewNode ( T[v].L , med ) ; 
		Splay ( T[v].LSon , lb , rb , clr ) ; 
	  end;
	  
	  if ( med+1 <= rb ) then
	  begin
	    if ( T[v].RSon = 0 ) then
		  T[v].RSOn := NewNode ( med+1 , T[v].R ) ; 
		Splay ( T[v].RSon , lb , rb , clr ) ; 
	  end;
	  
	  T[v].NOT_MAX := Max ( Get_last_not_max(T[v].LSon) , Get_last_not_max(T[v].RSon) );
	  
	end;
	
  end;
  
  procedure Modify ( v , x , delta : LongInt )  ;
    var med : LongInt;
  begin
    if ( T[v].Lazy > 0 ) then
	  Push ( v ) ; 
	  
    if ( T[v].L = T[v].R ) then
	begin
	  
	  T[v].Clr += Delta;
	  if ( T[v].Clr = MAX_VAL ) then
	    T[v].NOT_MAX := -1;
	  
	end
	else
	begin
	  med := ( T[v].L + T[v].R ) div 2 ; 
	  
	  if ( x <= med ) then
	  begin
	    if ( T[v].LSon = 0 ) then
		  T[v].LSon := NewNode ( T[v].L , med ) ; 
		Modify ( T[v].LSon , x , delta ) ; 
	  end
	  else
	  begin
	    if ( T[v].RSon = 0 ) then
		  T[v].RSon := NewNode ( med+1 , T[v].R ) ; 
		Modify ( T[v].RSon , x , delta ) ; 
	  end;
	  
	  
	  T[v].NOT_MAX := Max ( Get_last_not_max(T[v].LSon) , Get_last_not_max(T[v].RSon) );
	end;
  end;
  
  // End of Segment Tree
  
  

  var N : LongInt;
      A : array [ 1 .. MAX_N ] of LongInt; 
  
  
  function Can ( x : LongInt ) : Boolean;
    var root : LongInt;
	    tmp , i : LongInt;
  begin
    tt := 0 ;
	root := NewNode ( 1 , MAX_RANGE );
	MAX_VAL := x;
	
	
	
	Splay ( root , 1 , A[1] , 1 );
	
	for i := 2 to N do
	begin
	  
	  
	  if ( A[i-1] < A[i] ) then
	    Splay ( root , A[i-1] + 1 , A[i] , 1 )
	  else
	  begin
	    
		if ( A[i-1] > A[i] ) then
		  Cut ( root , A[i] +1 , A[i-1] );
		
		tmp := Get_last_not_max(root);
		
		if ( tmp = -1 ) then
		  exit ( false ) ; 
		  
		Modify ( root , tmp , +1 );
		if ( tmp <> A[i] ) then
		  Splay ( root , tmp+1 , A[i] , 1 );
		
		
	  end;
	  
	  
	end;
    
	
	exit ( true ) ; 
	
  end;
  
	  
  var L , R , med : LongINt;
      i : LongInt;
	  OneDeal : boolean;
begin
  readLn ( N ) ; 
  for i := 1 to N do
    read ( A[i] ) ; 
	
  
  OneDeal := true;
  for i := 1 to N-1 do
    if ( A[i] >= A[i+1] ) then
	  OneDeal := false;
	  
  if ( OneDeal ) then
  begin
    writeLn ( 1 ) ; 
	halt();
  end;
  
  
  L := 1 ; 
  R := N;
  while ( L + 1 < R ) do
  begin
    med := ( L + R ) div 2 ; 
    if ( Can(med) ) then
	  R := med
	else
	  L := med;
  end;
  
  writeLn ( R ) ; 

  
  
end.