#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <assert.h>
#include <set>
#include <iomanip>
using namespace std;

const int len = 250000;
const int none = 1 << 30;
int x;
int a[len];
int t[len * 4], g[len * 4], s[len * 4];

void build(int v, int l, int r, int f) {
	s[v] = none;
	if (l == r - 1) {
		t[v] = 0;
		g[v] = l;
		if (t[v] == f - 1)
			g[v] = -1;
		return;
	}
	int m = l + r >> 1;
	build(2 * v + 1, l, m, f);
	build(2 * v + 2, m, r, f);
	g[v] = max(g[2 * v + 1], g[2 * v + 2]);
}

void push(int v, int l, int r, int f) {
	if (s[v] != none) {
		t[v] = s[v];
		s[2 * v + 1] = s[2 * v + 2] = s[v];
		//g[v] = r - 1;
		//if (t[v] >= f - 1)
		//	g[v] = -1;
		s[v] = none;
	}
	if (l == r - 1) {
		if (t[v] == f - 1)
			g[v] = -1;
		else
			g[v] = l;
	}
}

void add(int v, int l, int r, int pos, int f) {
	push(v, l, r, f);
	if (l == r - 1) {
		t[v]++;
		g[v] = l;
		if (t[v] >= f - 1) {
			g[v] = -1;
		}
		return;
	}
	int m = l + r >> 1;
	if (pos < m)
		add(2 * v + 1, l, m, pos, f);
	else
		add(2 * v + 2, m, r, pos, f);
	g[v] = max(g[2 * v + 1], g[2 * v + 2]);
}

int gp(int v, int l, int r, int from, int to, int f) {
	push(v, l, r, f);
	if (from <= l && r <= to)
		return g[v];
	if (from >= r || to <= l)
		return -1;
	int m = l + r >> 1;
	return max(gp(2 * v + 1, l, m, from, to, f),
		gp(2 * v + 2, m, r, from, to, f));
}

void st(int v, int l, int r, int from, int to, int f) {
	if (from <= l && r <= to) {
		s[v] = 0;
		push(v, l, r, f);
		return;
	}
	if (from >= r || to <= l)
		return;
	push(v, l, r, f);
	st(2 * v + 1, l, l + r >> 1, from, to, f);
	st(2 * v + 2, l + r >> 1, r, from, to, f);
	g[v] = max(g[2 * v + 1], g[2 * v + 2]);
}

bool can(int f) {
	int l = 200001;
	build(0, 0, l, f);

	for (int i = 1; i < x; i++) {
		if (a[i - 1] < a[i]) {
			st(0, 0, l, a[i - 1], l, f);
		}
		else {
			int pos = gp(0, 0, l, 0, a[i], f);
			if (pos < 0 || pos >= a[i])
				return false;
			add(0, 0, l, pos, f);
			st(0, 0, l, pos + 1, l, f);
		}
	}
	return true;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> x;
	for (int i = 0; i < x; i++)
		cin >> a[i];
	int l = 0, r = x;

	while (r - l > 1) {
		int m = l + r >> 1;
		if (can(m))
			r = m;
		else
			l = m;
	}
	cout << r;
}