#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <vector>


typedef long long ll;
typedef double dl;

using namespace std;

struct at
{
	ll l;
	ll r;
	ll p;
};



bool comp(at a, at b)
{
	if (a.l == b.l)
		return a.r < b.r;

	return a.l < b.l;
}

ll f(ll l1, ll r1, ll l2, ll r2)
{
	ll r = min(r1, r2);
	ll l = max(l1, l2);

	return r - l + 1;
}

vector<vector<ll>> d, pred;
vector<at> vec;


ll ans(ll i, ll j)
{
	ll maxx = max(vec[i].p, vec[j].p);

	ll p = pred[i][j];

	if (pred[i][j] != -1)
	{
		maxx = max(maxx, max(ans(i, p), ans(p, j)));
	}
	return maxx;
}

int main()
{
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ll n, k;
	cin >> n >> k;

	vec.resize(n);

	vector<ll> st, fn;

	st.reserve(n);
	fn.reserve(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> vec[i].l >> vec[i].r >> vec[i].p;
		--vec[i].l;
		--vec[i].r;

		if (vec[i].l == 0)
			st.push_back(i);

		if (vec[i].r == k -1)
			fn.push_back(i);
	}

	//sort(vec.begin(), vec.end(), comp);
	
	d.resize(n, vector<ll>(n, 1e18));
	pred.resize(n, vector<ll>(n, -1));

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			if (i == j)
			{
				d[i][j] = 0;//vec[i].p;
				d[j][i] = 0;//vec[i].p;
			}

			if (d[i][j] == 1e18)
			{
				ll per = f(vec[i].l, vec[i].r, vec[j].l, vec[j].r);

				if (per > 0)
				{
					d[i][j] = per * (vec[i].p + vec[j].p);
					d[j][i] = per * (vec[i].p + vec[j].p);
				}
				else if (per == 0)
				{
					d[i][j] = per * (vec[i].p + vec[j].p);
					d[j][i] = per * (vec[i].p + vec[j].p);
				}
			}
		}
	}

	for (int k = 0; k < n; ++k)
	{
		for (int i = 0; i < n; ++i)
		{
			for (int j = i; j < n; ++j)
			{
				if (d[i][j] > d[i][k] + d[k][j])
				{
					d[i][j] = d[i][k] + d[k][j];
					d[j][i] = d[i][k] + d[k][j];
					pred[i][j] = k;
					pred[j][i] = k;
				}
			}
		}
	}

	ll minn = 1e18;

	for (int i = 0; i < st.size(); ++i)
	{
		for (int j = 0; j < fn.size(); ++j)
		{
			ll res = d[st[i]][fn[j]];

			ll ii = st[i], jj = fn[j];

			res = max(res, ans(ii, jj));

			minn = min(minn, res);
		}
	}

	if (minn == 1e18)
		cout << -1 << endl;
	else
		cout << max((ll)1, minn) << endl;
	return 0;
}
