#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mk make_pair
#define eps 1lle-8
#define all(x) x.begin(), x.end()
#define inf 2e9
#define linf 8e18
#define Size 100005

vector<int> V;
int E[Size];
int D[Size];
bool used[Size];

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif

	int N;
	cin >> N;


	unordered_set<int> KS;
	for (int i = 0; i < N; i++) {
		int a;
		scanf("%d", &a);
		V.push_back(a);
		KS.insert(a);
	}

	if (N == 1 || KS.size() == N) {
		cout << "1\n";
		return 0;
	}

	set<pair<int, int>> S;

	for (int i = V.size() - 1; i >= 0; i--) {

		auto it = S.upper_bound(mk(V[i], -1));
		if (it == S.end())
			E[i] = -1;
		else {
			if (it->first == V[i])
				E[i] = it->second;
			else {
				if (it == S.begin())
					E[i] = -1;
				else {
					it--;
					E[i] = it->second;
				}
			}
		}

		S.insert(mk(V[i], i));
	}

	vector<pair<int, int>> Ans;

	int del = 0;
	for (int i = 0; i < N; i++) {
		del = (i ? D[i - 1] : 0);
		if (!used[i]) {
			int mn = inf;
			int cnt = 0;
			int cur = i;
			while (cur != -1 && !used[cur]) {
				mn = min(mn, V[cur]);
				cnt++;
				cur = E[cur];
			}

			cur = i;
			while (cur != -1 && !used[cur]) {
				D[cur] = mn;
				cur = E[cur];
				used[cur] = 1;
			}

			Ans.push_back(mk(mn - del, cnt));
		}
	}

	ll ans = 2;
	for (int i = 0; i < Ans.size(); i++) {
		ll x = ll(ceil(1.0 * log(1.0 * Ans[i].second) / log(1.0 * Ans[i].first)));
		ans = max(ans, x);
	}

	cout << ans << "\n";


	return 0;
}