#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mk make_pair
#define eps 1lle-8
#define all(x) x.begin(), x.end()
#define inf 2e9
#define nl nullptr
#define linf 8e18
#define Size 100005

struct treap {
	treap *l, *r;
	int x, y;
	int in;
	int minin;
	treap(int x, int in) : x(x), in(in), minin(in), l(nl), r(nl), y(rand()) {}
};

void refresh(treap *t) {
	t->minin = t->in;
	if (t->l)
		t->minin = min(t->minin, t->l->minin);
	if (t->r)
		t->minin = min(t->minin, t->r->minin);
}

pair<treap *, treap *> splitx(treap *t, int x) {
	if (!t)
		return mk(t, t);
	if (x < t->x) {
		auto h = splitx(t->l, x);
		t->l = h.second;
		refresh(t);
		return mk(h.first, t);
	}
	else {
		auto h = splitx(t->r, x);
		t->r = h.first;
		refresh(t);
		return mk(t, h.second);
	}
}

treap *merge(treap *a, treap *b) {
	if (!a)
		return b;
	if (!b)
		return a;
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		refresh(a);
		return a;
	}
	else {
		b->l = merge(a, b->l);
		refresh(b);
		return b;
	}
}

vector<int> V;
int E[Size];
int D[Size];
bool used[Size];

ll pw(ll k, ll p) {
	if (!p)
		return 1;
	if (p % 2)
		return k * pw(k, p - 1);
	ll s = pw(k, p / 2);
	return s * s;
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin); freopen("out.txt", "w", stdout);
#endif

	int N;
	cin >> N;

	treap *t = nl;
	vector<pair<int, int>> order;
	unordered_set<int> KS;
	for (int i = 0; i < N; i++) {
		int a;
		scanf("%d", &a);
		V.push_back(a);
		order.push_back(mk(a, i));
		KS.insert(a);
	}

	if (N == 1 || KS.size() == N) {
		cout << "1\n";
		return 0;
	}
	sort(all(order));

	set<pair<int, int>> S;

	for (int i = V.size() - 1; i >= 0; i--) {
		auto sp = splitx(t, V[i]);

		if (!sp.first)
			E[i] = -1;
		else
			E[i] = sp.first->minin;

		t = merge(sp.first, merge(new treap(V[i], i), sp.second));
	}

	map<int, int> Ans;

	int del = 0;
	for (int j = 0; j < N; j++) {
		int i = order[j].second;
		del = (i ? D[i - 1] : 0);
		if (!used[i]) {
			int mn = inf;
			int cnt = 0;
			int cur = i;
			while (cur != -1 && !used[cur]) {
				mn = min(mn, V[cur]);
				cnt++;
				cur = E[cur];
			}
			if (cur != -1 && used[cur]) {
				Ans[V[cur]]++;
			}

			cur = i;
			while (cur != -1 && !used[cur]) {
				D[cur] = mn;
				used[cur] = 1;
				cur = E[cur];
			}

			//Ans.push_back(mk(mn - del, cnt));
			Ans[mn - del] += cnt;
		}
	}

	ll ans = 2;
	for (auto el : Ans) {
		ll sz = el.first;
		ll cnt = el.second;
		ll l = 0, r = 64;
		while (r - l > 1) {
			ll m = l + r >> 1;
			if (pw(m, sz) >= cnt)
				r = m;
			else
				l = m;
		}

		//ll x = ll(ceil(1.0 * log(1.0 * Ans[i].second) / log(1.0 * Ans[i].first)));
		ans = max(ans, r);
	}

	cout << ans << "\n";


	return 0;
}