#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <random>

using namespace std;

const int INF = 2e9 + 7;


struct node {
	int x, y;
	multiset <int> ra;
	int mini;
	node* L;
	node* R;
	node() {}
	node(int x, int dob) : y(rand()), x(x), L(NULL), R(NULL) {
		ra.insert(dob);
		mini = dob;
	}
};

node* root = new node(INF, INF);

void update(node* T) {
	if(!T) {
		return;
	}
	if (T->ra.size() != 0) {
		T->mini = (*T->ra.begin());
	}
	else {
		T->mini = INF;
	}
	if (T->L) {
		T->mini = min(T->mini, T->L->mini);
	}
	if (T->R) {
		T->mini = min(T->mini, T->R->mini);
	}
}

node *merge(node* L, node* R) {
	if (!L) {
		return R;
	}
	if (!R) {
		return L;
	}
	if (L->y > R->y) {
		L->R = merge(L->R, R);
		update(L);
		return L;
	}
	else {
		R->L = merge(L, R->L);
		update(R);
		return R;
	}
}

pair <node*, node*> split(node* T, long long x) {
	if (!T) {
		return make_pair(T, T);
	}
	pair <node*, node*> t;
	if (T->x >= x) {
		t = split(T->L, x);
		T->L = t.second;
		update(T);
		return make_pair(t.first, T);
	}
	else {
		t = split(T->R, x);
		T->R = t.first;
		update(T);
		return make_pair(T, t.second);
	}
}



set <int> q;
pair < pair <int, int> , int> ot[100500];
int n;
int k;

void add(int cost, int dob) {
	pair <node*, node*> t1 = split(root, cost);
	pair <node*, node*> t2 = split(t1.second, cost + 1);
	if (!t2.first) {
		t2.first = new node(cost, dob);
	}
	else {
		t2.first->ra.insert(dob);
		update(t2.first);
	}
	t1.second = merge(t2.first, t2.second);
	root = merge(t1.first, t1.second);
}

void deli(int cost, int dob) {
	pair <node*, node*> t1 = split(root, cost);
	pair <node*, node*> t2 = split(t1.second, cost + 1);
	t2.first->ra.erase(t2.first->ra.find(dob));
	update(t2.first);
	t1.second = merge(t2.first, t2.second);
	root = merge(t1.first, t1.second);
}

int takemin(int cost) {
	pair <node*, node*> t1 = split(root, cost + 1);
	int ans = INF;
	if (t1.first) {
		ans = t1.first->mini;
	}
	root = merge(t1.first, t1.second);
	return ans;
}

multiset < pair <int, int> > delite;
multiset < pair <int, pair <int, int> > > dobav;

bool pr(int m) {
	q.clear();
	delite.clear();
	dobav.clear();
	q.insert(0);
	root = new node(INF, INF);
	for (int i = 1; i <= n; i++) {
		if (ot[i].second > m) {
			continue;
		}
		while (dobav.size() != 0 && dobav.begin()->first <= ot[i].first.first) {
			add(dobav.begin()->second.first, dobav.begin()->second.second);
			dobav.erase(dobav.begin());
		}
		while (delite.size() != 0 && delite.begin()->first < ot[i].first.first) {
			deli(delite.begin()->second, delite.begin()->first);
			delite.erase(delite.begin());
		}
		

		int mini = takemin(m - ot[i].second);
		if (mini <= ot[i].first.second) {
			q.insert(ot[i].first.second);
			dobav.insert(make_pair(mini + 1, make_pair(ot[i].second, ot[i].first.second)));
			delite.insert(make_pair(ot[i].first.second, ot[i].second));
		}



		if (q.find(ot[i].first.first - 1) != q.end()) {
			add(ot[i].second, ot[i].first.second);
			delite.insert(make_pair(ot[i].first.second, ot[i].second));
			q.insert(ot[i].first.second);
		}
	}
	return (q.find(k) != q.end());

}

int main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	cin >> n >> k;
	for (int i = 1; i <= n; i++) {
		cin >> ot[i].first.first >> ot[i].first.second >> ot[i].second;
	}
	sort(ot + 1, ot + n + 1);
	q.insert(0);
	for (int i = 1; i <= n; i++) {
		set <int>::iterator it = q.end();
		it--;
		if ((*it) >= ot[i].first.first - 1) {
			q.insert(ot[i].first.second);
		}
	}
	if (q.find(k) == q.end()) {
		cout << -1;
		return 0;
	}

	int l = 0, r = INF;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (pr(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r;
}
	

