// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
	os << "{";
	for (int i = 0; i < (int)v.size(); i++) {
		if (i != 0) {
			os << ", ";
		}
		os << v[i];
	}
	return os << "}";
}

struct StackNaive {
	private:
		vector<int> stk;
	public:
		inline void clear() {
			stk.clear();
		}
		
		inline void resize(int newSz) {
			stk.resize(newSz, 0);
		}
		
		inline bool empty() {
			return stk.empty();
		}
		
		inline int back() {
			return stk.back();
		}
		
		inline void popBack() {
			stk.pop_back();
		}
		
		inline void incBack() {
			stk.back()++;
		}
		
		StackNaive() {
		}
};

signed main() {
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	vector<int> v(n);
	StackNaive stk;
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	auto ok = [&](int knt) -> bool {
		stk.clear();
		stk.resize(v[0]);
		for (int i = 1; i < n; i++) {
			if (v[i-1] >= v[i]) {
				stk.resize(v[i]);
				while (!stk.empty() && stk.back() == knt-1) {
					stk.popBack();
				}
				if (stk.empty()) {
					return false;
				} else {
					stk.incBack();
				}
			}
			stk.resize(v[i]);
		}
		return true;
	};
	int l = 1, r = n;
	while (l < r) {
		int m = (l + r) / 2;
		if (ok(m)) {
			r = m;
		} else {
			l = m+1;
		}
	};
	cout << l << endl;
	return 0;
}
