// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

template<typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
	os << "{";
	for (int i = 0; i < (int)v.size(); i++) {
		if (i != 0) {
			os << ", ";
		}
		os << v[i];
	}
	return os << "}";
}

class Stack {
	private:
		vector< pair<int, int> > vals;
		int size;
	public:
		inline void clear() {
			vals.clear();
			size = 0;
		}
		
		inline void resize(int newSz) {
			size = newSz;
			while (!vals.empty() && vals.back().first >= size) {
				vals.pop_back();
			}
		}
		
		inline bool empty() {
			return size == 0;
		}
		
		inline int back() {
			if (vals.empty() || vals.back().first != size-1) {
				return 0;
			} else {
				return vals.back().second;
			}
		}
		
		inline void popBack() {
			resize(size - 1);
		}
		
		inline void incBack() {
			if (vals.empty() || vals.back().first != size-1) {
				vals.emplace_back(size-1, 1);
			} else {
				vals.back().second++;
			}
		}
		
		Stack()
			: vals(), size(0) {
		}
};

signed main() {
	ios_base::sync_with_stdio(false);
	int n; cin >> n;
	vector<int> v(n);
	Stack stk;
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	auto ok = [&](int knt) -> bool {
		if (knt == 1) {
			for (int i = 1; i < n; i++) {
				if (v[i-1] >= v[i]) {
					return false;
				}
			}
			return true;
		}
		stk.clear();
		stk.resize(v[0]);
		for (int i = 1; i < n; i++) {
			stk.resize(v[i]);
			if (v[i-1] >= v[i]) {
				while (!stk.empty() && stk.back() == knt-1) {
					stk.popBack();
				}
				if (stk.empty()) {
					return false;
				} else {
					stk.incBack();
					stk.resize(v[i]);
				}
			}
		}
		return true;
	};
	int l = 1, r = n;
	while (l < r) {
		int m = (l + r) / 2;
		if (ok(m)) {
			r = m;
		} else {
			l = m+1;
		}
	};
	cout << l << endl;
	return 0;
}
