// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

struct Segment {
	int l, r;
	int64_t p;
	bool used;
};

inline bool operator<(Segment a, Segment b) {
	return a.p > b.p;
}

signed main() {
	ios_base::sync_with_stdio(false);
	int n, k; cin >> n >> k;
	vector<Segment> v(n);
	map<int, int> compressor;
	compressor[1] = compressor[k] = 42;
	for (int i = 0; i < n; i++) {
		cin >> v[i].l >> v[i].r >> v[i].p;
		compressor[v[i].l] = compressor[v[i].r] = 42;
		if (v[i].l != k) {
			compressor[v[i].l + 1] = 42;
		}
		if (v[i].r != 1) {
			compressor[v[i].r - 1] = 42;
		}
		v[i].used = false;
	}
	int ktr = 0;
	for (auto& it: compressor) {
		it.second = ktr++;
	}
	k = ktr;
	for (int i = 0; i < n; i++) {
		v[i].l = compressor[v[i].l];
		v[i].r = compressor[v[i].r];
	}
	sort(v.begin(), v.end());
	vector<int64_t> totP(k);
	for (int i = 0; i < n; i++) {
		for (int j = v[i].l; j <= v[i].r; j++) {
			totP[j] += v[i].p;
		}
	}
	for (int i = 0; i < k; i++) {
		if (totP[i] == 0) {
			cout << -1 << endl;
			return 0;
		}
	}
	for (;;) {
		int delId = -1;
		for (int i = 0; i < n; i++) {
			if (!v[i].used) {
				bool ok = true;
				for (int j = v[i].l; j <= v[i].r; j++) {
					if (totP[j] == v[i].p) {
						ok = false;
						break;
					}
				}
				if (ok) {
					delId = i;
					break;
				}
			}
		}
		if (delId < 0) {
			break;
		}
		for (int i = v[delId].l; i <= v[delId].r; i++) {
			totP[i] -= v[delId].p;
		}
		v[delId].used = true;
	}
	int64_t ans = 0;
	for (int i = 0; i < k; i++) {
		ans = max(ans, totP[i]);
	}
	cout << ans << endl;
	return 0;
}
