// The code was written by alex256
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <chrono>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
#include <cstdint>
#include <climits>
#include <cstdlib>
#include <functional>

using namespace std;
using namespace chrono;

int64_t gcd(int64_t a, int64_t b) {
	return b ? gcd(b, a % b) : a;
}

int64_t lcm(int64_t a, int64_t b) {
	return a / gcd(a, b) * b;
}

namespace DebugGrader {
	const int maxQuery = 6;
	
	mt19937 rnd(system_clock().now().time_since_epoch().count());
	int gameId;
	int n;
	int queryLimit;
	bool finished;
	bool inited = false;
	int64_t guessd;
	
	int init() {
		n = 10000;
		//cin >> n;
		gameId = 0;
		finished = true;
		inited = true;
		cout << "init() = " << n << endl;
		return n;
	}
	
	void newGame() {
		if (!inited) {
			cerr << "Error: not inited!" << endl;
			exit(42);			
		}
		if (!finished) {
			cerr << "Error: game was not finished!" << endl;
			exit(42);
		}
		if (gameId == n) {
			cerr << "Error: too many games!" << endl;
			exit(42);
		}
		gameId++;
		finished = false;
		queryLimit = 0;
		//cin >> guessd;
		guessd = rnd() % (int64_t)1e18 + 1;
		cout << "newGame() = " << guessd << endl;
	}
	
	pair<int64_t, int64_t> query(int64_t num) {
		if (queryLimit >= maxQuery) {
			cerr << "Error: too many queries!!!" << endl;
			exit(42);
		}
		if (!inited) {
			cerr << "Error: not inited!" << endl;
			exit(42);			
		}
		if (finished) {
			cerr << "Error: game is finished!" << endl;
			exit(42);
		}
		queryLimit++;
		int64_t knt = guessd / num;
		int64_t g = gcd(knt, guessd);
		auto res = make_pair(knt / g, guessd / g);
		cout << "query(" << num << ") = {" << res.first << ", " << res.second << "}" << endl;
		return res; 
	}
	
	void answer(int64_t res) {
		if (!inited) {
			cerr << "Error: not inited!" << endl;
			exit(42);			
		}
		if (finished) {
			cerr << "Error: game is finished!" << endl;
			exit(42);
		}
		cout << "answer(" << res << ")" << endl;
		if (res == guessd) {
			cout << "OK in " << queryLimit << " queries" << endl;
		} else {
			cout << "WA" << endl;
		}	
		finished = true;
	}
};

namespace ReleaseGrader {
	int init() {
		int n; cin >> n;
		return n;
	}
	
	void newGame() {
	}
	
	pair<int64_t, int64_t> query(int64_t num) {
		cout << "X " << num << endl;
		int64_t a, b; cin >> a >> b;
		return make_pair(a, b);
	}
	
	void answer(int64_t res) {
		cout << "N " << res << endl;
		string s; cin >> s;
		if (s != "Correct") {
			for (;;);
		}
	}
};

#define Grader ReleaseGrader

int64_t justNumbers[6] = {2, 3, 7, 17, 47, 101};

signed main() {
	ios_base::sync_with_stdio(false);
	int t = Grader::init();
	while (t--) {
		Grader::newGame();
		int64_t res = 1;
		for (int i = 0; i < 6; i++) {
			int64_t x = justNumbers[i];
			int64_t a, b; tie(a, b) = Grader::query(x);
			res = lcm(res, b);
		}
		Grader::answer(res);
	}
	return 0;
}
