#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double dbl;

#define size(s) (int) (s).size()
#define all(s) (s).begin(), (s).end()
#define rall(s) (s).rbegin(), (s).rend()

const int INF = 1e9, TMP = -2 * INF + 1;
const dbl EPS = 1e-9;

struct Seg{
	int l, r, p;
};

bool comp(Seg a, Seg b) {
	return a.l < b.l || (a.l == b.l && a.r < b.r);
}

void update(int v, int tl, int tr, int L, int R, int x, vector<int> &tree) {
	if (L > tr || tl > R) return;

	if (tl == tr) {
		tree[v] += x;
	} else {
		int mid = (tl + tr) / 2;

		update(v * 2, tl, mid, L, R, x, tree);
		update(v * 2 + 1, mid + 1, tr, L, R, x, tree);

		tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
	}
}

int get(int v, int tl, int tr, int L, int R, vector<int> &tree) {
	if (L > tr || tl > R) {
		return -INF;
	} else if (L <= tl && tr <= R) {
		return tree[v];
	} else {
		int mid = (tl + tr) / 2;

		return max(get(v * 2, tl, mid, L, R, tree), get(v * 2 + 1, mid + 1, tr, L, R, tree));
	}
}

int main() {
	ios::sync_with_stdio(0);

	cin.tie(nullptr);
	cout.tie(nullptr);
	
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	int n, k, kCompress;

	cin >> n >> k;

	n += 2;

	vector<Seg> a(n);
	vector<int> toCompress;
	unordered_map<int, int> idComp(3 * n);

	toCompress.push_back(1);
	toCompress.push_back(k);

	for (int i = 0; i < n - 2; i++) {
		cin >> a[i].l >> a[i].r >> a[i].p;

		toCompress.push_back(a[i].l);
		toCompress.push_back(a[i].r);
	}

	a[n - 2] = {0, 0, 0};
	a[n - 1] = {k, k, 0};

	sort(all(toCompress));

	toCompress.resize(unique(all(toCompress)) - toCompress.begin());

	for (int i = 0; i < size(toCompress); i++) {
		idComp[toCompress[i]] = i;
	}

	kCompress = idComp[k] + 1;

	for (int i = 0; i < n; i++) {
		a[i].l = idComp[a[i].l] + 1;
		a[i].r = idComp[a[i].r] + 1;
	}

	sort(all(a), comp);

	vector<vector<int> > dp(n, vector<int> (4 * kCompress, 0));

	for (int i = 1; i < n; i++) {
		int minId = -1, minEl = INF;

		for (int j = i - 1; j >= 0; j--) {
			if (toCompress[a[i].l - 1] <= toCompress[a[j].r - 1] + 1) {
				int val = get(1, 1, kCompress, a[i].l, a[j].r, dp[j]);

				if (val < minEl) {
					minEl = val;
					minId = j;
				}
			}
		}

		if (minId == -1) {
			cout << "-1\n";
			return 0;
		}

		dp[i] = dp[minId];

		update(1, 1, kCompress, a[i].l, a[i].r, a[i].p, dp[i]);
	}

	int ans = INF;

	for (int i = 0; i < n; i++) {
		if (get(1, 1, kCompress, kCompress, kCompress, dp[i]) > 0) {
			ans = min(ans, get(1, 1, kCompress, 1, kCompress, dp[i]));
		}
	}

	if (ans == INF) {
		cout << "-1\n";
	} else {
		cout << ans << '\n';
	}

	return 0;
}
