import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Locale;

public class ZG1 implements Runnable {

	
	public void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		Z[] z = new Z[n];
		for (int i = 0; i < n; i++) {
			z[i] = new Z(nextInt(), nextInt(), nextInt());
		}
		
		long max = 0;
		
		a: for (int i = 1; i < Math.pow(2, n); i++) {
			String s = Integer.toBinaryString(i);
			while (s.length() < n)
				s = '0' + s;
			long[] a = new long[k];
			for (int j = 0; j < s.length(); j++) {
				if (s.charAt(j) == '1') {
					for (int q = z[j].l - 1; q < z[j].r; q++) {
						a[q] += z[j].p;
					}
				}
			}
			long lmax = 0;
			for (int j = 0; j < s.length(); j++) {
				if (a[j] == 0)
					continue a;
				lmax = Math.max(lmax, a[j]);
			}
			if (max == 0 || lmax < max) {
				max = lmax;
			}
		}
		
		out.write(max + "");
	}
	
	class Z {
		int l;
		int r;
		int p;
		public Z(int l, int r, int p) {
			super();
			this.l = l;
			this.r = r;
			this.p = p;
		}
		
	}
	
	BufferedReader in;
	BufferedWriter out;
	@Override
	public void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new BufferedWriter(new OutputStreamWriter(System.out));
			solve();
			out.flush();
			out.close();
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(read());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(read());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(read());
	}
	
	String read() throws IOException {
		StringBuilder sb = new StringBuilder();
		int c = 0;
		while (c >= 0 && c <= ' ')
			c = in.read();
		if (c < 0) 
			return "";
		while (c > ' ') {
			sb.append((char) c);
			c = in.read();
		}
		return sb.toString();
	}

	public static void main(String[] args) {
		try {
			Locale.setDefault(Locale.US);
		} catch (Exception e) {
		}
		new Thread(null, new ZG1(), "1", 1 << 25).start();
	}
}
