#include <bits/stdc++.h>

using namespace std;

#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#define F first
#define S second

typedef long long ll;
typedef long double ld;

const ll INFll = (1ll << 50);

auto start_t = clock();

template<typename T>
void die(T ans)
{
    cout << ans << endl;
    cerr << "Done in " << (start_t - clock()) / ld(CLOCKS_PER_SEC) << "sec" << endl;
    exit(0);
}

int n, k;
vector<pair<pair<int, int>, int > > a;
vector<int > cmp;

class segtree
{
public:
    vector<ll > t;
    int n;

    ll query(int l, int r)
    {
        ll res = INFll;

        for (l += n, r += n; l < r; l >>= 1, r >>= 1)
        {
            if (l & 1)
                res = min(res, t[l++]);
            if (r & 1)
                res = min(res, t[--r]);
        }

        return res;
    }

    void modify(int p, ll val)
    {
        for (t[p += n] = val; p > 1; p >>= 1)
            t[p >> 1] = min(t[p], t[p ^ 1]);
    }

    segtree(int sz) : t(sz << 1, INFll), n(sz) {};
};

int getCmp(int x)
{
    return lower_bound(all(cmp), x) - cmp.begin();
}

bool comp(pair<pair<int, int>, int >& a, pair<pair<int, int>, int >& b)
{
    return a.F.S < b.F.S;
}

int main()
{
    ios_base::sync_with_stdio(0);
//    cout << fixed << setprecision(13);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> k;
    a.resize(n);
    for (auto& x: a)
        cin >> x.F.F >> x.F.S >> x.S;

    cmp.push_back(1);
    cmp.push_back(0);
    cmp.push_back(k);
    for (auto& q: a)
    {
        cmp.push_back(q.F.F);
        cmp.push_back(q.F.F - 1);
        cmp.push_back(q.F.S);
    }

    sort(all(cmp));

    cmp.erase(unique(all(cmp)), cmp.end());

    sort(all(a), comp);

    vector<ll > dp(cmp.size(), INFll);
    segtree tr(cmp.size());

    dp[0] = 0;
    tr.modify(0, 0);

    for (auto& q: a)
    {
        int l = getCmp(q.F.F);
        int r = getCmp(q.F.S);
        ll p = q.S;

//        cerr << getCmp(q.F.F - 1) << " " << r << " -> " << tr.query(getCmp(q.F.F - 1), r + 1) << endl;
        dp[r] = min(dp[r], max(dp[getCmp(q.F.F - 1)], p));
        dp[r] = min(dp[r], tr.query(l, r + 1) + p);
        tr.modify(r, dp[r]);
    }

//    for (int x: cmp)
//        cerr << x << " ";
//    cerr << endl;
//    for (ll x: dp)
//        cerr << x << " ";
//    cerr << endl;

    if (dp[getCmp(k)] == INFll)
        die(-1);

    die(dp[getCmp(k)]);

    return 0;
}
