#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <ctime>
#include <queue>
#define X first
#define Y second
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 1e9 + 4;
const ll MAXN = 400;
using namespace std;
struct ST {
	vector<ll> v;
	vector<ll> ph;
	ll n, m;
	void init(ll n, ll m) {
		v.clear();
		ph.clear();
		ph.resize(4 * n);
		v.resize(4 * n);
		this->n = n;
		this->m = m;
		return;
	}
	ll getmin(ll ver) {
		if (ph[ver] == -1)
			return 0;
		return max(ph[ver], v[ver]);
	}
	void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr <= pos || tl > pos)
			return;
		if (ph[ver]) {
			if (ph[ver] == -1)
				v[ver] = 0;
			else v[ver] = max(v[ver], ph[ver]);
			if (tl != tr - 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = ph[ver];
			}
			ph[ver] = 0;
		}
		if (tr == tl + 1 && tl == pos) {
			v[ver]++;
			return;
		}
		ll tm = (tl + tr) / 2;
		if (pos < tm)
			set(pos, val, ver * 2 + 1, tl, tm);
		else set(pos, val, ver * 2 + 2, tm, tr);
		v[ver] = min(getmin(ver * 2 + 1), getmin(ver * 2 + 2));
	}
	void setotr(ll l, ll r, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (l >= tr || r <= tl || tl >= tr || l >= r)
			return;
		if (ph[ver]) {
			if (ph[ver] == -1)
				v[ver] = 0;
			else v[ver] = max(v[ver], ph[ver]);
			if (tl != tr - 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = ph[ver];
			}
			ph[ver] = 0;
		}
		if (tl == l && tr == r) {
			v[ver] = 0;
			if (tr != tl + 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = -1;
			}
			return;
		}
		ll tm = (tr + tl) / 2;
		setotr(l, min(r, tm), val, ver * 2 + 1, tl, tm);
		setotr(max(l, tm), r, val, ver * 2 + 2, tm, tr);
		v[ver] = min(getmin(ver * 2 + 1), getmin(ver * 2 + 2));
	}
	void setotr2(ll l, ll r, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (l >= tr || r <= tl || tl >= tr || l >= r)
			return;
		if (ph[ver]) {
			if (ph[ver] == -1)
				v[ver] = 0;
			else v[ver] = max(v[ver], ph[ver]);
			if (tl != tr - 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = ph[ver];
			}
			ph[ver] = 0;
		}
		if (tl == l && tr == r) {
			v[ver] = max(v[ver], val);
			if (tr != tl + 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = val;
			}
			return;
		}
		ll tm = (tr + tl) / 2;
		setotr2(l, min(r, tm), val, ver * 2 + 1, tl, tm);
		setotr2(max(l, tm), r, val, ver * 2 + 2, tm, tr);
		v[ver] = min(getmin(ver * 2 + 1), getmin(ver * 2 + 2));
	}
	ll getind(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (ph[ver]) {
			if (ph[ver] == -1)
				v[ver] = 0;
			else v[ver] = max(v[ver], ph[ver]);
			if (tl != tr - 1) {
				ph[ver * 2 + 1] = ph[ver * 2 + 2] = ph[ver];
			}
			ph[ver] = 0;
		}
		if (l >= tr || r <= tl || v[ver] == m)
			return -1;
		if (tl == tr - 1) {
			if (v[ver] < m)
				return l;
			return -1;
		}
		ll tm = (tr + tl) / 2;
		ll ret = getind(max(l, tm), r, ver * 2 + 2, tm, tr);
		if (ret != -1)
			return ret;
		return getind(l, min(r, tm), ver * 2 + 1, tl, tm);
	}
} tr;
map<ll, ll> mp;
vector<ll> v;
ll n;

bool check(ll x) {
	tr.init(MAXN, x);
	for (ll i = 0; i < n; i++) {
		ll ind = tr.getind(0, v[i]);
		if (ind == -1)
			return false;
		tr.set(ind, 1);
		tr.setotr2(0, ind, 1);
		tr.setotr2(ind + 1, v[i], 1);
		tr.setotr(ind + 1, MAXN, -1);
	}
	return true;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n;
	v.resize(n);
	for (ll i = 0; i < n; i++)
		cin >> v[i];
	ll l = 1, r = 1e18;
	while (r - l > 1) {
		ll m = (r + l) / 2;
		if (check(m))
			r = m;
		else l = m;
	}
	if (check(l))
		r = l;
	cout << r;
	return 0;
}