#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <ctime>
#include <queue>
#define X first
#define Y second
typedef long long ll;
typedef long double ld;
const ll INF = 1e9 + 4;
using namespace std;
struct ST {
	vector<ll> v;
	ll n;
	void init(ll n) {
		v.resize(4 * n);
		this->n = n;
		return;
	}
	void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr <= pos || tl > pos)
			return;
		if (tr == tl - 1 && tl == pos)
			return void(v[ver] = val);
		ll tm = (tl + tr) / 2;
		if (tm < pos)
			set(pos, val, ver * 2 + 1, tl, tm);
		else set(pos, val, ver * 2 + 2, tm, tr);
		v[ver] = v[ver * 2 + 1] + v[ver * 2 + 2];
	}
	ll get(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr <= l || tl >= r)
			return INF;
		if (tl == tr - 1)
			return (v[ver] == 1 ? l : INF);
		ll tm = (tr + tl) / 2;
		ll ret = get(l, min(tm, r), ver * 2 + 1, tl, tm);
		if (ret != INF)
			return ret;
		return get(max(tm, l), tr, ver * 2 + 2, tm, tr);
	}
	ll getsum(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tl >= r || tr <= l)
				 0;
		if (tl == l && tr == r)
			return v[ver];
		ll tm = (tl + tr) / 2;
		return getsum(l, min(tm, r), ver * 2 + 1, tl, tm) +
			getsum(max(tm, l), r, ver * 2 + 2, tm, tr);
	}
} tr;
const ll MAXN = 1000000 + 3;
ll d[4][MAXN];
ll n;
string s;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> s;
	for (ll i = n - 1; i >= 0; i--) {
		d[0][i] = d[0][i + 1] + s[i]=='U';
		d[1][i] = d[1][i + 1] + s[i]=='R';
		d[2][i] = d[2][i + 1] + s[i]=='D';
		d[3][i] = d[3][i + 1] + s[i]=='L';
	}
	ll x, y;
	cin >> x >> y;
	ll tx = 0, ty = 0;
	vector<bool> good(4, true);
	vector<ll> ans(4, n);
	if (y >= 0)
		ans[2] = 0;
	else ans[0] = 0;
	if (x >= 0)
		ans[3] = 0;
	else ans[1] = 0;
	for (ll i = 0; i < n; i++) {
		if (ty == y) {
			ans[0] = min(ans[0], i);
			ans[2] = min(ans[2], i);
		}
		if (tx == x) {
			ans[1] = min(ans[1], i);
			ans[3] = min(ans[3], i);
		}
		if (s[i] == 'U' && ans[0]>i)
			ty++;
		if (s[i] == 'D' && ans[2]>i)
			ty--;
		if (s[i] == 'R' && ans[1]>i)
			tx++;
		if (s[i] == 'L' && ans[3]>i)
			tx--;
	}
	if (tx != x || ty != y)
		cout << -1;
	else {
		for (ll i = 0; i < 4; i++)
			cout << ans[i] << ' ';
	}
	return 0;
}