#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <ctime>
#include <queue>
#define X first
#define Y second
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 1e9 + 4;
using namespace std;
struct ST {
	vector<ll> v;
	ll n;
	void init(ll n) {
		v.resize(4 * n);
		this->n = n;
		return;
	}
	void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr <= pos || tl > pos)
			return;
		if (tr == tl - 1 && tl == pos)
			return void(v[ver] = val);
		ll tm = (tl + tr) / 2;
		if (tm < pos)
			set(pos, val, ver * 2 + 1, tl, tm);
		else set(pos, val, ver * 2 + 2, tm, tr);
		v[ver] = v[ver * 2 + 1] + v[ver * 2 + 2];
	}
	ll get(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr <= l || tl >= r)
			return INF;
		if (tl == tr - 1)
			return (v[ver] == 1 ? l : INF);
		ll tm = (tr + tl) / 2;
		ll ret = get(l, min(tm, r), ver * 2 + 1, tl, tm);
		if (ret != INF)
			return ret;
		return get(max(tm, l), tr, ver * 2 + 2, tm, tr);
	}
	ll getsum(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tl >= r || tr <= l)
			0;
		if (tl == l && tr == r)
			return v[ver];
		ll tm = (tl + tr) / 2;
		return getsum(l, min(tm, r), ver * 2 + 1, tl, tm) +
			getsum(max(tm, l), r, ver * 2 + 2, tm, tr);
	}
} tr;
const ll MAXN = 1000000 + 3;

struct ev {
	ll p, w, type, id;
	ev(ll p, ll w, ll type, ll id) :
		p(p),
		w(w),
		type(type),
		id(id)
	{}
};
ll ans = 1;
bool comp(ev a, ev b) {
	if (a.p != b.p)
		return a.p < b.p;
	if (a.type != b.type)
		return a.type>b.type;
	return a.id < b.id;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll n, k;
	cin >> n >> k;
	vector<ev> v;
	vector<pair<pair<ll, ll>,ll> > sob;
	for (ll i = 0; i < n; i++) {
		ll l, r, w;
		cin >> l >> r >> w;
		sob.push_back({ {l,r},w });
		v.emplace_back(l, w, 1, i);
		v.emplace_back(r + 1, w, 2, i);
	}
	sort(v.begin(), v.end(), comp);
	multiset<ll> st;
	ll col = 0;
	if (v[0].p != 1) {
		cout << -1;
		return 0;
	}
	vector<pair<ll, ll> > bl;
	for (ll i = 0; i < v.size(); i++) {
		if (v[i].type == 1) {
			col++;
		}
		else {
			col--;
		}
		if (col == 0 && v[i].p != k + 1 && (i==v.size()-1 || v[i+1].p!=v[i].p)) {
			cout << -1;
			return 0;
		}
	}
	ll ans = 1e18;
	for (ll i = 0; i < (1 << n); i++) {
		vector<ev> v;
		for (ll j = 0; j < n; j++) {
			if (i & (1 << j)) {
				v.emplace_back(sob[j].X.X, sob[j].Y, 1,j);
				v.emplace_back(sob[j].X.Y+1, sob[j].Y, 2,j);
			}
		}
		sort(v.begin(), v.end(), comp);
		ll mx = 0;
		ll tans = 0;
		ll col = 0;
		if (v.size()==0 || v[0].p != 1)
			continue;
		for (ll j = 0; j < v.size(); j++) {
			if (v[j].type == 1)
				col++, tans += v[j].w;
			else col--, tans -= v[j].w;
			if (col == 0 && v[j].p != k + 1 && (j==v.size()-1 || v[j+1].p!=v[j].p)) {
				mx = 1e18;
				break;
			}
			mx = max(mx, tans);
		}
		ans = min(ans, mx);
	}
	cout << ans;
	return 0;
}