#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

pair<llp, ll> seg[MAXN];
set<ll> cord;
unordered_map<ll, ll> mp;
ll n, k;

ll make(ll i, vector<ll> v) {
	if (i == n) {
		ll ans = 0;
		for (ll i = 0; i < v.size(); i++) {
			if (v[i] == 0) { return INF; }
			ans = max(ans, v[i]);
		}
		return ans;
	}
	
	ll ans = make(i + 1, v);
	for (ll j = seg[i].first.first; j <= seg[i].first.second; j++) {
		v[j] += seg[i].second;
	}

	ans = min(ans, make(i + 1, v));
	return ans;
}

int main() {
	cin >> n >> k;
	cord.insert(1);
	cord.insert(k);

	for (ll i = 0; i < n; i++) {
		cin >> seg[i].first.first >> seg[i].first.second >> seg[i].second;
		seg[i].first.second = min(k, seg[i].first.second);
		cord.insert(seg[i].first.first);
		cord.insert(seg[i].first.second);
	}

	ll q = 0;
	for (auto it = cord.begin(), end = cord.end(); it != end; it++) {
		mp[*it] = q;
		q++;
	}
	
	for (ll i = 0; i < n; i++) {
		seg[i].first.first = mp[seg[i].first.first];
		seg[i].first.second = mp[seg[i].first.second];
	}

	vector<ll> v(cord.size(), 0);
	ll ans = make(0, v);
	if (ans == INF) { ans = -1; }
	cout << ans;

	return 0;
}