#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <assert.h>
#include <bitset>
#include <cmath>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> llp;

const ll MAXN = 200000;
const ll INF = 1000000000;
const ll MOD = 1000000007;
const ld eps = 1e-7;

ll pw[62];

ll gcd(ll a, ll b) {
	while (b > 0) {
		a %= b;
		swap(a, b);
	}
	return a;
}

int main() {
	pw[0] = 1;
	for (ll i = 1; i < 62; i++) {
		pw[i] = pw[i - 1] * 2;
	}

	ll g;
	scanf("%lld", &g);

	for (ll q = 0; q < g; q++) {
		ll l = 0, r = 61;
		ll m = (l + r) / 2;
		
		ll del = 1;

		bool f = false;;

		while (r - l > 1) {
			printf("X %lld\n", pw[m]); fflush(stdout);

			ll a, b;
			scanf("%lld", &a);
			if (a == -1) { assert(false); return 0; }
			scanf("%lld", &b);

			if (a == 0) {
				r = m;
				if (m == 1) { f = true; }
			}
			else {
				l = m;
				del = del / gcd(del, b) * b;
			}
			m = (l + r) / 2;
		}
		
		if (f) {
			printf("N 1\n"); fflush(stdout);
		}
		else {
			assert(del > 0 && del <= 1000000000000000000);
			printf("N %lld\n", del); fflush(stdout);
		}

		char s[20];
		scanf("%s", &s);
		if (s[0] == 'W') { return 0; }
	}

	return 0;
}