#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back

typedef long long ll;
typedef long double ld;

const int N = 100100;
const ll INF = (ll)(1e18);

struct segtree{
    int n;
    vector<ll> t;

    void modify(int p, ll val){
        p += n;
        if (t[p] < val) return;
        t[p] = val;
        for (; p > 1; p >>= 1) t[p >> 1] = min(t[p], t[p ^ 1]);
    }

    ll query(int l, int r){
        ll res = INF;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1){
            if (l & 1) res = min(res, t[l++]);
            if (r & 1) res = min(res, t[--r]);
        }
        return res;
    }

    segtree(int n):n(n), t(n << 1, INF){
    }
};
pair<pair<int,int>,int> gr[N];
int n, k;
vector<int> all;

int mp(int x){
    int p = (int)(lower_bound(all.begin(), all.end(), x) - all.begin());
    return p;
}

int main(){
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n >> k;
//    mp.reserve(3 * N);
    all.reserve(n + n + n + 4);
    all.pb(0);
    all.pb(k);
    all.pb(k + 1);
    for (int i = 0; i < n; i++){
        cin >> gr[i].F.S >> gr[i].F.F >> gr[i].S;
        all.pb(gr[i].F.F);
        all.pb(gr[i].F.S - 1);
        all.pb(gr[i].F.S);
    }
    sort(all.begin(), all.end());
    sort(gr, gr + n);
    segtree T(n + n + n + 4);
    T.modify(0, 0);
    for (int i = 0; i < n; i++){
        int l = gr[i].F.S, r = gr[i].F.F;
//        cerr << l << " " << r << endl;
        ll add = gr[i].S;
        ll cur;
        cur = T.query(mp(l - 1), mp(r));
        T.modify(mp(r), cur + add);
        cur = T.query(mp(l - 1), mp(l));
        T.modify(mp(r), max(cur, add));
    }
    if (T.query(mp(k), mp(k + 1)) == INF){
        cout << -1 << endl;
    }
    else{
        cout << T.query(mp(k), mp(k + 1));
    }
    return 0;
}

