#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <bitset>
#include <ctime>
#include <sstream>
#include <queue>
#include <cassert>

using namespace std;
typedef long long ll;


int solve();

int main() {
#ifdef ZAOCHKA
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int dd = (int)1e5 + 1;
int l[dd];
int cur[dd];
int n;

struct node {
	int l, r;
	int push, val;

	node() {
		l = -1, r = -1, push = 0, val = 0;
	}

	void clear() {
		l = -1, r = -1, push = 0, val = 0;
	}
};

node T[4 * dd];

int nv = 0;

int newnode() {
	int cur = nv++;
	T[cur].l = T[cur].r = -1;
	T[cur].push = T[cur].val = 0;
	return cur;
}

struct SegmentTree {

	void clear() {
		nv = 0;
	}

	int get(int x) {
		return x == -1 ? 0 : (T[x].push ? 0 : T[x].val);
	}

	void push(int x) {
		if (x == -1) return;
		if (T[x].push) {
			if (T[x].l != -1) T[x].push = 1;
			if (T[x].r != -1) T[x].push = 1;
			T[x].val = 0;
		}
	}

	void check(int &x) {
		if (x == -1) {
			x = newnode();
		}
	}

	void add(int v, int tl, int tr, int pos) {
		push(v);
		if (tl == tr) {
			T[v].val++;
		} else {
			int tm = (tl + tr) / 2;
			if (pos <= tm) {
				check(T[v].l);
				add(T[v].l, tl, tm, pos);
			} else {
				check(T[v].r);
				add(T[v].r, tm + 1, tr, pos);
			}
			T[v].val = min(get(T[v].l), get(T[v].r));
		}
	}

	void upd(int v, int tl, int tr, int l, int r) {
		push(v);
		if (l == tl && tr == r) {
			T[v].push = 1;
		} else {
			int tm = (tl + tr) / 2;
			if (r <= tm) {
				check(T[v].l);
				upd(T[v].l, tl, tm, l, r);
			} else if (l > tm) {
				check(T[v].r);
				upd(T[v].r, tm + 1, tr, l, r);
			} else {
				check(T[v].l), check(T[v].r);
				upd(T[v].l, tl, tm, l, tm);
				upd(T[v].r, tm + 1, tr, tm + 1, r);
			}
			T[v].val = min(get(T[v].l), get(T[v].r));
		}
	}

	int get(int v, int tl, int tr, int pos, int x) {
		if (tl == tr) {
			return (T[v].val < x ? tl : -1);
		}

		int tm = (tl + tr) / 2;

		int t = -1;

		if (pos > tm && get(T[v].r) < x) {
			check(T[v].r);
			t = get(T[v].r, tm + 1, tr, pos, x);
		}
		
		if (t != -1) return t;

		if (get(T[v].l) < x) {
			check(T[v].l);
			t = get(T[v].l, tl, tm, pos, x);
		}

		return t;
	}

} F;

const int N = (int)1e9 + 1;

bool check(int x) {

	F.clear();
	int root = -1;
	F.check(root);

	F.upd(root, 0, N, 0, l[0] - 1);

	for (int i = 1; i < n; i++) {
		if (l[i] > l[i - 1]) {

			F.upd(root, 0, N, l[i - 1], l[i] - 1);

		} else {

			int pos = F.get(root, 0, N, l[i] - 1, x);

			if (pos < 0) return false;

			F.add(root, 0, N, pos);

			if (pos + 1 <= l[i] - 1)
				F.upd(root, 0, N, pos + 1, l[i] - 1);
		}
	}
	return true;
}

int solve() {
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%d", &l[i]);
	}
	check(2);
	int l = -1, r = (int)1e9 + 1;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (check(m))
			r = m;
		else
			l = m;
	}
	printf("%d\n", r + 1);


	return 0;
}