#include <bits/stdc++.h>

using namespace std;

#define int int64_t

ifstream fin("input.txt");
ofstream fout("output.txt");
ofstream deb("debug.txt");

const int inf = 1000000000;

template<typename T>
void printc(vector<T> &a) {
    for (auto x : a)
        cout << x << " ";
    cout << endl;
}

template<typename T>
void printd(vector<T> &a) {
    for (auto x : a)
        deb << x << " ";
    deb << endl;
}

vector<int> l, r, p;

struct hap {
    int id, x;
    bool is_start;
    hap (int id = 0, int x = 0, bool is_start = true) {
        this -> id = id;
        this -> x = x;
        this -> is_start = is_start;
    }
};

bool cmp(hap a, hap b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.is_start && !b.is_start;
}

int max_elem(vector<int> &a) {
    int ans = -1;
    for (auto x : a)
        ans = max(ans, x);
    return ans;
}

signed main()
{
    int n, k;
    fin >> n >> k;
    l.resize(n);
    r.resize(n);
    p.resize(n);

    for (int i = 0; i < n; i++)
        fin >> l[i] >> r[i] >> p[i];

    vector<hap> haps;
    for (int i = 0; i < n; i++) {
        haps.push_back(hap(i, l[i], true));
        haps.push_back(hap(i, r[i] + 1, false));
    }
    sort(haps.begin(), haps.end(), cmp);

    int bal = 0;
    if (haps[0].x > 1 || haps.back().x <= k) {
        fout << -1;
        return 0;
    }
    for (int i = 0; i < n * 2 - 1; i++) {
        auto h = haps[i];
        if (h.is_start)
            bal++;
        else
            bal--;
        if (bal == 0) {
            fout << -1;
            return 0;
        }
    }


    vector<int> cl(n);
    vector<int> cr(n);
    vector<int> cp(n);

    int t = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (i > 0 && haps[i - 1].x < haps[i].x)
            t++;
        auto h = haps[i];
        cp[h.id] = p[h.id];
        if (h.is_start)
            cl[h.id] = t;
        else
            cr[h.id] = t;
    }

    int sz = t;
    int min_p = inf;

    for (int mask = 0; mask < (1 << n); mask++) {
        vector<bool> is_covered(sz);
        vector<int> cur_p(sz);
        for (int i = 0; i < sz; i++) {
            if ((mask & (1 << i)) > 0) {
                for (int j = cl[i]; j < cr[i]; j++) {
                    is_covered[j] = true;
                    cur_p[j] += cp[i];
                }
            }
        }
        bool is_good = true;
        int cur_max_p = max_elem(cur_p);
        for (int i = 0; i < sz; i++) {
            is_good = is_good & is_covered[i];
        }
        if (is_good)
            min_p = min(min_p, cur_max_p);
    }

    if (min_p == inf)
        fout << -1;
    else
        fout << min_p;

    return 0;
}
