#define push_back pb
#define pop_back pob
#define make_pair mp
#define _p(x, y) pair < x, y >
#define first X
#define second Y

#include <iostream>
#include <vector>
#include <stdio.h>
#include <set>
#include <map>
#include <iterator>
#include <climits>
#include <algorithm>
#include <cmath>
#include <random>
#include <queue>
#include <time.h>

using namespace std;

typedef long long i64;
#define endl '\n'

const int INF = 1e9 + 7;
const i64 LINF = 1e18 + 7;

int error() {
	printf("-1\n");
	return 0;
}

int main() {

#ifdef _DEBUG
	freopen("C_graph.txt", "r", stdin);
#endif

	int n, k;
	scanf("%d%d", &n, &k);

	vector < i64 > p(n);
	int l, r;
	vector < _p(int, _p(int, int)) > events;

	vector < int > starts;
	vector < int > ends;
	for (int i = 0; i < n; i++) {
		scanf("%d%d%lld", &l, &r, &p[i]);
		events.pb(mp(l, mp(0, i)));
		if (l == 1)
			starts.pb(i);
		events.pb(mp(r, mp(1, i)));
		if (r == k)
			ends.pb(i);
	}

	if (ends.size() == 0) {
		return error();
	}

	vector < vector < _p(int, i64) > > graph(n);

	set < int > s;
	sort(events.begin(), events.end());
	vector < int > prev_del;
	int pdx = -1;

	for (int i = 0; i < events.size(); i++) {
		
		if (events[i].Y.X == 0) {
			
			for (int x : s) {
				graph[x].pb(mp(events[i].Y.Y, p[x] + p[events[i].Y.Y]));
			}

			if (events[i].X == pdx + 1) {
				for (int x : prev_del) {
					graph[x].pb(mp(events[i].Y.Y, max(p[x], p[events[i].Y.Y])));
				}
			}
			else {
				prev_del.clear();
			}

			s.insert(events[i].Y.Y);
		}
		else {
			if (events[i].X != pdx) {
				pdx = events[i].X;
				prev_del.clear();
			}
			prev_del.pb(events[i].Y.Y);

			s.erase(events[i].Y.Y);
		}

	}

	set < _p(i64, int) > q;
	vector < i64 > dyn(n, LINF);
	for (int i : starts) {
		q.insert(mp(p[i], i));
		dyn[i] = p[i];
	}

	int cur;
	while (q.size()) {
		
		cur = q.begin()->Y;
		q.erase(q.begin());

		for (_p(int, i64) &gi : graph[cur]) {
			if (dyn[gi.X] > max(dyn[cur], gi.Y)) {
				q.erase(mp(dyn[gi.X], gi.X));
				dyn[gi.X] = max(dyn[cur], gi.Y);
				q.insert(mp(dyn[gi.X], gi.X));
			}
		}

	}

	i64 ans = LINF;
	for (int i : ends) {
		ans = min(dyn[i], ans);
	}

	if (ans == LINF) {
		printf("-1\n");
	}
	else {
		printf("%lld\n", ans);
	}
	return 0;
}