#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <cstdio>
#include <iomanip>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(s) s.begin(), s.end() 

ifstream cin("input.txt");
ofstream cout("output.txt");

struct node {
	int l, r, p;
};

vector <node> otr;

bool f(node a, node b) {
	if (a.l != b.l) {
		return a.l < b.l;
	}
	return a.r < b.r;
}

void init1(int n) {
	int k;
	cin >> k;
	otr.resize(n);
	map <int, int> scanl;
	for (int i = 0; i < n; i++) {
		int l, r, p;
		cin >> l >> r >> p; l--; r--;
		otr[i] = { l, r, p };
	}
	sort(all(otr), f);
	int tl = -1;
	for (int i = 0; i < n; i++) {
		if (tl < otr[i].l - 1) {
			cout << -1;
			return;
		}
		tl = max(tl, otr[i].r);
	}
	if (tl < k - 1) {
		cout << -1;
		return;
	}
	map <int, bool> dp;
	dp[0] = true;
	for (auto c : otr) {
		int l = c.l;
		int r = c.r;
		if (dp.find(l) != dp.end() && dp[l]) {
			dp[r + 1] = true;
		}
	}
	if (dp.find(k) != dp.end()) {
		cout << 1;
	}
	else {
		cout << 2;
	}
	return;
}

int main() {
	int n;
	cin >> n;
	init1(n);
}