#include <fstream>
#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

vector<int> next(int m, vector<int> prev, int sz) {
    vector<int> ans;
    if (sz > prev.size()) {
        ans = prev;
        for (int i = prev.size(); i < sz; ++i) {
            ans.push_back(0);
        }
    } else {
        ans.resize(sz);
        int i = sz - 1;
        while (i >= 0 && prev[i] == m - 1) {
            ans[i] = 0;
            --i;
        }
        if (i < 0) {
            return {-1};
        }
        ans[i] = prev[i] + 1;
        --i;
        while (i >= 0) {
            ans[i] = prev[i];
            --i;
        }
    }
    return ans;
}

bool check(int m, vector<int> &a) {
    int n = a.size();
    vector<int>prev;
    for (int i = 0; i < a[0]; ++i) {
        prev.push_back(0);
    }
    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            vector<int> k(prev.begin(), prev.begin() + a[i]);
            prev = next(m, k, a[i]);
        } else {
            prev = next(m, prev, a[i]);
        }
        if (prev[0] == -1) {
            return false;
        }
    }
    return true;
}

int main() {
    //ifstream cin("i-A.txt");
    int n;
    cin >> n;
    vector<int> q(n);
    for (int &i : q) {
        cin >> i;
    }
    ll l = 0, r = 1e15;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (check(m, q)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r;
    return 0;
}
