#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <queue>
#include <map>

using namespace std;

struct vert {
	long long l, r, p;
};

bool comp(vert a, vert b) {
	return a.l < b.l;
}

bool comp2(vert a, vert b) {
	return a.r < b.r;
}

const long long INF = 1e18 + 18;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<vert> a(n);
	bool can = 1;
	for (int i = 0; i < n; i++) {
		cin >> a[i].l >> a[i].r >> a[i].p;
		a[i].l--;
		a[i].r--;
		if (a[i].p != 1)
			can = 0;
	}
	sort(a.begin(), a.end(), comp);
	if (can) {
		long long mx = -1;
		int now = 0;
		int place = -1;
		bool is = 1;
		while (place < k - 1) {
			while (now < n && a[now].l <= place + 1) {
				if (a[now].l == place + 1)
					mx = max(mx, a[now].r);
				now++;
			}
			if (mx == place) {
				is = 0;
				break;
			}
			place = mx;
		}
		if (is) {
			cout << 1;
			return 0;
		}
		place = -1;
		now = 0;
		mx = -1;
		while (place < k - 1) {
			while (now < n && a[now].l <= place + 1) {
				mx = max(mx, a[now].r);
				now++;
			}
			if (mx == place) {
				cout << -1;
				return 0;
			}
			place = mx;
		}
		cout << 2;
		return 0;
	}
	a.push_back({ -1, -1, 0 });
	sort(a.begin(), a.end(), comp2);
	n++;
	vector<long long> dp(n, INF);
	dp[0] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			if (a[j].l < a[i].l) {
				if (a[j].r > a[i].l - 1) {
					dp[i] = min(dp[i], max(a[i].p + a[j].p, dp[j]));
				}
				if (a[j].r == a[i].l - 1) {
					dp[i] = min(dp[i], max(a[i].p, dp[j]));
				}
			}
		}
	}
	long long mn = INF;
	for (int i = 0; i < n; i++)
		if (a[i].r == k - 1)
			mn = min(mn, dp[i]);
	if (mn == INF)
		cout << -1;
	else
		cout << mn;

	return 0;
}