#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <stdio.h>

using namespace std;

typedef long long ll;
typedef double dbl;

template <class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << "\n";
}


const ll INF = 1e15;

struct point{
    int l, r;
    ll w;
};


vector<ll> tree;

void update(int pos, ll v){
    tree[pos] = v;
    while (pos > 0){
        pos = (pos - 1) / 2;
        tree[pos] = max(tree[pos * 2 + 1], tree[pos * 2 + 2]);
    }
}


ll get(int v, int vl, int vr, int l, int r){
    if (vl >= l && vr <= r)
        return tree[v];
    if (vl > r || vr < l)
        return 0;
    int vm = (vl + vr) / 2;
    return max(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm + 1, vr, l, r));
}


int main()
{
    /*freopen("test.in", "r", stdin);
    /*freopen("test.out", "w", stdout);/**/
    int n, k;
    cin >> n >> k;
    vector<point> s(n);
    set<int> lst;
    bool flag = false;
    for (int i = 0; i < n; i++){
        cin >> s[i].l >> s[i].r >> s[i].w;
        s[i].l--;
        s[i].r--;
        lst.insert(s[i].l);
        lst.insert(s[i].l + 1);
        lst.insert(max(s[i].l - 1, 0));
        lst.insert(s[i].r);
        lst.insert(s[i].r + 1);
        lst.insert(max(s[i].r - 1, 0));
        if (k == s[i].r + 1)
            flag = true;
    }
    if (!flag){
        cout << -1 << endl;
        return 0;
    }
    vector<int> s1;
    while (lst.size() > 0){
        s1.push_back(*(lst.begin()));
        lst.erase(s1.back());
    }
    for (int i = 0; i < n; i++){
        int l = 0;
        int r = s1.size();
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (s1[m] <= s[i].l)
                l = m;
            else
                r = m;
        }
        s[i].l = l;

        l = 0;
        r = s1.size();
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (s1[m] <= s[i].r)
                l = m;
            else
                r = m;
        }
        s[i].r = l;
    }
    k = 0;
    for (int i = 0; i < n; i++)
        k = max(k, s[i].r + 1);
    /*for (int i = 0; i < n; i++)
        cout << s[i].l << " " << s[i].r << endl;/**/
    vector<ll> dp(k, INF);
    int b = 1;
    while (b < k)
        b *= 2;
    tree.resize(2 * b - 1);
    for (int i = b - 1; i < b - 1 + n; i++)
        tree[i] = INF;
    for (int i = b - 2; i >= 0; i--)
        tree[i] = max(tree[i * 2 + 1], tree[i * 2 + 2]);
    for (int i = 0; i < k; i++){
        for (int j = 0; j < n; j++){
            if (s[j].r == i){
                if (s[j].l == 0)
                    dp[i] = min(dp[i], s[j].w);
                else{
                    if (s[j].l < s[j].r)
                        dp[i] = min(dp[i], max(s[j].w, min(s[j].w + get(0, 0, b - 1, s[j].l, i - 1), dp[s[j].l - 1])));
                    else
                        dp[i] = min(dp[i], max(s[j].w, dp[i - 1]));
                }
            }
        }
        update(b - 1 + i, dp[i]);
    }
    print(dp);
    if (dp[k - 1] == INF)
        cout << -1 << endl;
    else
        cout << dp[k - 1] << endl;
    return 0;
}
