#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cstdlib>

using namespace std;

typedef unsigned long long ll;

ll n;
vector<ll> lens;

const ll MAXCNTLEN = (ll) 1e5 + 42;
const ll LBINF = (ll) 1e9 + 4253;
ll MAXLEN[MAXCNTLEN];

ll pow(ll a, ll b) {
    if (b == 0) {
        return 1;
    }
    ll g = pow(a, b / 2);
    ll ans = g * g;
    if (b % 2) {
        ans *= a;
    }
    return ans;
}

//ll pow(ll a, ll b) {
//    if (a == 1) {
//        return 1;
//    }
//    ll st = 1;
//    for (ll i = 0; i < b; ++i) {
//        st *= a;
//    }
//    return st;
//}

bool isCorrect(ll c) {
    set<ll> now;
    map<ll, ll> num;
    now.insert(0);
    num[0] = 0;
    for (ll i = 0; i < n; ++i) {
        auto it = --now.end();
        ll lb = LBINF;
        while (*it >= lens[i]) {
            if (lb != LBINF) {
                num[lb] = 0;
            }
            lb = *it;
            now.erase(it--);
        }
        if (lb == LBINF) {
            now.insert(lens[i]);
            num[lens[i]] = 1;
            continue;
        }
        if (lens[i] == lb) {
            num[lb]++;
            if (lb - *it <= MAXLEN[c]) {
                if (num[lb] > pow(c, lb - *it)) {
                    num[lb] = 0;
                    auto itt = num.find(lb);
                    --itt;
                    auto nt = itt;
                    --nt;
                    while (itt != num.begin()) {
                        itt->second++;
                        if (itt->first - nt->first <= MAXLEN[c] &&
                            itt->second > pow(c, itt->first - nt->first)) {
                            itt->second = 0;
                            --itt;
                            nt = itt;
                            --nt;
                        } else {
                            break;
                        }
                    }
                    if (itt == num.begin()) {
                        return false;
                    }
                }
            }
            now.insert(lb);
        } else {
            if (lb - *it > MAXLEN[c]) {
                num[lb] = 0;
                num[lens[i]] = 1;
            } else {
                num[lens[i]] = (num[lb] - 1) / pow(c, lb - lens[i]) + 2;
                num[lb] = 0;
                if (num[lens[i]] > pow(c, lens[i] - *it)) {
                    num[lens[i]] = 0;
                    auto itt = num.find(lens[i]);
                    --itt;
                    auto nt = itt;
                    --nt;
                    while (itt != num.begin()) {
                        itt->second++;
                        if (itt->first - nt->first <= MAXLEN[c] &&
                            itt->second > pow(c, itt->first - nt->first)) {
                            itt->second = 0;
                            --itt;
                            nt = itt;
                            --nt;
                        } else {
                            break;
                        }
                    }
                    if (itt == num.begin()) {
                        return false;
                    }
                }
            }
            now.insert(lens[i]);
        }
    }
    return true;
}

ll binSearch() {
    ll l = 0, r = n;
    while (l < r - 1) {
        ll m = (l + r) / 2;
        if (isCorrect(m)) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}\

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    MAXLEN[1] = LBINF + 42;
    for (ll i = 2; i < MAXCNTLEN; ++i) {
        ll num = MAXCNTLEN;
        while (num) {
            ++MAXLEN[i];
            num /= i;
        }
        if (i < 40) {
            ++MAXLEN[i];
        }
    }
    cin >> n;
    lens.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> lens[i];
    }
    cout << binSearch() << "\n";
//    system("pause");
    return 0;
}