//#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <set>
//#include <map>
//
//using namespace std;
//
//typedef long long ll;
//
//const ll INF = (ll) 1e9 + 42;
//
//enum {OPEN, CLOSE};
//
//struct Event {
//    ll pos;
//    ll pair;
//    ll p;
//    int type;
//};
//
//vector<Event> es;
//
//bool operator<(const Event &a, const Event &b) {
//    return a.pos < b.pos || (a.pos == b.pos && a.type < b.type);
//}
//
//bool isCorrect(ll maxi) {
//    ll now = 0;
//    multiset<pair<ll, ll>> s;
//    map<ll, vector<ll>> ws;
//    set<pair<ll, ll>> can;
//    for (int i = 0; i < es.size(); ++i) {
//        auto e = es[i];
//        if (e.type == OPEN) {
//            if (now + e.p <= maxi) {
//                s.insert({e.pair, e.p});
//            } else {
//
//            }
//        } else {
//            now -= e.p;
//            s.erase(s.begin());
//        }
//    }
//}
//
//ll binSearch() {
//    ll l = 0, r = INF;
//    while (l < r - 1) {
//        ll m = (l + r) / 2;
//        if (isCorrect(m)) {
//            r = m;
//        } else {
//            l = m;
//        }
//    }
//    return r;
//}
//
//int main() {
//    ll n, k;
//    cin >> n >> k;
//    for (int i = 0; i < n; ++i) {
//        ll l, r, p;
//        cin >> l >> r >> p;
//        es.push_back({l, r, p, OPEN});
//        es.push_back({r, l, p, CLOSE});
//    }
//    sort(es.begin(), es.end());
//    return 0;
//}
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll INF = (ll) 1e18;

ll k;

struct Edge {
    ll l, r, p;
};

struct Event {
    ll pos, p;
    bool isOpen;
};

bool operator<(const Event &a, const Event &b) {
    return a.pos < b.pos || (a.pos == b.pos && a.isOpen > b.isOpen);
}

vector<Event> ev;

ll check() {
    sort(ev.begin(), ev.end());
    ll maxP = 0;
    ll p = 0;
    if (ev.empty()) {
        return INF;
    }
    for (auto e : ev) {
        if (p == 0 && e.pos != 1) {
            return INF;
        }
        if (e.isOpen) {
            p += e.p;
        } else {
            p -= e.p;
        }
        if (p == 0 && e.pos < k) {
            return INF;
        }
        maxP = max(maxP, p);
    }
    return maxP;
}


int main() {
    int n;
    cin >> n >> k;
    vector<Edge> es(n);
    for (int i = 0; i < n; ++i) {
        cin >> es[i].l >> es[i].r >> es[i].p;
    }
    ll ans = INF;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ev.clear();
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                ev.push_back({es[i].l, es[i].p, true});
                ev.push_back({es[i].r, es[i].p, false});
            }
        }
        ans = min(ans, check());
    }
    if (ans == INF) {
        ans = -1;
    }
    cout << ans << "\n";
//    system("pause");
    return 0;
}