import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;
import java.io.*;

/**
 * Created by olymp on 10.03.2017.
 */
public class Main {
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }


    void solve() throws IOException {
        int n = nextInt();
        int l[] = new int[n];
        int mas[][] = new int[n][];
        for (int i = 0; i < n; i++) {
            l[i] = nextInt();
            mas[i] = new int[l[i]];
        }
        int left = 0, right = 256;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            for(int i = 0; i < l[0]; i++){
                mas[0][i] = 1;
            }
            boolean res = true;
            for(int i = 1; i < n; i++){
                if(l[i] > l[i - 1]){
                    for(int j = 0; j < l[i - 1]; j++){
                        mas[i][j] = mas[i - 1][j];
                    }
                    for(int j = l[i - 1]; j < l[i]; j++){
                        mas[i][j] = 1;
                    }
                }else {
                    for(int j = 0; j < l[i]; j++){
                        mas[i][j] = mas[i - 1][j];
                    }
                    boolean flag = true;
                    for(int j = l[i] - 1; j >= 0; j--){
                        mas[i][j]++;
                        if(mas[i][j] > mid){
                            mas[i][j] = 1;
                            if(j == 0) flag = false;
                        }else break;
                    }
                    if(!flag) {
                        res = false;
                        break;
                    }
                }
            }
            if(res){
                right = mid;
            }else left =mid;
        }
        out.print(right);
    }
}

/*
8
LLURDRRD
1 -1

4 4
25 25 30 50
10 40
20 30
70 100
50 50

5 3 8
1 2
5 1
2 4
1 1 2
3
2 1 2
3
2 4 2
2 5 3
3
1 4 5
 */