import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

/**
 * Created by olymp on 10.03.2017.
 */
public class Main {
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }


    void solve() throws IOException {
        int n = nextInt();
        char s[] = nextToken().toCharArray();
        int x = nextInt(), y = nextInt();
        int x1 = 0, y1 = 0;
        boolean xx = false, yy = false;
        int resl = 0, resu = 0, resr = 0, resd = 0;
        if(x == 0){
            xx = true;
        }
        if(y == 0){
            yy = true;
        }
        for (int i = 0; i < n; i++) {
            if (s[i] == 'U' && y > 0) {
                if (!yy) {
                    y1++;
                    if (y1 == y) {
                        yy = true;
                        resu = i + 1;
                    }
                }
            } else if (s[i] == 'L' && x < 0) {
                if (!xx) {
                    x1--;
                    if (x1 == x) {
                        xx = true;
                        resl = i + 1;
                    }
                }
            } else if (s[i] == 'R'&& x > 0) {
                if (!xx) {
                    x1++;
                    if (x1 == x) {
                        xx = true;
                        resr = i + 1;
                    }
                }
            } else if(y < 0){
                if (!yy) {
                    y1--;
                    if (y1 == y) {
                        yy = true;
                        resd = i + 1;
                    }
                }
            }
        }
        if (xx && yy) {
            out.printf("%d %d %d %d", resl, resu, resr, resd);
        } else out.print(-1);
    }
}
/*
8
LLURDRRD
1 -1

4 4
25 25 30 50
10 40
20 30
70 100
50 50

5 3 8
1 2
5 1
2 4
1 1 2
3
2 1 2
3
2 4 2
2 5 3
3
1 4 5
 */