import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

/**
 * Created by olymp on 10.03.2017.
 */
public class qwe {
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new qwe().run();
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    class Shaurma implements Comparable<Shaurma> {
        int l, r, p;

        Shaurma(int l, int r, int p) {
            this.l = l;
            this.r = r;
            this.p = p;
        }

        @Override
        public int compareTo(Shaurma o) {
            if (r == o.r) return Integer.compare(l, o.l);
            else return Integer.compare(r, o.r);
        }
    }

    void solve() throws IOException {
        int n = nextInt(), k = nextInt();
        Shaurma s[] = new Shaurma[n];
        for (int i = 0; i < n; i++) {
            s[i] = new Shaurma(nextInt(), nextInt(), nextInt());
        }
        Arrays.sort(s);
        long res[] = new long[n];
        for (int i = 0; i < n; i++) {
            if(s[i].l == 1) res[i] = s[i].p;
            else res[i] = Long.MAX_VALUE/2;
            for (int j = 0; j < i; j++) {
                if (s[j].r + 1 == s[i].l) {
                    res[i] = Math.min(res[i], Math.max(res[j],s[i].p));
                } else if (s[j].r >= s[i].l && s[j].r < s[i].r) {
                    res[i] = Math.min(res[i], Math.max(res[j], s[j].p + s[i].p));
                }
            }
        }
        long max = Long.MAX_VALUE/2;
        for (int i = 0; i < n; i++) {
            if (s[i].r >= k) max = Math.min(max, res[i]);
        }
        if (max == Integer.MAX_VALUE) max = -1;
        out.print(max);
    }
}
