import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

/**
 * Created by olymp on 10.03.2017.
 */
public class Main {
    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }


    void solve() throws IOException {
        int g = nextInt();

        for (int gg = 0; gg < g; gg++) {
            int l = 0, r = 61;
            long x, y;
            long qq = 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                qq = (long)Math.pow(2, mid);
                out.print("X ");
                out.println(qq);
                out.flush();
                x = nextLong();
                if (x == -1) return;
                y = nextLong();
                if (y == qq) {
                    l = mid;
                } else r = mid;
            }
            qq = (long)Math.pow(2, l + 1);
            out.print("X ");
            out.println(qq);
            out.flush();
            x = nextLong();
            if (x == -1) return;
            y = nextLong();
            while (y % 2 == 0) y /= 2;
            qq /= 2;
            y *= qq;
            out.println("N " + y);
            out.flush();
            String s = br.readLine();
            if (s.charAt(0) == 'W') return;
        }
    }
}

/*
8
LLURDRRD
1 -1

4 4
25 25 30 50
10 40
20 30
70 100
50 50

5 3 8
1 2
5 1
2 4
1 1 2
3
2 1 2
3
2 4 2
2 5 3
3
1 4 5
 */