#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e5 + 123;

struct Segment {
	int l, r, c;
};

int n;
int a[N];

int ptr;
Segment s[N];

void merge() {
	if (ptr < 2) return;
	
	if (s[ptr - 1].c == s[ptr - 2].c) {
		s[ptr - 2].r = s[ptr - 1].r;
		ptr--;
		merge();
	}
}

bool check(int k) {
	ptr = 0;
	s[ptr++] = {0, a[0] - 1, 1};
	
	for (int i = 1; i < n; i++) {
		if (a[i] > a[i - 1]) {
			s[ptr++] = {a[i - 1], a[i] - 1, 1};
			merge();
		} else {
			while (s[ptr - 1].l > a[i] - 1) {
				ptr--;
			}
			s[ptr - 1].r = a[i] - 1;
			
			if (s[ptr - 1].c == k) {
				ptr--;
				if (ptr == 0) {
					return false;
				} else {
					if (s[ptr - 1].l == s[ptr - 1].r) {
						s[ptr - 1].c++;
						merge();
					} else {
						s[ptr - 1].r--;
						s[ptr].l = s[ptr - 1].r + 1;
						s[ptr].r = s[ptr - 1].r + 1;
						s[ptr].c = s[ptr - 1].c + 1;
						ptr++;
						merge();
					}
				}
				
				if (s[ptr - 1].r < a[i] - 1) {
					s[ptr++] = {s[ptr - 1].r + 1, a[i] - 1, 1};
					merge();
				}
			} else {
				if (s[ptr - 1].l == s[ptr - 1].r) {
					s[ptr - 1].c++;
					merge();
				} else {
					s[ptr - 1].r--;
					s[ptr] = s[ptr - 1];
					s[ptr].l = s[ptr - 1].r + 1;
					s[ptr].r = s[ptr].l;
					s[ptr].c++;
					ptr++;
					merge();
				}
			}
		}
	}
	
	return true;
}

void run() {
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	
	int left = 0;
	int right = N;
	
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (check(mid)) {
			right = mid;
		} else {
			left = mid;
		}
	}
	
	cout << right << "\n";
}
