#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) (int) (x).size()
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL
	#define debug(x) cerr << x << endl
#else
	#define debug(x)
#endif

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;
const int MOD = (int) 1e9 + 7;
const ld EPS = 1e-8;

void run();

int main() {
#ifndef LOCAL
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	run();
	return 0;
}

const int N = (int) 1e6 + 123;

int n, x, y;
string s;
map<char, int> p[N];
map<char, int> q[N];

void run() {
	cin >> n;
	cin >> s;
	cin >> x >> y;
	p[0]['L'] = 0;
	p[0]['R'] = 0;
	p[0]['U'] = 0;
	p[0]['D'] = 0;
	for (int i = 1; i <= n; i++) {
		p[i] = p[i - 1];
		p[i][s[i - 1]]++;
	}
	
	for (int i = 0; i <= n; i++) {
		for (auto &it : p[i]) {
			if (!q[it.second].count(it.first)) {
				q[it.second][it.first] = i;
			}
		}
	}
	
	int pos_l = -INF;
	int pos_r = -INF;
	int pos_d = -INF;
	int pos_u = -INF;
	
	for (int r = 0; r < n; r++) {
		int rest = x - p[r]['R'];
		if (rest > 0) continue;

		rest = -rest;
		if (!q[rest].count('L')) continue;
		pos_r = r;
		pos_l = q[rest]['L'];
	}
	
	for (int u = 0; u < n; u++) {
		int rest = y - p[u]['U'];
		if (rest > 0) continue;

		rest = -rest;
		if (!q[rest].count('D')) continue;
		pos_u = u;
		pos_d = q[rest]['D'];
	}
	
	if (pos_l == -INF || pos_d == -INF) {
		cout << "-1\n";
		return;
	}
	
	cout << pos_l << " " << pos_u << " " << pos_r << " " << pos_d << "\n";
}
