#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

const long long INF = (long long)1e15;

long long check(const vector<pair<pair<int, int>, int>> &req, int mask, int k)
{
	vector<long long> ws(k, 0);
	for (int i = 0; i < req.size(); ++i)
	{
		if ((mask >> i) & 1)
		{
			for (int j = req[i].first.first; j <= req[i].first.second; ++j)
				ws[j] += req[i].second;
		}
	}
	long long mx = 0;
	for (auto elem : ws)
	{
		if (elem == 0)
			return INF;
		if (elem > mx)
			mx = elem;
	}
	return mx;
}

int main()
{
	int n, k;
	cin >> n >> k;
	vector<pair<pair<int, int>, int>> req(n);
	set<int> tmp;
	tmp.insert(1);
	tmp.insert(k);
	for (int i = 0; i < n; ++i)
	{
		int l, r, p;
		cin >> l >> r >> p;
		req[i] = { { l - 1, r - 1 }, p };
	}
	long long mn = INF;
	for (int i = 0; i < (1 << n); ++i)
	{
		long long res = check(req, i, k);
		if (res < mn)
			mn = res;
	}
	if (mn == INF)
		cout << -1 << endl;
	else
		cout << mn << endl;
	return 0;
}

