#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <vector>
#include <algorithm>

/// problem "Eclair"

using std::pair;

const int N = 100100;

int ls[N];

int div_pow(int val, int64_t a, int p)
{
    while (p && val >= a) {
        if (p&1) val /= a;
        p /= 2;
        a *= a;
    }
    return p ? 0 : val;
}

bool test(int n, int alph_sz)
{
    std::vector<pair<int, int> > word(1, {0, 0});
    for (int i = 0; i < n; ++i) {
        while (word.size() >= 2 && word.back().first > ls[i]) {
            auto it = word.back(); word.pop_back();
            if (word.back().first < ls[i])
                word.push_back({ls[i], 0});
            int dl = it.first - word.back().first;
            word.back().second += div_pow(it.second, alph_sz, dl);
        }
        if (word.back().first < ls[i])
            word.push_back({ls[i], -1});
        word.back().second++;
    }
    return word[0].second == 1;
}

int main()
{
    ///assert(freopen("input.txt", "r", stdin));
    int n; scanf("%d", &n);
    for (int i = 0; i < n; ++i)
        scanf("%d", ls+i);
    ls[n++] = 0;

    int l, r;
    l = 0; r = n;

    while (r - l > 1) {
        int mid = l + (r-l)/2;
        if (test(n, mid))
            r = mid;
        else
            l = mid;
    }

    printf("%d\n", r);

    return 0;
}
