#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <set>
#include <vector>
#include <algorithm>

/// problem "Napoleon"

const int N = 100100;

struct seg_t {
    int l, r;
} segs[N];

bool test(int n, int k, int val) {
    std::multiset<int> rs;
    rs.insert(segs[0].r);
    for (int i = 1; i < n; ++i) {
        if (rs.empty() || *rs.rbegin() < segs[i].l)
            return false;
        while (rs.size() && *rs.begin() <= segs[i].l)
            rs.erase(rs.begin());
        if ((int)rs.size() < val)
            rs.insert(segs[i].r);
    }
    return *rs.rbegin() == k;
}

inline
bool test_input(int n, int k)
{
    if (segs[0].l != 0)
        return false;
    return test(n, k, 1<<30);
}

int main()
{
    ///assert(freopen("input.txt", "r", stdin));
    int n, k; scanf("%d%d", &n, &k);

    int p;
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &segs[i].l, &segs[i].r, &p);
        --segs[i].l; assert(p == 1);
    }

    std::sort(segs, segs+n, [](seg_t a, seg_t b) {
                if (a.l != b.l) return a.l < b.l;
                if (a.r != b.r) return a.r > b.r;
                return false;
              });

    if (!test_input(n, k)) {
        printf("-1");
        return 0;
    }

    int l, r;
    l = 0, r = n+1;

    while (r - l > 1) {
        int mid = (l+r)/2;
        if (test(n, k, mid))
            r = mid;
        else
            l = mid;
    }

    printf("%d\n", r);

    return 0;
}
