#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <inttypes.h>
#include <map>
#include <vector>
#include <algorithm>

/// problem "Napoleon"

const int N = 30;
const int64_t INF = 1LL<<60;

int n, k;
struct seg_t {
    int l, r, p;
} segs[N];

struct ev_t {
    int x, t, dp;
} evs[N];

int64_t score(int mask)
{
    int sz = 0;
    for (int i = 0; i < n; ++i)
        if ((mask>>i)&1)
            evs[sz++] = {segs[i].l, 1, segs[i].p},
            evs[sz++] = {segs[i].r, -1, -segs[i].p};
    std::sort(evs, evs+sz, [](ev_t a, ev_t b){
                if (a.x != b.x) return a.x < b.x;
                return a.t < b.t;
              });

    if (evs[0].x != 0 || evs[sz-1].x != k)
        return INF;

    int64_t mx_p = 0;
    int64_t p = 0;
    int cnt = 0;
    for (int i = 0; i < sz; ++i) {
        if (i && evs[i].x != evs[i-1].x && !cnt)
            return INF;
        cnt += evs[i].t;
        p += evs[i].dp;
        mx_p = std::max(mx_p, p);
    }
    return mx_p;
}

int main()
{
    ///assert(freopen("input.txt", "r", stdin));
    scanf("%d%d", &n, &k);

    assert(n <= 12);

    for (int i = 0; i < n; ++i)
        scanf("%d%d%d", &segs[i].l, &segs[i].r, &segs[i].p), --segs[i].l;

    int64_t best = 1LL<<60;

    for (int mask = 0; mask < (1<<n); ++mask)
        best = std::min(best, score(mask));

    if (best == INF)
        best = -1;
    printf("%lld\n", best);

    return 0;
}
