#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <inttypes.h>
#include <vector>
#include <algorithm>

#define EXIT_ASSERT(COND) if (!(COND)) exit(0)

/// problem "Panna Cotta"

void qu(int64_t& a, int64_t& b, int64_t x)
{
    if (x > 1e18) {
        a = 0; b = 0;
        return;
    }
    printf("X %lld\n", x); fflush(stdout);
    scanf("%lld", &a); EXIT_ASSERT(a != -1);
    scanf("%lld", &b);
}

void put_res(int64_t val)
{
    printf("N %lld\n", val); fflush(stdout);
    char buf[10];
    scanf("%s", buf); EXIT_ASSERT(buf[0] != 'W');
}

int64_t gcd(register int64_t a, register int64_t b)
{
    register int64_t c;
    while (a != 0)
        c = a,
        a = b%a,
        b = c;
    return b;
}

inline
int64_t lca(int64_t a, int64_t b)
{
    return (a/gcd(a, b))*b;
}


void solve()
{
    int64_t a, b;
    int l, r;
    l = 0, r = 60;
    int64_t d = 1;
    while (r - l > 1) {
        int mid = (l+r)/2;
        qu(a, b, 1LL<<mid);
        d = lca(b, d);
        if (a)
            l = mid;
        else
            r = mid;
    }
    put_res(d);
}

int main()
{
    ///assert(freopen("input.txt", "r", stdin));

    int g; scanf("%d", &g);
    while (g--) solve();

    return 0;
}
