#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template <typename T>
inline ostream &operator << (ostream & out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T>
inline ostream &operator << (ostream & out, const set <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << endl;
    return out;
}

template <typename T1, typename T2>
inline ostream & operator << (ostream &out, const pair <T1, T2> &p) {
    out << p.fi << ' ' << p.se << endl;
}


struct segment
{
    int l, r, weight;
    segment (int a, int b, int c) {
        tie(l, r, weight) = make_tuple(a, b, c);
    }
    bool operator < (const segment &other) const {
        if(l == other.l) {
            if(r == other.r)
                return weight < other.weight;
            return r < other.r;
        }
        return l < other.l;
    }
};

int n, k;

vector <segment> segments;

bool all_good() {
    for(auto to: segments)
        if(to.weight != 1)
            return false;
    return true;
}

void easy_solve() {
    int cur_r = 1;
    for(int i = 0;i < sz(segments);) {
        int j = i - 1;
        while(j < sz(segments) - 1 && segments[j + 1].l == cur_r)
            j++;
        if(j == i - 1)
            break;
        cur_r = segments[j].r + 1;

        i = j + 1;
    }
    if(cur_r > k)
        cout << 1;
    else
        cout << 2;
}

bool can_cover() {
    int cur_r = 1;
    for(int i = 0;i < sz(segments); ++i) {
        if(segments[i].l <= cur_r)
            cur_r = max(cur_r, segments[i].r + 1);
    }
    return (cur_r > k);
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    cin >> n >> k;
    segments.assign(n, segment(0, 0, 0));
    int l, r, w;
    for(int i = 0;i < n; ++i) {
        cin >> l >> r >> w;
        segments[i] = segment(l, r, w);
    }
    sort(segments.begin(), segments.end());
    if(!can_cover()) {
        cout << -1;
        return 0;
    }
    if(all_good())
        easy_solve();
    return 0;
}
