#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

struct q {
	int l, r, p;
	q() {}
	q(int const& l, int const& r, int const& p) : l(l), r(r), p(p) {}
	bool operator <(q const& o) const {
		if (l != o.l) return l < o.l;
		if (r != o.r) return r < o.r;
		return p < o.p;
	}
};

q query[3010];
ll h[1000100];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		int l, r, p;
		cin >> l >> r >> p;
		query[i] = q(l, r, p);
	}
	int ans = INF;
	for (int mask = 0; mask < (1 << n); mask++) {
		int cur = 0;
		for (int i = 1; i <= k; i++) h[i] = 0;
		for (int i = 0; i < n; i++) if (mask & (1 << i)) for (int pos = query[i].l; pos <= query[i].r; pos++) h[pos] += query[i].p;
		for (int i = 1; i <= k; i++) if (!h[i]) cur = INF; else cur = max(cur, h[i]);
		ans = min(ans, cur);
	}
	cout << ans;
	return 0;
}