#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <string>
#include <initializer_list>
#include <cassert>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef long double ld;
typedef pair <int, int> par;
typedef pair <ll, ll> parll;

int const INF = 1e9 + 7;
ll const LLINF = 1e18;
int const mod = 1e9 + 9;
int const ph = 257;
ld const eps = 1e-8;

bool operator == (par a, par b) {
	return a.first == b.first && a.second == b.second;
}
bool operator != (par a, par b) {
	return a.first != b.first || a.second != b.second;
}
par operator + (par a, par b) {
	return{ a.first + b.first, a.second + b.second };
}
par operator - (par a, par b) {
	return{ a.first - b.first, a.second - b.second };
}

namespace std {
	using std::hash;
	using std::size_t;
	template <>
	struct hash<par> {
		size_t operator ()(par const& a) const {
			return (1LL * hash<int>()(a.first) * ph + hash<int>()(a.second)) % mod;
		}
	};
}

struct q {
	int l, r, p;
	q() {}
	q(int const& l, int const& r, int const& p) : l(l), r(r), p(p) {}
	bool operator <(q const& o) const {
		if (l != o.l) return l < o.l;
		if (r != o.r) return r < o.r;
		return p < o.p;
	}
};

q query[3010];
vector <par> line;
queue <int> es;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		int l, r, p;
		cin >> l >> r >> p;
		query[i] = q(l, r, p);
		line.push_back({ l, 0 });
		line.push_back({ r, 1 });
	}
	sort(line.begin(), line.end());
	int op = 0;
	int prev = line[0].first;
	if (line[0].first != 1 || line.back().first != k) {
		cout << -1;
		return 0;
	}
	for (int i = 0; i < line.size(); i++) {
		if (line[i].second == 0) op++; else op--;
		if (op == 1 && line[i - 1].second == 1 && line[i - 1].first < line[i].first) {
			cout << -1;
			return 0;
		}
	}
	es.push(0);
	while (!es.empty()) {
		int en = es.front();
		es.pop();
		if (en == k) {
			cout << 1;
			return 0;
		}
		for (int i = 0; i < n; i++) if (query[i].l == en + 1) es.push(query[i].r);
	}
	cout << 2;
	//cout << ans;
	return 0;
}