#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)2e5 + 7;
const int inf = (int)1e9 + 7;

int A[dd], l[dd];
int T[4 * dd], psh[4 * dd];

void build(int v, int tl, int tr) {
	T[v] = inf;
	psh[v] = -1;
	if (tl != tr) {
		int tm = (tl + tr) / 2;
		build(v * 2, tl, tm);
		build(v * 2 + 1, tm + 1, tr);
	}
}

void push(int v, int tl, int tr) {
	if (psh[v] == -1) return;
	T[v] = psh[v];
	if (tl != tr)
		psh[v * 2] = psh[v * 2 + 1] = psh[v];
	psh[v] = -1;
}

int get(int v, int tl, int tr, int M) {
	push(v, tl, tr);
	if (tl == tr)
		return tl;
	int tm = (tl + tr) / 2;
	push(v * 2 + 1, tm + 1, tr);
	if (T[v * 2 + 1] < M)
		return get(v * 2 + 1, tm + 1, tr, M);
	return get(v * 2, tl, tm, M);
}

int get_pt(int v, int tl, int tr, int pos) {
	push(v, tl, tr);
	if (tl == tr)
		return T[v];
	int tm = (tl + tr) / 2;
	if (pos <= tm)
		return get_pt(v * 2, tl, tm, pos);
	return get_pt(v * 2 + 1, tm + 1, tr, pos);
}

void st(int v, int tl, int tr, int l, int r, int val) {
	if (tl == l && tr == r) {
		psh[v] = val;
		push(v, tl, tr);
	} else {
		push(v, tl, tr);
		int tm = (tl + tr) / 2;
		if (r <= tm)
			st(v * 2, tl, tm, l, r, val);
		else if (l > tm)
			st(v * 2 + 1, tm + 1, tr, l, r, val);
		else
			st(v * 2, tl, tm, l, tm, val), st(v * 2 + 1, tm + 1, tr, tm + 1, r, val);
		push(v * 2, tl, tm);
		push(v * 2 + 1, tm + 1, tr);
		T[v] = min(T[v * 2], T[v * 2 + 1]);
	}
}

int solve() {
	int n;
	scanf("%d", &n);
	int mx = 0;
	for (int i = 0; i < n; ++i)
		scanf("%d", &l[i]), mx = max(mx, l[i]);

	int L = 0, R = n;

	while (R - L > 1) {

		int M = (R + L) / 2;

		build(1, 0, mx - 1);
		st(1, 0, mx - 1, 0, l[0] - 1, 1);

		for (int ii = 1; ii < n; ++ii) {
			if (l[ii] > l[ii - 1])
				st(1, 0, mx - 1, l[ii - 1], l[ii] - 1, 1);
			else {

				if (l[ii] < mx) st(1, 0, mx - 1, l[ii], mx - 1, inf);

				push(1, 0, mx - 1);
				if (T[1] >= M) {
					L = M;
					break;
				}

				int pos = get(1, 0, mx - 1, M);
				int X = get_pt(1, 0, mx - 1, pos);

				st(1, 0, mx - 1, pos, pos, X + 1);
				if (pos + 1 <= l[ii] - 1)
					st(1, 0, mx - 1, pos + 1, l[ii] - 1, 1);

			}
		}
		if (L != M) R = M;
	}
	printf("%d", R);
	return 0;
}
