#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <cassert>
#include <numeric>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef PoDuReM
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	return solve();
}

const int dd = (int)1e5 + 7;
const int inf = (int)1e9 + 7;

int A[dd], l[dd];

struct node {
	int v, psh;
	int l, r;

	node() {
		v = psh = -1;
		l = r = -1;
	}
} ST[(int)12e6];
int cnt = 1;

void push(node &v, int tl, int tr) {
	if (v.psh == -1) return;
	v.v = v.psh;
	if (tl != tr) {
		if (v.l == -1)
			v.l = cnt++;
		if (v.r == -1)
			v.r = cnt++;
		ST[v.l].psh = ST[v.r].psh = v.psh;
	}
	v.psh = -1;
}

int pos;

void get(node &v, int tl, int tr, int M) {
	push(v, tl, tr);
	if (tl == tr) {
		v.v++;
		return void(pos = tl);
	}
	int tm = (tl + tr) / 2;
	push(ST[v.r], tm + 1, tr);
	if (ST[v.r].v < M)
		get(ST[v.r], tm + 1, tr, M);
	else
		get(ST[v.l], tl, tm, M);
	
	push(ST[v.l], tl, tm), push(ST[v.r], tm + 1, tr);
	v.v = min(ST[v.l].v, ST[v.r].v);
}

void st(node &v, int tl, int tr, int l, int r, int val) {
	if (tl == l && tr == r) {
		v.psh = val;
		push(v, tl, tr);
	} else {
		push(v, tl, tr);
		int tm = (tl + tr) / 2;
		if (r <= tm)
			st(ST[v.l], tl, tm, l, r, val);
		else if (l > tm)
			st(ST[v.r], tm + 1, tr, l, r, val);
		else
			st(ST[v.l], tl, tm, l, tm, val), st(ST[v.r], tm + 1, tr, tm + 1, r, val);
		push(ST[v.l], tl, tm);
		push(ST[v.r], tm + 1, tr);
		v.v = min(ST[v.l].v, ST[v.r].v);
	}
}

int solve() {
	ST[0] = node();
	int n;
	scanf("%d", &n);
	int mx = 0;
	for (int i = 0; i < n; ++i)
		scanf("%d", &l[i]), mx = max(mx, l[i]);

	int L = 0, R = n;

	while (R - L > 1) {

		int M = (R + L) / 2;

		//build(1, 0, mx - 1);
		st(ST[0], 0, mx - 1, 0, mx - 1, inf);
		st(ST[0], 0, mx - 1, 0, l[0] - 1, 1);

		for (int ii = 1; ii < n; ++ii) {
			if (l[ii] > l[ii - 1])
				st(ST[0], 0, mx - 1, l[ii - 1], l[ii] - 1, 1);
			else {

				if (l[ii] < mx) st(ST[0], 0, mx - 1, l[ii], mx - 1, inf);

				push(ST[0], 0, mx - 1);
				if (ST[0].v >= M) {
					L = M;
					break;
				}

				get(ST[0], 0, mx - 1, M);

				if (pos + 1 <= l[ii] - 1)
					st(ST[0], 0, mx - 1, pos + 1, l[ii] - 1, 1);

			}
		}
		if (L != M) R = M;
	}
	printf("%d", R);
	//printf("\n%.10f", 1.0 * clock() / CLOCKS_PER_SEC);
	return 0;
}
