#include <iostream>
#include <vector>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
#define mp make_pair
#define pb push_back

typedef long long int64;

struct Ferm {
	int l, r, p;
	Ferm(int l = 0, int r = 0, int p = 0) {
		this->l = l;
		this->r = r;
		this->p = p;
	}
};

bool comp(Ferm a, Ferm b) {
	if (a.l < b.l)
		return true;
	if (a.l == b.l && a.r > b.r)
		return true;
	return false;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector < Ferm > f(n);
	for (int i = 0; i < n; i++) {
		cin >> f[i].l >> f[i].r >> f[i].p;
	}
	sort(f.begin(), f.end(), comp);
	bool exist = 0;
	int maxp = 100000000;
	for (int mask = 0; mask < (1 << n); mask++) {
		vector < Ferm > cur;
		for (int i = 0; i < n; i++) {
			if ((1 << i) & mask) {
				cur.pb(f[i]);
			}
		}
		int ost = 0;
		int maxr = 0;
		for (int i = 0; i < cur.size(); i++) {
			if (cur[i].l > maxr) {
				ost += (cur[i].l - maxr - 1);
			}
			maxr = max(maxr, cur[i].r);
		}
		ost += max(0, k - maxr);
		if (ost == 0) {
			exist = 1;
			int curpa = 0, curpb = 0, curmaxp = 0;
			for (int i = 0; i < cur.size(); i++) {
				int a, b;
				a = cur[i].l;
				b = cur[i].r;
				curpa = 0;
				curpb = 0;
				for (int j = 0; j < cur.size(); j++) {
					if (cur[j].l <= a && cur[j].r >= a) {
						curpa += cur[j].p;
					}
					if (cur[j].l <= b && cur[j].r >= b) {
						curpb += cur[j].p;
					}
				}
				curmaxp = max(curmaxp, curpa);
				curmaxp = max(curmaxp, curpb);
			}
			maxp = min(maxp, curmaxp);
		}
	}
	if (exist) {
		cout << maxp;
	}
	else {
		cout << -1;
	}
	cout << "";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

