#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair <int, int>
#define pll pair <long long, long long>
#define pld pair <long double, long double>
#define pb push_back
#define ff first
#define ss second
#define ppiii pair < pair <long long, long long> , long long>

int n, k;
vector <ppiii> segm, segm2;

const long long INF = 100000000000000;

void go(long long val)
{
    cout << val;
    exit(0);
}

void solve1()
{
    map <long long, long long> start;
    sort(segm.begin(), segm.end());
    for(int i = n - 1; i >= 0; i--)
    {
        //cout << "Now seg: " << segm[i].first.first << " " << segm[i].first.second << endl;
        start[segm[i].first.first] = max(start[segm[i].first.first], max(start[segm[i].first.second + 1], segm[i].first.second));
    }
    if(start[1] >= k)
    {
        go(1);
    }

    //check pos 2
    if(segm[0].first.first > 1)
    {
        go(-1);
    }
    long long theend = segm[0].first.second;
    for(int i = 1; i < n; i++)
    {
        if(segm[i].first.first <= theend + 1)
        {
            theend = max(theend, segm[i].first.second);
        }
    }
    if(theend >= k)
    {
        go(2);
    }
    else
    {
        go(-1);
    }
}

bool check(long long val)
{
    vector <pll> dp(n);
    for(int i = 0; i < n; i++)
    {
        if(segm[i].first.first == 1)
            dp[i] = {segm[i].second, -1};
        else
        {
            long long opt = INF;
            long long optprev = -1;
            for(int j = 0; j < i; j++)
            {
                if(dp[j].first == INF) continue;
                if((dp[j].second >= 0) ? segm[dp[j].second].first.second : -1 >= segm[i].first.first) continue;
                if(segm[j].first.second < segm[i].first.first - 1) continue;
                else if(segm[j].first.second == segm[i].first.first - 1)
                {
                    if(max(segm[i].second, dp[j].first) < opt)
                    {
                        opt = max(segm[j].second, dp[j].first);
                        optprev = j;
                    }
                }
                else
                {
                    if(max(segm[i].second + segm[j].second, dp[j].first) < opt)
                    {
                        opt = max(segm[i].second + segm[j].second, dp[j].first);
                        optprev = j;
                    }
                }
            }
            if(opt <= val)
                dp[i] = {opt, optprev};
            else
                dp[i] = {INF, -1};
        }
    }
    for(int i = 0; i < n; i++)
    {
        if(dp[i].first <= val and segm[i].first.second == k)
            return true;
    }
    return false;
}

void cleversolve()
{
    sort(segm.begin(), segm.end());
    long long l = 0, r = INF;
    while(r > l + 1)
    {
        long long m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m;
    }
    if(r == INF)
        go(-1);
    else
        go(r);
    //cout << check(1);
}

int main()
{
    bool onlyone = true;
    cin >> n >> k;
    segm.resize(n);
    segm2.resize(n);
    for(int i = 0; i < n; i++)
    {
        cin >> segm[i].first.first >> segm[i].first.second >> segm[i].second;
        if(segm[i].second != 1) onlyone = false;
    }
    /*for(int i = 0; i < n; i++)
    {
        segm2[i] = segm[i];
        swap(segm2[i].first.first, segm2[i].first.second);
    }*/

    //go
    if(onlyone)
        solve1();
    else
        cleversolve();

    return 0;
}
