#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair <int, int>
#define pll pair <long long, long long>
#define pld pair <long double, long double>
#define pb push_back
#define ff first
#define ss second
#define ppiii pair < pair <long long, long long> , long long>

long long n, k;
vector < pair < pair <long long, long long> , long long > > segm;

const long long INF = 1000000000;

void go(long long val)
{
    cout << val;
    exit(0);
}

void solve1()
{
    map <long long, long long> start;
    sort(segm.begin(), segm.end());
    for(int i = n - 1; i >= 0; i--)
    {
        //cout << "Now seg: " << segm[i].first.first << " " << segm[i].first.second << endl;
        start[segm[i].first.first] = max(start[segm[i].first.first], max(start[segm[i].first.second + 1], segm[i].first.second));
    }
    if(start[1] >= k)
    {
        go(1);
    }

    //check pos 2
    if(segm[0].first.first > 1)
    {
        go(-1);
    }
    long long theend = segm[0].first.second;
    for(int i = 1; i < n; i++)
    {
        if(segm[i].first.first <= theend + 1)
        {
            theend = max(theend, segm[i].first.second);
        }
    }
    if(theend >= k)
    {
        go(2);
    }
    else
    {
        go(-1);
    }
}

bool check(long long val)
{
    //cout << "checking pos for " << val << endl;
    vector <pll> dp(n);
    for(int i = 0; i < n; i++)
        dp[i] = {INF * INF, -1};
    for(int i = 0; i < n; i++)
    {
        //cout << "incycle" << endl;
        if(segm[i].first.first == 1)
            dp[i] = {segm[i].second, -1};
        else
        {
            //cout << "updating long way" << endl;
            long long opt = INF * INF;
            long long optprev = -1;
            for(int j = 0; j < i; j++)
            {
                if(dp[j].first == INF * INF)
                {
                    //cout << "inf-breack\n";
                    continue;
                }
                if(((dp[j].second >= 0) ? segm[dp[j].second].first.second : -1) >= segm[i].first.first)
                {
                    //cout << "prev-inter breach\n";
                    continue;
                }
                if(segm[j].first.second < segm[i].first.first - 1)
                {
                    //cout << "non-intersect\n";
                    continue;
                }
                else if(segm[j].first.second == segm[i].first.first - 1)
                {
                    //cout << "updating in noncross" << endl;
                    if(max(segm[i].second, dp[j].first) < opt)
                    {
                        opt = max(segm[i].second, dp[j].first);
                        optprev = j;
                    }
                }
                else
                {
                    //cout << "updating in cross" << endl;
                    //cout << max(segm[i].second + segm[j].second, dp[j].first) << " " << opt << endl;
                    if(max(segm[i].second + segm[j].second, dp[j].first) < opt)
                    {
                        opt = max(segm[i].second + segm[j].second, dp[j].first);
                        optprev = j;
                    }
                }
            }

            if(opt <= val)
                dp[i] = {opt, optprev};
            else
                dp[i] = {INF * INF, -1};
        }
        //cout << "given dp: " << dp[i].first << endl;
        //cout << "i: " << i << " " << dp[i].first << " " << dp[i].second << endl;
    }
    //cout << "-----\n";
    for(int i = 0; i < n; i++)
    {
        //cout << dp[i].first << " ";
        if(dp[i].first <= val and segm[i].first.second == k)
            return true;
    }
    return false;
}

void cleversolve()
{
    sort(segm.begin(), segm.end());
    long long l = 0, r = INF * INF;
    while(r > l + 1)
    {
        long long m = (l + r) / 2;
        if(check(m))
            r = m;
        else
            l = m;
    }
    if(r == INF * INF)
        go(-1);
    else
        go(r);
    //cout << check(1);
}

int main()
{
    bool onlyone = true;
    cin >> n >> k;
    segm.resize(n);

    for(int i = 0; i < n; i++)
    {
        cin >> segm[i].first.first >> segm[i].first.second >> segm[i].second;
        if(segm[i].second != 1) onlyone = false;
    }

    /*for(int i = 0; i < n; i++)
        cout << segm[i].first.first << " " << segm[i].first.second << " " << segm[i].second << endl;*/

    //go
    if(!onlyone)
        cleversolve();
    else
        solve1();

    return 0;
}
