#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <cstdio>

#define X first
#define Y first
#define pb push_back
#define all(v) v.begin(),v.end()
#define fors(a,b,c) for(int a = b; a < c; ++a)

using namespace std;

typedef long long ll;
typedef long double ld;

int n;
vector<ll> arr;
int j = 0;

struct Tree {
    int sizet = 1;
    vector<int> t, p;

    Tree(int n) {
        while (sizet < n) {
            sizet *= 2;
        }
        t.resize(2 * sizet, 1e9);
        p.resize(2 * sizet, -1);
    }

    void push(int v) {
        if (v >= 2 * sizet)
            return;

        if (p[v] != -1) {
            t[v] = p[v];

            if (v < sizet) {
                p[2 * v] = p[v];
                p[2 * v + 1] = p[v];
            }
            p[v] = -1;
        }
    }

    void sets(int v, int tl, int tr, int l, int r, int sums) {
        push(v);
        if (tl > r || tr < l) {
            return;
        }

        if (tl >= l && tr <= r) {
            p[v] = sums;
            push(v);
            return;
        }

        int mid = (tl + tr) / 2;
        sets(2 * v, tl, mid, l, r, sums);
        sets(2 * v + 1, mid + 1, tr, l, r, sums);
        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    void inc(int v, int tl, int tr, int pos) {
        push(v);
        if (tl == tr) {
            t[v]++;
            return;
        }

        push(2 * v + 1);
        push(2 * v);

        int mid = (tl + tr) / 2;
        if (pos <= mid) {
            inc(2 * v, tl, mid, pos);
        } else {
            inc(2 * v + 1, tl, mid, pos);
        }

        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    int finds(int v, int tl, int tr, int f) {
        push(v);
        if (tl == tr) {
            if (t[v] != f) {
                return tl;
            }
            return -1;
        }

        int mid = (tl + tr) / 2;
        push(2 * v + 1);
        push(2 * v);
        if (t[2 * v + 1] < f) {
            return finds(2 * v + 1, mid + 1, tr, f);
        } else {
            return finds(2 * v, tl, mid, f);
        }
    }
};


bool check(ll f) {
    Tree *last = new Tree(2e5 + 1);
    int sz = 0;
    for (int i = 0; i < n; ++i) {
        if (arr[i] > sz) {
            last->sets(1, 0, last->sizet - 1, sz, arr[i] - 1, 1);
            sz = arr[i];
        } else {
            if (arr[i] != sz) {
                last->sets(1, 0, last->sizet - 1, arr[i], sz - 1, 1e9);
            }
            sz = arr[i];

            int finds = last->finds(1, 0, last->sizet - 1,  f);

            if (finds == -1) {
                return false;
            }

            last->inc(1, 0, last->sizet - 1, finds);
            last->sets(1, 0, last->sizet - 1, finds + 1, sz - 1, 1);
        }
    }
    return true;
}

int main() {
    //ifstream cin("input.txt");
    //ofstream cout("output.txt");

    cin.tie(0);
    ios_base::sync_with_stdio(false);

    cin >> n;
    arr.resize(n);

    for (ll &x : arr) {
        cin >> x;
    }
    int l = 0, r = 2e5 + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        j = 0;
        if (check(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r << endl;

    return 0;
}
