#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <random>
#include <map>
#include <set>
#include <cstdio>
#include <deque>
#include <fstream>

#define pb push_back
#define all(v) v.begin(),v.end()

using namespace std;

const int MAXN = 1e5 + 100;
typedef long long ll;

struct T {
    int l, r, c;

    T(int l, int r, int c) : l(l), r(r), c(c) {}
};

int n, m;

vector<int> p;
vector<T> arr;

bool cmp(T a, T b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

ll ans = 1e18;

void check() {
    vector<T> f;
    for (int i = 0; i < n; ++i) {
        if(p[i] == 1) {
            f.pb({arr[i].l, -1, arr[i].c});
            f.pb({arr[i].r, 1, arr[i].c});
        }
    }
    sort(all(f), cmp);

    int pos = 0;
    int bal = 0;
    ll nows = 0, max_nows = 0;
    for (auto x : f) {
        if (bal == 0 && x.l - pos > 1) {
            return;
        }
        pos = x.l;

        if (x.r == -1) {
            bal++;
            nows += x.c;
        } else {
            bal--;
            nows -= x.c;
        }
        max_nows = max(max_nows, nows);
    }
    if (pos < m) {
        return;
    }

    ans = min(ans, max_nows);
}

void gen(int nows, int lens) {
    if (nows == lens) {
        check();
        return;
    }

    p.pb(0);
    gen(nows + 1, lens);
    p.pop_back();
    p.pb(1);
    gen(nows + 1, lens);
    p.pop_back();
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;

    int l, r, c;
    for (int i = 0; i < n; ++i) {
        cin >> l >> r >> c;
        arr.pb({l, r, c});
    }
    gen(0, n);
    if (ans == 1e18) {
        cout << -1;
        return 0;
    }
    cout << ans << endl;
    return 0;
}
