#include <iostream>
#include <vector>
#include <set>
#include <map>


using namespace std;


const int INF = 2e9 + 15;


struct Node
{
	vector<pair<int, int>> go;
	int vis = 0;
	Node() {};
};

map<int, Node> g;


void dfs(int v, int id)
{
	//cerr << "V: " << v << ' ' << id << endl;
	g[v].vis = id;
	for (auto i : g[v].go)
	{
		//cerr << "-> " << i.first << ' ' << i.second << endl;
		if (!g[i.first].vis != id && i.second <= id)
		{
			dfs(i.first, id);
		}
	}
}


int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> s;
	for (int i = 0; i < n; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		s.push_back({a, b + 1, c});
	}
	for (int i = 0; i < n; i++)
	{
		g[s[i][0]].go.push_back({s[i][1], s[i][2]});
		for (int j = 0; j < n; j++)
		{
			if (s[i][0] < s[j][0] &&
				s[j][0] < s[i][1] && 
				s[i][1] < s[j][1])
			{
				g[s[i][1]].go.push_back({s[j][1], s[j][2] + s[i][2]});
			}
		}
	}
	int l = -2;
	int r = INF;
	while (r - l > 1)
	{
		int md = l + (r - l) / 2;
		//cerr << endl;
		dfs(1, md);
		if (g[m + 1].vis == md)
		{
			r = md;
		}
		else
		{
			l = md;
		}
	}
	cout << (r == INF ? -1 : r) << endl;
}