#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxn = 1e5 + 100, inf = 1e9 + 100;

struct treap{
    int v, mn, x, y;
    treap *l, *r;
};

typedef treap * ptr;

ll A = 53, B = 43, C = 323, X = 13, Y = 23, MOD = 1e9 + 993;

ll myrand(){
    ll Z = (A * X + B * Y + C) % MOD;
    X = Y;
    Y = Z;
    return Z;
}

ptr create(int v, int x){
    ptr t = new treap;
    t->v = v;
    t->x = x;
    t->mn = v;
    t->y = myrand();
    t->l = nullptr;
    t->r = nullptr;
    return t;
}

int mn(ptr t){
    return t == nullptr ? 0 : t->mn;
}

void upd(ptr &t){
    if (t != nullptr)
        t->mn = min(t->v, min(mn(t->l), mn(t->r)));
}

void split(ptr t, ptr &l,  ptr &r, int key){
    if (t == nullptr){
        l = nullptr;
        r = nullptr;
        return;
    }
    if (t->x <= key)
        split(t->r, t->r, r, key), l = t;
    else
        split(t->l, l, t->l, key), r = t;
    upd(l);
    upd(r);
}

void merge(ptr &t, ptr l, ptr r){
    if (l == nullptr){
        t = r;
        return;
    }
    if (r == nullptr){
        t = l;
        return;
    }
    if (l->y <= r->y)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;
    upd(t);
}

ptr insert(ptr &t, ptr ins){
    ptr t1, t2;
    split(t, t1, t2, ins->x);
    merge(t, t1, ins);
    merge(t, t, t2);
    return t;
    if (t == nullptr)
        return ins;
    if (t->y >= ins->y){
        split(t, ins->l, ins->r, ins->x);
        upd(ins);
        return ins;
    }
    if (ins->x <= t->x)
        t->l = insert(t->l, ins);
    else
        t->r = insert(t->r, ins);
    upd(t);
    return t;
}

void cl(ptr &t){
    if (t == nullptr)
        return;
    cl(t->l);
    cl(t->r);
    ptr s = nullptr;
    swap(s, t);
}

int findmn(ptr &t, int val){
    if (t == nullptr)
        return inf;
    if (t->x > val)
        return findmn(t->l, val);
    return min(mn(t->l), min(t->v, findmn(t->r, val)));
}

int n, kek;

pair<pair<int, int>, int> a[maxn];

map<int, int> mp;

int mas[2 * maxn], cnt;

ptr q[8 * maxn];

void build(int v, int l, int r){
    cl(q[v]);
    if (l == r)
        return;
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

void update(int v, int tl, int tr, int l, int r, pair<int, int> val){
    if (l > r)
        return;
    if (tl == l && tr == r){
        q[v] = insert(q[v], create(val.second, val.first));
        return;
    }
    int m = (tl + tr) / 2;
    update(2 * v, tl, m, l, min(r, m), val);
    update(2 * v + 1, m + 1, tr, max(l, m + 1), r, val);
}

int get(int v, int l, int r, int ind, int val){
    int ret = findmn(q[v], val);
    if (l == r)
        return ret;
    int m = (l + r) / 2;
    if (ind <= m)
        return min(ret, get(2 * v, l, m, ind, val));
    return min(ret, get(2 * v + 1, m + 1, r, ind, val));
}

bool check(int val){
    build(1, 0, cnt - 1);
    update(1, 0, cnt - 1, 0, 0, make_pair(0, -1));
    for (int i = 0; i < n; i++){
        int x = get(1, 0, cnt - 1, a[i].first.first, val - a[i].second);
        if (x < a[i].first.second){
            if (a[i].first.second == cnt - 1)
                return 1;
            update(1, 0, cnt - 1, max(a[i].first.first, x) + 1, a[i].first.second, make_pair(a[i].second, a[i].first.second));
            update(1, 0, cnt - 1, a[i].first.second + 1, a[i].first.second + 1, make_pair(0, a[i].first.second));
        }
    }
    return 0;
}

int main()
{
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    ios::sync_with_stdio(0);
    cin >> n >> kek;
    for (int i = 0; i < n; i++)
        cin >> a[i].first.first >> a[i].first.second >> a[i].second, mas[2 * i] = a[i].first.first, mas[2 * i + 1] = a[i].first.second;
    mas[2 * n] = kek;
    mas[2 * n + 1] = 1;
    sort(mas, mas + 2 * n + 2);
    for (int i = 0; i < 2 * n + 2; i++)
        if (i == 0 || mas[i] != mas[i - 1])
            mp[mas[i]] = cnt, cnt++;
    for (int i = 0; i < n; i++)
        a[i].first.first = mp[a[i].first.first], a[i].first.second = mp[a[i].first.second];
    sort(a, a + n);
    ll l = 0, r = 2e9 + 1;
    while (r - l > 1){
        ll m = (l + r) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }
    if (r == 2e9 + 1)
        r = -1;
    cout << r;
}
