#include <bits/stdc++.h>
#define pb push_back
#define x first
#define y second
#define mp make_pair
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
 
using namespace std;

const string FILENAME = "input";

typedef pair <int, int> point;
typedef long long base;

const int MAXN = 1 << 18;

int n;
int arr[MAXN + 1];

struct seg_tree {
	int mod[MAXN * 2];
	seg_tree() {}
	void push(int i) {
		if (i > MAXN) 
			return;
		if (mod[i] != -1) {
			mod[i * 2] = mod[i * 2 + 1] = mod[i];
			mod[i] = -1;
		}
	}
	int get(int j) {
		int i = MAXN + j;
		vector <int> id;
		while (i > 0) {
			id.pb(i);
			i >>= 1;
		}
		for (int q = id.size(); q--;) {
			push(q);
		}
		return mod[id[0]];
	}
	void change(int i, int L, int R, int Ln, int Rn, int d) {
		if (R <= Ln || Rn <= L) return;
		if (Ln <= L && R <= Rn) {
			mod[i] = d;
			return;
		}
		push(i);
		int M = (L + R) >> 1;
		change(i * 2, L, M, Ln, Rn, d);
		change(i * 2 + 1, M, R, Ln, Rn, d);
	}
};

seg_tree box;

bool check(int M) {
	//cout << M << endl;
	for (int i = 0; i < n; ++i) {
		if (i == 0) {
			box.mod[1] = 0;
		} else {
			if (arr[i - 1] < arr[i]) {
				box.change(1, 0, MAXN, arr[i - 1], arr[i], 0);
			} else {
				int j = arr[i] - 1;
				int carry = 1;
				while (j >= 0 && carry) {
					int a = box.get(j);
					++a;
					if (a == M) {
						a = 0;
						carry = 1;
					} else {
						carry = 0;
					}
					box.mod[j + MAXN] = a;
					--j;
				}
				if (carry) return false;
			}
		}
		// for (int j = 0; j < arr[i]; ++j) {
		// 	cout << box.get(j) << ' ';
		// }
		// cout << endl;
	}
	return true;
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
		arr[i] = min(arr[i], (int)2e5);
	}
	int L = 0, R = n;
	while (R - L > 1) {
		int M = (L + R) >> 1;
		if (check(M)) {
			R = M;
		} else {
			L = M;
		}
	}
	cout << R << endl;
}