#include <bits/stdc++.h>
#define pb push_back
#define x first
#define y second
#define mp make_pair
#define read(FILENAME) freopen((FILENAME + ".in").c_str(), "r", stdin)
#define write(FILENAME) freopen((FILENAME + ".out").c_str(), "w", stdout)
#define files(FILENAME) read(FILENAME), write(FILENAME)
 
using namespace std;

const string FILENAME = "input";

typedef pair <int, int> point;
typedef long long base;

const int MAXN = 1 << 17;

int n, k;
vector <pair <point, int>> arr;

int R[MAXN];
set <int> ans;
set <pair <int, int>> event;

struct seg_tree {
	int tree[MAXN * 2];
	multiset <int> res[MAXN];
	vector <int> p;
	seg_tree() {}
	void clear() {
		for (int i = 0; i < MAXN * 2; ++i) {
			tree[i] = 2e9;
			if (i < MAXN) {
				res[i].clear();
				res[i].insert(2e9);
			}
		}
	}
	int get_id(int d) {
		int j = lower_bound(p.begin(), p.end(), d) - p.begin();
		assert(j < p.size() && p[j] == d);
		return j;
	}
	int get(int i, int L, int R, int d) {
		if (p[L] > d) return 2e9;
		if (p[R - 1] <= d) return tree[i];
		int M = (L + R) >> 1;
		return min(get(i * 2, L, M, d), get(i * 2 + 1, M, R, d));
	}
	void update(int i) {
		i += MAXN;
		tree[i] = *res[i - MAXN].begin();
		while (i > 1) {
			i >>= 1;
			tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
		}
	}
	void insert(int i, int d) {
		i = get_id(i);
		res[i].insert(d);
		update(i);
	}
	void erase(int i, int d) {
		i = get_id(i);
		res[i].erase(res[i].find(d));
		update(i);
	}
};

seg_tree box;

bool check(int M) {
	ans.clear();
	event.clear();
	box.clear();
	ans.insert(0);
	for (int i = 0; i < n; ++i) {
		if (arr[i].y > M) continue;
		event.insert({arr[i].x.x, i});
	}
	while (event.size()) {
		auto u = *event.begin();
		event.erase(event.begin());
		if (u.y >= 0) {
			if (ans.count(u.x - 1)) {
				ans.insert(arr[u.y].x.y);
				if (arr[u.y].x.y == k) return true;
				event.insert({u.x, -1e9 - (u.y + 1)});

			} else {
				int Rx = box.get(1, 0, MAXN, M - arr[u.y].y);
				if (Rx < arr[u.y].x.y) {
					if (arr[u.y].x.y == k) return true;
					event.insert({Rx + 1, -1e9 - (u.y + 1)});
				}
			}
		} else {
			u.y += 1e9;
			if (u.y < 0) {
				u.y = -u.y - 1;
				box.insert(arr[u.y].y, arr[u.y].x.y);
				event.insert({arr[u.y].x.y + 1, -1e9 + (u.y + 1)});
			} else {
				u.y -= 1;
				box.erase(arr[u.y].y, arr[u.y].x.y);
			}
		}
	}
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	//read(FILENAME);
	cin >> n >> k;
	arr.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i].x.x >> arr[i].x.y >> arr[i].y;
		box.p.push_back(arr[i].y);
	}
	sort(box.p.begin(), box.p.end());
	while (box.p.size() != MAXN) {
		box.p.push_back(box.p.back());
	}
	int L = 0, R = 2e9 + 1;
	while (R - L > 1) {
		int M = ((long long)R + L) / 2;
		if (check(M)) {
			R = M;
		} else {
			L = M;
		}
	}
	if (L == 2e9) {
		cout << -1 << endl;
	} else {
		cout << R << endl;
	}
} 