#include <iostream>
#include <vector>
#include <set>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <functional>
#include <climits>
#include <cassert>

using namespace std;

typedef unsigned int index;

bool check(size_t m, const vector<size_t> &lens)
{
	vector<pair<index, size_t>> ans = {{1, lens[0]}};
	size_t len = lens[0];
	for (index io = 1; io < lens.size(); io++)
	{
		size_t i = lens[io];
		if (i > len)
		{
			ans.push_back({1, i - len});
			len = i;
		}
		else
		{
			while (len > i)
			{
				if (len - ans.back().second >= i)
				{
					len -= ans.back().second;
					ans.pop_back();
				}
				else
				{
					pair<index, size_t> sw = ans.back();
					sw.second -= len - i;
					ans.back() = sw;
					len = i;
				}
			}
			while (!ans.empty() and ans.back().first == m)
			{
				len -= ans.back().second;
				ans.pop_back();
			}
			if (ans.empty())
				return false;
			ans.back().second--;
			pair<index, size_t> sv = {ans.back().first + 1, 1};
			if (ans.back().second == 0)
				ans.pop_back();
			ans.push_back(sv);
			if (len < i)
			{
				ans.push_back({1, i - len});
				len = i;
			}
		}
	}
	return true;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	size_t n;
	cin >> n;
	vector<size_t> lens(n);
	for (auto &i: lens)
		cin >> i;
	size_t l = 0, r = n;
	while (r - l > 1)
	{
		size_t m = (l + r) / 2;
		if (check(m, lens))
			r = m;
		else
			l = m;
	}
	cout << r << endl;
}
