#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ld long double

struct Node {
    int l;
    int r;
    int p;
    Node(int l, int r, int p) : l(l), r(r), p(p) {}
};

typedef Node * node;

int n, m;
const ll INF = 1e15;
const int MAXM = 1e5 + 1;
node st[MAXM];
map<pair<int, int>, bool> used;
map<pair<int, int>, ll> dp;

inline bool cmp(node a, node b) {
    return a -> l < b -> l;
}

inline int bins(int x) {
    int l = -1;
    int r = n - 1;
    int m;
    while (l + 1 < r) {
        m = (l + r) / 2;
        if (st[m] -> l >= x) {
            r = m;
        }
        else {
            l = m;
        }
    }
    return r;
}

ll lazy_dp(int x, int i) {
    if (i != -1 && st[i] -> r == m) {
        return st[i] -> p;
    }
    if (used[mp(x, i)])
        return dp[mp(x, i)];
    used[mp(x, i)] = 1;
    ll now_ans = 0;
    int maxi = x;
    ll bans = INF;
    if (i != -1) {
        now_ans = st[i] -> p;
        maxi = st[i] -> r;
    }
    int v = bins(x);
    int j = v;
    for (; j < n && st[j] -> l <= maxi; ++j) {
        if (st[j] -> r > maxi) {
            bans = min(bans, max(lazy_dp(maxi + 1, j), st[j] -> p + (maxi == st[j] -> l ? 0 : now_ans)));
        }
    }
    return dp[mp(x, i)] = bans;
}

inline void solve() {
    queue<int> Q;
    map<int, vector<int> > starts;
    for (int i = 0; i < n; ++i) {
        if (st[i] -> l == 0) {
            Q.push(i);
        }
        starts[st[i] -> l].pb(i);
    }
    while (!Q.empty()) {
        int v = Q.front();
        Q.pop();
        if (st[v] -> r == m) {
            cout << 1;
            return;
        }
        int u = st[v] -> r;
        for (int p: starts[u]) {
            Q.push(p);
        }
        starts[u].clear();
    }
    cout << 2;
}

int main() {
    scanf("%d%d", &n, &m);
    int p, q, c;
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &p, &q, &c);
        --p;
        st[i] = new Node(p, q, c);
    }
    sort(st, st + n, cmp);
    if (st[0] -> l != 0) {
        cout << -1;
        return 0;
    }
    if (n <= 5000) {
        ll v = lazy_dp(0, -1);
        if (v >=INF) {
            cout << -1;
        }
        else {
            cout << v;
        }
    }
    else {
        int ptr1 = 1;
        int maxi = st[0] -> r;
        while (ptr1 < n && maxi != m) {
            auto z = st[ptr1++];
            if (z -> l > maxi) {
                cout << -1;
                return 0;
            }
            maxi = max(maxi, z -> r);
        }
        if (maxi != m) {
            cout << -1;
            return 0;
        }
        solve();
    }
}
