#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds;*/

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vvi graph;
typedef vector<char> vc;
typedef pair<int, int> pii;

/* <-----------------------------------------------------------------------------> */

const ll INF = 1e14;
int n, k;

struct Ev
{
    int x, type;
    ll p;

    bool operator < (const Ev & other) const
    {
        if (x != other.x) return x < other.x;
        return type > other.type;
    }
};

struct Pt
{
    int l, r;
    ll p;
};

vector<Pt> pt;

ll cnt(ll m)
{
    ll ans = 0;

    vector<Ev> ev;

    for (int i = 0; i < n; ++i)
        if (m & (1 << i))
        {
            ev.pb({pt[i].l, 1, pt[i].p});
            ev.pb({pt[i].r, -1, pt[i].p});
        }

    sort(all(ev));

    int pr = 0, bal = 0;
    ll cur_p = 0;

    for (Ev & i : ev)
    {
        if (!bal && i.x != pr + 1) return INF;
        pr = i.x;
        bal += i.type;
        if (i.type == 1) cur_p += i.p;
        else cur_p -= i.p;
        ans = max(ans, cur_p);
    }

    if (pr != k) return INF;
    return ans;
}

void solve()
{
    scanf("%d%d", &n, &k);

    pt.resize(n);

    forn (i, n)
        scanf("%d%d%lld", &pt[i].l, &pt[i].r, &pt[i].p);

    ll ans = INF;

    for (int i = 0; i < 1 << n; ++i)
        ans = min(ans, cnt(i));

    if (ans == INF) printf("-1");
    else printf("%lld", ans);
}

/* <-----------------------------------------------------------------------------> */

// #define LOCAL
// #define FILE_NAME

int main()
{
#if defined LOCAL
    freopen("input.txt", "r", stdin);
#elif defined FILE_NAME
    freopen(FILE_NAME".in", "r", stdin);
    freopen(FILE_NAME".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
