#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

/*#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> pbds;*/

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vvi graph;
typedef vector<char> vc;
typedef pair<int, int> pii;

/* <-----------------------------------------------------------------------------> */

const ll INF = 1e14;

struct Pt
{
    int l, r, id;
    ll p;

    bool operator < (const Pt & other) const
    {
        if (l != other.l) return l < other.l;
        if (r != other.r) return r < other.r;
        return id < other.id;
    }
};

graph g;
vector<Pt> pt;
vector<ll> d;

void solve()
{
    int n, k;
    scanf("%d%d", &n, &k);

    g.resize(n + 1);
    d.resize(n + 1, INF);
    pt.resize(n + 1);

    for (int i = 1; i <= n; ++i)
    {
        scanf("%d%d%lld", &pt[i].l, &pt[i].r, &pt[i].p);
        pt[i].id = i;
    }

    for (int i = 1; i <= n; ++i)
        for (int j = i + 1; j <= n; ++j)
            if (pt[j].l <= pt[i].r + 1) g[i].pb(j);

    for (int i = 1; i <= n; ++i)
        if (pt[i].l == 1) g[0].pb(i);

    priority_queue<pair<ll, int> > q;
    q.push({0, 0});
    d[0] = 0;

    while (!q.empty())
    {
        ll cur_d = -q.top().ft;
        int v = q.top().sd;
        q.pop();

        if (cur_d > d[v]) continue;

        for (int & u : g[v])
        {
            ll w;
            if (pt[u].l > pt[v].r) w = pt[u].p - d[v];
            else w = pt[u].p;

            if (d[u] > d[v] + w)
            {
                d[u] = d[v] + w;
                q.push({-d[u], u});
            }
        }
    }

    ll ans = INF;
    for (int i = 1; i <= n; ++i)
        if (pt[i].r == k) ans = min(ans, d[i]);

    if (ans == INF) printf("-1");
    else printf("%lld", ans);
}

/* <-----------------------------------------------------------------------------> */

// #define LOCAL
// #define FILE_NAME

int main()
{
#if defined LOCAL
    freopen("input.txt", "r", stdin);
#elif defined FILE_NAME
    freopen(FILE_NAME".in", "r", stdin);
    freopen(FILE_NAME".out", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
