#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int bin_search(vector <int> &v, int quest, int n) {
    int left, right, mid;
    left = -1;
    right = n;
    while (right - left > 1) {
        mid = (right + left) / 2;
        if (v[mid] >= quest) {
            right = mid;
        }
        else {
            left = mid;
        }
    }
    return right;
}

int main() {
    ifstream fin;
    fin.open("input.txt");
    ofstream fout;
    fout.open("output.txt");
    int n, l_res, r_res, u_res, d_res;
    bool flag;
    pair <int, int> finish;
    string s;
    fin >> n >> s >> finish.first >> finish.second;
    vector <int> l(n + 1);
    vector <int> r(n + 1);
    vector <int> u(n + 1);
    vector <int> d(n + 1);
    l[0] = 0, r[0] = 0, u[0] = 0, d[0] = 0;
    for (int i = 0; i < n; i++) {
        l[i + 1] = l[i];
        r[i + 1] = r[i];
        u[i + 1] = u[i];
        d[i + 1] = d[i];
        if (s[i] == 'L') {
            l[i + 1]++;
        }
        else if (s[i] == 'R') {
            r[i + 1]++;
        }
        else if (s[i] == 'U') {
            u[i + 1]++;
        }
        else if (s[i] == 'D') {
            d[i + 1]++;
        }
    }
    flag = true;
    //cout << l[n] << ' ' << r[n] << ' ' << u[n] << ' ' << d[n] << '\n';
    if ((finish.first > r[n]) || (finish.first < -l[n]) || (finish.second > u[n]) || (finish.second < -d[n])) {
        flag = false;
    }
    if (flag) {
        if (finish.first < 0) {
            r_res = 0;
            l_res = bin_search(l, -finish.first, n);
        }
        else {
            l_res = 0;
            r_res = bin_search(r, finish.first, n);
        }
        if (finish.second < 0) {
            u_res = 0;
            d_res = bin_search(d, -finish.second, n);
        }
        else {
            d_res = 0;
            u_res = bin_search(u, finish.second, n);
        }
    }
    if (flag) {
        fout << l_res << ' ' << u_res << ' ' << r_res << ' ' << d_res << '\n';
    }
    else {
        fout << "-1\n";
    }
    fin.close();
    fout.close();
    return 0;
}
