#include<bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e5 + 7;

int mid;

struct TNode {
    int x, y;
    TNode *left, *right;
    int cnt, pos;
};

TNode *new_node(int x) {
    return new TNode{x, rand(), nullptr, nullptr, 0, x};
}

int safe_pos(TNode *root) {
    if (!root) {
        return -1;
    }
    return root->pos;
}

void relax(TNode *root) {
    if (!root) {
        return;
    }
    root->pos = max(safe_pos(root->left), safe_pos(root->right));
    if (root->cnt < mid) {
        root->pos = max(root->pos, root->x);
    }
}

TNode *merge(TNode *left, TNode *right) {
    if (!left) {
        return right;
    }
    if (!right) {
        return left;
    }
    if (left->y > right->y) {
        left->right = merge(left->right, right);
        relax(left);
        return left;
    } else {
        right->left = merge(left, right->left);
        relax(right);
        return right;
    }
}

pair <TNode *, TNode *> split(TNode *root, int x) {
    if (!root) {
        return {nullptr, nullptr};
    }
    if (root->x > x) {
        auto t = split(root->left, x);
        root->left = t.second;
        relax(root);
        return {t.first, root};
    } else {
        auto t = split(root->right, x);
        root->right = t.first;
        relax(root);
        return {root, t.second};
    }
}

int main() {
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <int> data(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> data[i];
    }
    int cnt = 0;
    int l = 0, r = INF;
    while (r - l > 1) {
        mid = (l + r) / 2;
        bool fl = 0;
        TNode *root = nullptr;
        for (int i = 0; i < n; i++) {
            if (data[i] > cnt) {
                cnt = data[i];
                continue;
            } else if (data[i] < cnt) {
                cnt = data[i];
                auto t = split(root, cnt);
                root = t.first;
            }
            if (!root) {
                root = merge(root, new_node(cnt));
            } else if (safe_pos(root) == -1) {
                fl = 1;
                break;
            } else {
                int pos = root->pos;
                auto t = split(root, pos);
                auto t1 = split(t.first, pos - 1);
                t1.second->cnt++;
                root = merge(t1.first, t1.second);
            }
        }
        if (fl) {
            l = mid;
        } else {
            r = mid;
        }
    }
    cout << r;
}
