# include <iostream>

using namespace std;

const int MAX_N = 1e5, MAX_L = 2e5;
int tree[4 * MAX_L], last[4 * MAX_L], add[4 * MAX_L];
int l[MAX_N];
int h, n;

void build(int v, int l, int r)
{
    add[v] = 0;
    last[v] = -1;
    if (l + 1 == r)
    {
        tree[v] = 1;
        if (h != 1)
        {
            last[v] = l;
        }
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    if (last[2 * v + 2] == -1)
    {
        last[v] = last[2 * v + 1];
    }
    else
    {
        last[v] = last[2 * v + 2];
    }
}

void push(int v, int l, int r)
{
    if (add[v] == 0) return;
    add[2 * v + 1] = add[v];
    add[2 * v + 2] = add[v];
    add[v] = 0;
    int m = (l + r) / 2;
    tree[2 * v + 1] = m - l;
    tree[2 * v + 2] = r - m;
    if (h != 1)
    {
        last[2 * v + 1] = m - 1;
        last[2 * v + 2] = r - 1;
    }
    else
    {
        last[2 * v + 1] = -1;
        last[2 * v + 2] = -1;
    }
}

void change(int v, int l, int r, int p, int x)
{
    if (l + 1 == r)
    {
        tree[v] = x;
        if (x != h) last[v] = l;
        else last[v] = -1;
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    if (p < m)
    {
        change(2 * v + 1, l, m, p, x);
    }
    else
    {
        change(2 * v + 2, m, r, p, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    if (last[2 * v + 2] == -1)
    {
        last[v] = last[2 * v + 1];
    }
    else
    {
        last[v] = last[2 * v + 2];
    }
}

void update(int v, int l, int r, int L, int R)
{
    if (l >= R || L >= r) return;
    if (L <= l && r <= R)
    {
        add[v] = 1;
        tree[v] = r - l;
        if (h != 1)
        {
            last[v] = r - 1;
        }
        else
        {
            last[v] = -1;
        }
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, L, R);
    update(2 * v + 2, m, r, L, R);
    if (last[2 * v + 2] == -1)
    {
        last[v] = last[2 * v + 1];
    }
    else
    {
        last[v] = last[2 * v + 2];
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get_last(int v, int l, int r, int L, int R)
{
    if (l >= R || L >= r) return -1;
    if (L <= l && r <= R)
    {
        return last[v];
    }
    push(v, l, r);
    int m = (l + r) / 2;
    return max(get_last(2 * v + 1, l, m, L, R), get_last(2 * v + 2, m, r, L, R));
}

int get(int v, int l, int r, int p)
{
    if (l + 1 == r) return tree[v];
    push(v, l, r);
    int m = (l + r) / 2;
    if (p < m)
    {
        return get(2 * v + 1, l, m, p);
    }
    else
    {
        return get(2 * v + 2, m, r, p);
    }
}

bool check(int m)
{
    int mx = 0;
    h = m;
    for (int i = 0; i < n; i++)
    {
        mx = max(mx, l[i]);
    }
    build(0, 0, mx);
    for (int i = 1; i < n; i++)
    {
        if (l[i] > l[i - 1])
        {
            update(0, 0, mx, l[i - 1] + 1, mx);
            continue;
        }
        int lst = get_last(0, 0, mx, 0, l[i]);
        if (lst == -1) return false;
        int x = get(0, 0, mx, lst);
        change(0, 0, mx, lst, x + 1);
        update(0, 0, mx, lst + 1, mx);
    }
    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i];
    }
    int l = 0, r = MAX_N + 1;
    while (r - l > 1)
    {
        int m = (l + r) / 2;
        if (check(m))
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    cout << r;
}
