#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <set>
#include <cassert>

using namespace std;

const int MAXN = 1e5 + 1;

int n;
int len[MAXN];

struct Seg {
    int l, r, val;
    Seg(int l = 0, int r = 0, int val = 0):
        l(l), r(r), val(val) {}
};

bool operator <(Seg a, Seg b) {
    return make_pair(make_pair(-a.l, -a.r), a.val) < make_pair(make_pair(-b.l, -b.r), b.val);
}

set <Seg> s;

bool check(int g) {
    s.clear();
    s.insert(Seg(0, len[0] - 1, 0));
    for (int i = 1; i < n; i++) {
        if (len[i] > len[i - 1])
            s.insert(Seg(len[i - 1], len[i] - 1, 0));
        else {
            while (!s.empty() && (*s.begin()).l > len[i] - 1)
                s.erase(s.begin());
            if ((*s.begin()).r > len[i] - 1) {
                Seg f = (*s.begin());
                s.erase(s.begin());
                s.insert(Seg(f.l, len[i] - 1, f.val));
            }
            while (!s.empty() && (*s.begin()).val == g - 1)
                s.erase(s.begin());
            if (s.empty())
                return false;
            Seg f = (*s.begin());
            s.erase(s.begin());
            if (f.r != f.l)
                s.insert(Seg(f.l, f.r - 1, f.val));
            s.insert(Seg(f.r, f.r, f.val + 1));
            if (f.r + 1 <= len[i] - 1)
                s.insert(Seg(f.r + 1, len[i] - 1, 0));
        }
    }

    return true;
}

int main() {
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> len[i];

    int l = 0, r = 1e5;
    while (r - l > 1) {
        int m = (l + r + 1) / 2;
        if (check(m))
            r = m;
        else
            l = m;
    }

    cout << r << endl;

    return 0;
}
