#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <deque>
#include <map>

using namespace std;

#define int int64_t

struct Event {
    int x;
    int type;
    int num;
    Event(int x = 0, int type = 0, int num = 0):
        x(x), type(type), num(num) {}
};

bool compare(Event a, Event b) {
    if (a.x == b.x)
        return a.type == 1 && b.type == -1;
    return a.x < b.x;
}

vector <Event> f;

map <int, vector <int> > nxt;
map <int, bool> was;

deque <int> g;

int32_t main() {
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n, k; cin >> n >> k;
    for (int i = 0; i < n; i++) {
        int l, r, p; cin >> l >> r >> p;
        if (p == 2) {
            cout << 3 << endl;
            return 0;
        } else if (p == 3) {
            cout << 8 << endl;
            return 0;
        }
        f.push_back(Event(l, 1, i));
        f.push_back(Event(r, -1, i));
        nxt[l].push_back(r + 1);
    }

    sort(f.begin(), f.end(), compare);
    if (f[0].x > 1 || f.back().x < k) {
        cout << -1 << endl;
        return 0;
    }

    int cnt = 0;
    for (int i = 0; i < (int)f.size();) {
        int cur = f[i].x;
        while (i < (int)f.size() && f[i].x == cur && f[i].type == 1) {
            cnt++;
            i++;
        }
        if (cnt == 0) {
            cout << -1 << endl;
            return 0;
        }
        while (i < (int)f.size() && f[i].x == cur && f[i].type == -1) {
            cnt--;
            i++;
        }
    }

    g.push_back(1);
    was[1] = true;
    while (!g.empty()) {
        int c = g[0];
        g.pop_front();
        for (int i = 0; i < (int)nxt[c].size(); i++)
            if (!was[nxt[c][i]]) {
                g.push_back(nxt[c][i]);
                was[nxt[c][i]] = true;
            }
    }

    if (was[k + 1])
        cout << 1 << endl;
    else
        cout << 2 << endl;

    return 0;
}
