#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <deque>
#include <map>

using namespace std;

#define int int64_t

map <int, vector <int> > nxt;
map <int, bool> was;

deque <int> g;

int32_t main() {
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n, k; cin >> n >> k;
    for (int i = 0; i < n; i++) {
        int l, r, p; cin >> l >> r >> p;
        if (p == 2) {
            cout << 3 << endl;
            return 0;
        } else if (p == 3) {
            cout << 8 << endl;
            return 0;
        }
        nxt[l].push_back(r + 1);
    }

    if (nxt[1].empty()) {
        cout << -1 << endl;
        return 0;
    }

    int curmax = 1;
    for (map <int, vector <int> > :: iterator it = nxt.begin(); it != nxt.end(); ++it) {
        if ((*it).first <= curmax)
            for (int i = 0; i < (int)(*it).second.size(); i++)
                curmax = max(curmax, (*it).second[i]);
    }

    if (curmax < k + 1) {
        cout << -1 << endl;
        return 0;
    }

    g.push_back(1);
    was[1] = true;
    while (!g.empty()) {
        int c = g[0];
        g.pop_front();
        for (int i = 0; i < (int)nxt[c].size(); i++)
            if (!was[nxt[c][i]]) {
                g.push_back(nxt[c][i]);
                was[nxt[c][i]] = true;
            }
    }

    if (was[k + 1])
        cout << 1 << endl;
    else
        cout << 2 << endl;

    return 0;
}
