#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

#define int int64_t

const int MAXN = 1e5;

int n, k;
int l[MAXN], r[MAXN], p[MAXN];
vector <int> q;
int answer = 1e18;

int allp[MAXN];

int check() {
    for (int i = 0; i <= k; i++)
        allp[i] = 0;
    for (int i = 0; i < (int)q.size(); i++) {
        int j = q[i];
        for (int k = l[j]; k <= r[j]; k++)
            allp[k] += p[j];
    }

    int maxp = allp[0];
    for (int i = 0; i <= k; i++) {
        if (allp[i] == 0)
            return 1e18;
        maxp = max(maxp, allp[i]);
    }
    return maxp;
}

void gen(int i) {
    if (i == n) {
        int c = check();
        answer = min(answer, c);
        return;
    }
    q.push_back(i);
    gen(i + 1);
    q.pop_back();
    gen(i + 1);
}

vector <int> allx;

int32_t main() {
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    cin >> n >> k;
    allx.push_back(1);
    allx.push_back(k);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i] >> p[i];
        allx.push_back(l[i]);
        allx.push_back(r[i]);
        allx.push_back(l[i] + 1);
        allx.push_back(r[i] + 1);
    }
    sort(allx.begin(), allx.end());
    allx.resize(unique(allx.begin(), allx.end()) - allx.begin());
    k = lower_bound(allx.begin(), allx.end(), k) - allx.begin();

    for (int i = 0; i < n; i++) {
        l[i] = lower_bound(allx.begin(), allx.end(), l[i]) - allx.begin(),
        r[i] = lower_bound(allx.begin(), allx.end(), r[i]) - allx.begin();
    }

    if (n <= 10) {
        gen(0);
        if (answer == 1e18)
            cout << -1 << endl;
        else
            cout << answer << endl;
        return 0;
    }

    return 0;
}
