#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdlib>

using namespace std;

#define int int64_t

pair<int, int> req(int x)
{
	cout << "X " << x << endl;
	int ansa, ansb;
	cin >> ansa;
	if (ansa == -1)
		exit(0);
	cin >> ansb;
	return{ ansa, ansb };
}

void answer(int val)
{
	cout << "N " << val << endl;
	string v;
	cin >> v;
	if (v == "Wrong")
		exit(0);
}

void guess_1_10()
{
	auto r1 = req(4);
	if (r1.first == 0)
	{
		answer(req(2).second);
		return;
	}
	auto q1 = r1.second;
	if (q1 == 4)
	{
		if (req(8).first == 1)
			answer(8);
		else
			answer(4);
		return;
	}
	if (q1 == 5)
	{
		if (req(10).first == 1)
			answer(10);
		else
			answer(5);
		return;
	}
	answer(q1);
	return;
}

int gcd(int x, int y)
{
	if (y == 0)
		return x;
	return gcd(y, x % y);
}

int lcq(vector<int> vals)
{
	int ret = 1;
	for (auto v : vals)
	{
		ret /= gcd(v, ret);
		ret *= v;
	}
	return ret;
}

void guess_p20()
{
	auto r11 = req(11);
	if (r11.first == 0)
	{
		guess_1_10();
		return;
	}
	auto r13 = req(13);
	auto r17 = req(17);
	answer(lcq({ r11.second, r13.second, r17.second }));
}

vector<int> primes;

const int maxn = 1.5e7;
bool erat[maxn] = {};

void get_primes()
{
	for (int i = 2; i < maxn; i++)
		if (erat[i] == 0)
		{
			primes.push_back(i);
			for (int j = i * i; j < maxn; j+=i)
				erat[j] = 1;
		}
	cerr << primes.size();
}

void guess_p300()
{
	auto rp20 = req(primes[20]);
	if (rp20.first == 0)
	{
		guess_p20();
		return;
	}
	auto rpr1 = req(primes[17]);
	auto rpr2 = req(primes[14]);
	auto rpr3 = req(primes[19]);
	answer(lcq({ rp20.second, rpr1.second, rpr2.second, rpr3.second }));
}

void guess_pmax()
{
	auto rp300 = req(primes[300]);
	if (rp300.first == 0)
	{
		guess_p300(); 
		return;
	}
	int rpi[] = { 228, 239, 118, 38 };
	vector<int> rpia(1, rp300.second);
	for (int i : rpi)
		rpia.push_back(req(i).second);
	answer(lcq(rpia));
}

void guess()
{
	auto rpmax = req(primes.back());
	if (rpmax.first == 0)
	{
		guess_pmax();
		return;
	}
	int rpi[] = { 627346, 756273, 123677, 875342, 875821 };
	vector<int> rpia(1, rpmax.second);
	for (int i : rpi)
		rpia.push_back(req(i).second);
	answer(lcq(rpia));
}

int32_t main()
{
	get_primes();
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		guess();
	return 0;
}