#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstdlib>

using namespace std;

#define int int64_t

int gcd(int x, int y)
{
	if (y == 0)
		return x;
	return gcd(y, x % y);
}

#define DEBUG

#undef DEBUG

#ifdef DEBUG

int n = 1 << 18;

pair<int, int> req(int x)
{
	//cerr << "X " << x << endl;
	int ansa = n / x, ansb = n;
	int d = gcd(ansa, ansb);
	ansa /= d, ansb /= d;
	//cerr << ansa << " " << ansb << "\n";
	return{ ansa, ansb };
}

void answer(int v)
{
	//cerr << "N " << v << endl;
	if (v == n);
		//cerr << "Correct\n";
	else
	{
		cerr << v << " " << n << "\n";
		cerr << "Wrong\n";
	}
}

#else

pair<int, int> req(int x)
{
	cout << "X " << x << endl;
	int ansa, ansb;
	cin >> ansa;
	if (ansa == -1)
		exit(0);
	cin >> ansb;
	return{ ansa, ansb };
}

void answer(int val)
{
	cout << "N " << val << endl;
	string v;
	cin >> v;
	if (v == "Wrong")
		exit(0);
}

#endif

void guess_1_10()
{
	auto r1 = req(4);
	if (r1.first == 0)
	{
		answer(req(2).second);
		return;
	}
	auto q1 = r1.second;
	if (q1 == 4)
	{
		if (req(8).first == 1)
			answer(8);
		else
			answer(4);
		return;
	}
	if (q1 == 5)
	{
		if (req(10).first == 1)
			answer(10);
		else
			answer(5);
		return;
	}
	answer(q1);
	return;
}

int lcq(vector<int> vals)
{
	int ret = 1;
	for (auto v : vals)
	{
		ret /= gcd(v, ret);
		ret *= v;
	}
	return ret;
}

void guess_p20()
{
	auto r11 = req(11);
	if (r11.first == 0)
	{
		guess_1_10();
		return;
	}
	auto r13 = req(13);
	auto r17 = req(17);
	answer(lcq({ r11.second, r13.second, r17.second }));
}

vector<int> primes;

const int maxn = 1.5e7;
bool erat[maxn] = {};

void get_primes()
{
	for (int i = 2; i < maxn; i++)
		if (erat[i] == 0)
		{
			primes.push_back(i);
			for (int j = i * i; j < maxn; j+=i)
				erat[j] = 1;
		}
	cerr << primes.size() << " " << primes.back() << "\n";
}

void guess_p300()
{
	auto rp20 = req(primes[20]);
	if (rp20.first == 0)
	{
		guess_p20();
		return;
	}
	auto rpr1 = req(primes[17]);
	auto rpr2 = req(primes[15]);
	auto rpr3 = req(primes[18]);
	int pa = lcq({ rp20.second, rpr1.second, rpr2.second});
	if (req(pa * 2).first != 0)
		pa = pa * 2;
	answer(pa);
}

void guess_pmax()
{
	auto rp300 = req(primes[300]);
	if (rp300.first == 0)
	{
		guess_p300(); 
		return;
	}
	int rpi[] = { 228, 239, 299, 38 };
	vector<int> rpia(1, rp300.second);
	for (int i : rpi)
		rpia.push_back(req(primes[i]).second);
	int pa = lcq(rpia);
	if (req(pa * 2).first != 0)
		pa = pa * 2;
	answer(pa);
}

void guess()
{
	//cerr << primes.back() << "\n";
	auto rpmax = req(primes.back());
	if (rpmax.first == 0)
	{
		guess_pmax();
		return;
	}
	int rpi[] = { 627346, 756273, 123677, 875342, 476743 };
	vector<int> rpia(1, rpmax.second);
	for (int i : rpi)
		rpia.push_back(req(primes[i]).second);
	int pa = lcq(rpia);
	if (req(pa * 2).first != 0)
		pa = pa * 2;
	answer(pa);
}

int32_t main()
{
	get_primes();
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		guess();
	}
	return 0;
}