#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1e9 + 7;
long long k;

struct seg {
	long long l, r, p;
};

bool cmp(seg &a, seg &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

bool check(vector<seg> &num, vector<long long> &used) {
	long long l = -1, r = 0;
	for (long long i = 0; i < num.size(); i++) {
		if (used[i] == 0) {
			continue;
		}
		r = max(r, num[i].r);
		if (l == -1) {
			l = num[i].l;
			continue;
		}
		long long w = 0;
		for (long long j = 0; j < i; j++) {
			if (used[j] == 0) {
				continue;
			}
			if (num[j].r >= num[i].l - 1) {
				w++;
			}
		}
		if (w == 0 || w > 1) {
			return false;
		}
	}
	if (l > 1 || r < k) {
		return false;
	}
	return true;
}

long long rec(vector<seg> &num, vector<long long> &used, long long j, long long p) {
	if (j == num.size()) {
		if (check(num, used)) {
			return p;
		} else {
			return INF;
		}
	}
	long long ans = rec(num, used, j + 1, p);
	p = max(p, num[j].p);
	for (long long i = 0; i < num.size(); i++) {
		if (used[i] == 0) {
			continue;
		}
		if (num[i].r >= num[j].l) {
			p = max(p, num[i].p + num[j].p);
		}
	}
	used[j] = 1;
	ans = min(ans, rec(num, used, j + 1, p));
	used[j] = 0;
	return ans;
}

int main() {
	long long n;
	cin >> n >> k;
	vector<seg> num(n);
	for (long long i = 0; i < n; i++) {
		cin >> num[i].l >> num[i].r >> num[i].p;
	}
	sort(num.begin(), num.end(), cmp);
	if (n <= 10) {
		vector<long long> used(n, 0);
		long long ans = rec(num, used, 0, 0);
		if (ans == INF) {
			cout << -1;
		} else {
			cout << ans;
		}
	} else {
		/*if (num[0].l > 1) {
			cout << -1;
			return 0;
		}
		long long r = num[0].r;
		for (long long i = 1; i < num.size(); i++) {
			if (num[i].l - 1 <= r) {
				r = max(r, num[i].r);
			}
		}
		if (r < k) {
			cout << -1;
			return 0;
		}
		*/
	}
	return 0;
}