#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

const int INF = 1e9 + 7;
int k;

struct seg {
	int l, r, p;
};

bool cmp(seg &a, seg &b) {
	if (a.l == b.l) {
		return a.r < b.r;
	} else {
		return a.l < b.l;
	}
}

bool check(vector<seg> &num, vector<int> &used) {
	int l = -1, r = 0;
	for (int i = 0; i < num.size(); i++) {
		if (used[i] == 0) {
			continue;
		}
		r = max(r, num[i].r);
		if (l == -1) {
			l = num[i].l;
			continue;
		}
		int w = 0;
		for (int j = 0; j < i; j++) {
			if (used[j] == 0) {
				continue;
			}
			if (num[j].r >= num[i].l - 1) {
				w++;
			}
		}
		if (w != 1) {
			return false;
		}
	}
	if (l != 1 || r != k) {
		return false;
	}
	return true;
}

int rec(vector<seg> &num, vector<int> &used, int j, int p) {
	if (j == num.size()) {
		if (check(num, used)) {
			return p;
		} else {
			return INF;
		}
	}
	int ans = rec(num, used, j + 1, p);
	p = max(p, num[j].p);
	for (int i = 0; i < j; i++) {
		if (used[i] == 0) {
			continue;
		}
		if (num[i].r >= num[j].l) {
			p = max(p, num[i].p + num[j].p);
		}
	}
	used[j] = 1;
	ans = min(ans, rec(num, used, j + 1, p));
	used[j] = 0;
	return ans;
}

int main() {
	int n;
	cin >> n >> k;
	vector<seg> num(n);
	for (int i = 0; i < n; i++) {
		cin >> num[i].l >> num[i].r >> num[i].p;
	}
	sort(num.begin(), num.end(), cmp);
	if (n <= 0) {
		vector<int> used(n, 0);
		int ans = rec(num, used, 0, 0);
		if (ans == INF) {
			cout << -1;
		} else {
			cout << ans;
		}
	} else {
		if (num[0].l > 1) {
			cout << -1;
			return 0;
		}
		int r = num[0].r;
		for (int i = 1; i < num.size(); i++) {
			if (num[i].l - 1 <= r) {
				r = max(r, num[i].r);
			}
		}
		if (r < k) {
			cout << -1;
			return 0;
		}
		set<int> ind;
		ind.insert(1);
		int maxn = 0;
		for (int i = 0; i < num.size(); i++) {
			if (ind.find(num[i].l) != ind.end()) {
				maxn = max(maxn, num[i].r);
				ind.insert(num[i].r + 1);
			}
		}
		if (maxn < k) {
			cout << 2;
		} else {
			cout << 1;
		}
	}
	return 0;
}