#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()
#define fi first
#define se second

const int N = 200000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;

using namespace std;

struct node
{
    int pr, len, sz, v, mi;
    node *L, *R;
    node()
    {
        L = NULL;
        R = NULL;
    }
    node(int a, int b, int c)
    {
        pr = a;
        len = b;
        sz = b;
        v = c;
        mi = c;
        L = NULL;
        R = NULL;
    }
};

int get_sz(node *t)
{
    if (t == NULL)
        return 0;
    else
        return t->sz;
}

void upd_sz(node *t)
{
    if (t == NULL)
        return;
    else
        t->sz = t->len + get_sz(t->L) + get_sz(t->R);
}

int get_mi(node *t)
{
    if (t == NULL)
        return inf;
    else
        return t->mi;
}

void upd_mi(node *t)
{
    if (t == NULL)
        return;
    else
        t->mi = min(t->v, min(get_mi(t->L), get_mi(t->R)));
}

node* merge(node *l, node *r)
{
    if (l == NULL)
        return r;
    else if (r == NULL)
        return l;
    else if (l->pr <= r->pr)
    {
        l->R = merge(l->R, r);
        upd_sz(l);
        upd_mi(l);
        return l;
    }
    else
    {
        r->L = merge(l, r->L);
        upd_sz(r);
        upd_mi(r);
        return r;
    }
}

node* split(node* t, int len)
{
    if (get_sz(t) == len)
        return t;
    else if (get_sz(t->L) >= len)
        return split(t->L, len);
    else if (get_sz(t->L) + t->len >= len)
    {
        t->len = len - get_sz(t->L);
        t->R = NULL;
        upd_sz(t);
        upd_mi(t);
        return t;
    }
    else
    {
        t->R = split(t->R, len - (get_sz(t->L) + t->len));
        upd_sz(t);
        upd_mi(t);
        return t;
    }
}

node* add(node* t, int len, int v)
{
    node* _new = new node(((rand() << 15) | rand()), len, v);
    return merge(t, _new);
}

int get_last(node *t, int k)
{
    if (t == NULL)
        return -inf;
    else if (get_mi(t->R) <= k)
    {
        int pos = get_last(t->R, k);
        if (pos == -inf)
            return -inf;
        else
            return get_sz(t->L) + t->len + pos;
    }
    else if (t->v <= k)
        return get_sz(t->L) + t->len - 1;
    else
        return get_last(t->L, k);
}

int get_v(node *t, int pos)
{
    if (t == NULL)
        return inf;
    else if (pos < get_sz(t->L))
        return get_v(t->L, pos);
    else if (pos < get_sz(t->L) + t->len)
        return t->v;
    else
        return get_v(t->R, pos - (get_sz(t->L) + t->len));
}

void print(node *t)
{
    if (t == NULL)
        return;
    print(t->L);
    cout << t->len << " " << t->v << "   ";
    print(t->R);
}

int main()
{
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    srand(time(0));
    int n;
    scanf("%d", &n);
    int a[n];
    rep(i, 0, n)
        scanf("%d", &a[i]);
    int l = 0, r = n, mid;
    while (r - l > 1)
    {
        mid = (l + r) / 2;
        bool ok = true;
        node* DD = NULL;
        DD = add(DD, a[0], 1);
        /*cout << mid << endl;
        print(DD);
        cout << endl;*/
        rep(i, 1, n)
        {
            if (a[i] > a[i - 1])
            {
                DD = add(DD, a[i] - a[i - 1], 1);
            }
            else
            {
                DD = split(DD, a[i]);
                /*cout << get_sz(DD) << endl;
                print(DD);
            cout << endl;*/
                int pos = get_last(DD, mid - 1);
                if (pos < 0)
                {
                    ok = false;
                    break;
                }
                int v = get_v(DD, pos);
                DD = split(DD, pos);
                /*cout << get_sz(DD) << endl;
                print(DD);
            cout << endl;*/
                DD = add(DD, 1, v + 1);
                /*cout << get_sz(DD) << endl;
                print(DD);
            cout << endl;*/
                if (get_sz(DD) < a[i])
                    DD = add(DD, a[i] - get_sz(DD), 1);
            }
            /*print(DD);
            cout << endl;*/
        }
        //cout << endl;
        if (ok)
            r = mid;
        else
            l = mid;
    }
    cout << r << "\n";
    return 0;
}
