#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

typedef long long ll;
typedef pair <int, int> pii;

const int INF = 1e9;
const ll INFll = 1ll * INF * INF;

struct point {
    int l, r, p;
};

bool comp(point a, point b) {
    return a.l < b.l || (a.l == b.l && a.r < b.r);
}

class segtree {
public:
    int n;
    vector <ll> t;
    vector <ll> d;
    int h;

    void build(vector <int> &v) {
        for (int i = 0; i < n; i++)
            t[i + n] = v[i];
        for (int i = n - 1; i > 0; i--)
            t[i] = t[i << 1] + t[i << 1 | 1];
    }

    void apply(int p, int value, int k) {
        t[p] += value * k;
        if (p < n)
            d[p] += value;
    }

    void recalc(int p) {
        int k = 1;
        while (p > 1)
            p >>= 1, k <<= 1, t[p] = t[p << 1] + t[p << 1 | 1] + d[p] * k;
    }

    void push(int p) {
        for (int s = h; s > 0; s--) {
            int i = p >> s;
            if (d[i] != 0) {
                apply(i << 1, d[i], 1 << (s - 1));
                apply(i << 1 | 1, d[i], 1 << (s - 1));
            }
            d[i] = 0;
        }
    }

    void inc(int l, int r, int value) {
        l += n, r += n;
        push(l);
        push(r - 1);
        int l0 = l, r0 = r;
        int k = 1;
        for (; l < r; l >>= 1, r >>= 1, k <<= 1) {
            if (l & 1)
                apply(l++, value, k);
            if (r & 1)
                apply(--r, value, k);
        }
        recalc(l0);
        recalc(r0 - 1);
    }

    ll query(int l, int r) {
        l += n, r += n;
        ll res = 0;
        push(l);
        push(r - 1);
        for (; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                res += t[l++];
            if (r & 1)
                res += t[--r];
        }
        return res;
    }

    segtree(int n):n(n), t() {
        h = 32 - __builtin_clz(n);
        t.resize(1 << n);
        d.resize(1 << n);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, k;
    cin >> n >> k;
    vector <point> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i].l >> v[i].r >> v[i].p;
    v.pb({0, 0, 0});
    sort(v.begin(), v.end(), comp);
    vector <ll> dp(v.size() + 1, INFll);
    dp[0] = 0;
    for (int i = 1; i < v.size(); i++) {
        ll val = INFll;
        for (int j = 0; j < i; j++) {
            if (v[j].r + 1 < v[i].l)
                continue;
            ll add;
            if (v[j].r >= v[i].l)
                add = v[j].p + v[i].p;
            else
                add = max(v[j].p, v[i].p);
            val = min(val, max(dp[j], add));
        }
        //cout << val << endl;
        dp[i] = val;
    }
    ll ans = INFll;
    for (int i = 1; i < v.size(); i++)
        if (v[i].r == k)
            ans = min(ans, dp[i]);
    if (ans == INFll)
        cout << -1 << endl;
    else
        cout << ans << endl;
    return 0;
}

