#include <bits/stdc++.h>

using namespace std;

const long long INF = (long long)1e18 + 7;

void die() {
    cout << -1 << endl;
    exit(0);
}

struct S {
    int l, r, _l;
    long long p;
};

inline bool operator< (S const& a, S const& b) {
    return (a.r < b.r);
}

const int N = (int)1e6;
long long tree[N];

long long getMin(int v, int l, int r, int ql, int qr) {
    int m = (l + r) / 2;

    if (r - l == 0)
        return INF;

    if (ql <= l && r <= qr)
        return tree[v];

    if (ql >= r || qr <= l)
        return INF;

    return min(getMin(v * 2, l, m, ql, qr), getMin(v * 2 + 1, m, r, ql, qr));
}

void setVal(int v, int l, int r, int ind, long long val) {
    int m = (l + r) / 2;

    if (ind < l || ind >= r)
        return;

    if (r - l == 1) {
        if (l == ind)
            tree[v] = val;
    } else {
        setVal(v * 2, l, m, ind, val);
        setVal(v * 2 + 1, m, r, ind, val);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
}

void printLastLevel(int v, int l, int r) {
    if (r - l == 0)
        return;

    //cout << v << ' ' << l << ' ' << r << ' ' << tree[v] << endl;

    int m = (l + r) / 2;
    if (r - l > 1) {
        printLastLevel(v * 2, l, m);
        printLastLevel(v * 2 + 1, m, r);
    }
}

int main() {
    ios_base::sync_with_stdio(false);

    #ifdef SCHEMTSCHIK
        //freopen("input.txt", "r", stdin);
    #else

    #endif

    for (int i = 0; i < N; i++)
        tree[i] = INF;

    /*for (int i = 0; i < 10; i++)
        setVal(1, 0, 10, i, i + 1);

    for (int i = 0; i < 10; i++)
        cout << getMin(1, 0, 10, i, i + 1) << endl;*/

    int n, k;
    cin >> n >> k;
    vector<S> a(n);
    set<int> tmp;
    for (auto& i : a)
        cin >> i.l >> i.r >> i.p, tmp.insert(i.l), tmp.insert(i.r);

    vector<int> _t;
    for (int i : tmp)
        _t.push_back(i);

    if (tmp.count(1) == 0)
        die();

    if (tmp.count(k) == 0)
        die();

    for (auto& i : a) {
        i._l = i.l;
        i.l = int(lower_bound(_t.begin(), _t.end(), i.l) - _t.begin());
        i.r = int(lower_bound(_t.begin(), _t.end(), i.r) - _t.begin());
    }

    k = int(lower_bound(_t.begin(), _t.end(), k) - _t.begin());

    vector<long long> dp(_t.size(), INF);

    sort(a.begin(), a.end());

    for (auto& i : a) {
        if (i.l == 0)
            dp[i.r] = min(dp[i.r], i.p);
        else if (tmp.count(i._l - 1) && dp[i.l - 1] != INF)
            dp[i.r] = min(dp[i.r], max(dp[i.l - 1], i.p));

        dp[i.r] = min(dp[i.r], getMin(1, 0, k + 1, i.l, i.r) + i.p);

        setVal(1, 0, k + 1, i.r, dp[i.r]);
    }

    //for (int i = 0; i <= k; i++)
    //    cout << dp[i] << endl;

    cout << (dp[k] == INF ? -1ll : dp[k]) << endl;

    return 0;
}
