#include <bits/stdc++.h>

using namespace std;

const long long INF = (long long)1e18 + 7;

void die() {
    cout << -1 << endl;
    exit(0);
}

struct S {
    int l, r, _l, _r;
    long long p;
};

inline bool operator< (S const& a, S const& b) {
    return (a.r < b.r || (a.r == b.r && a.p < b.p));
}

const int N = (int)1e6;
long long tree[N];

long long getMin(int v, int l, int r, int ql, int qr) {
    int m = (l + r) / 2;

    if (r - l == 0)
        return INF;

    if (ql <= l && r <= qr)
        return tree[v];

    if (ql >= r || qr <= l)
        return INF;

    return min(getMin(v * 2, l, m, ql, qr), getMin(v * 2 + 1, m, r, ql, qr));
}

void setVal(int v, int l, int r, int ind, long long val) {
    int m = (l + r) / 2;

    if (ind < l || ind >= r)
        return;

    if (r - l == 1) {
        if (l == ind)
            tree[v] = val;
    } else {
        setVal(v * 2, l, m, ind, val);
        setVal(v * 2 + 1, m, r, ind, val);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
}

void printLastLevel(int v, int l, int r) {
    if (r - l == 0)
        return;

    //cout << v << ' ' << l << ' ' << r << ' ' << tree[v] << endl;

    int m = (l + r) / 2;
    if (r - l > 1) {
        printLastLevel(v * 2, l, m);
        printLastLevel(v * 2 + 1, m, r);
    }
}

int main() {
    ios_base::sync_with_stdio(false);

#ifdef SCHEMTSCHIK
    //freopen("input.txt", "r", stdin);
#else

#endif

    for (int i = 0; i < N; i++)
        tree[i] = INF;

    /* vector<int> a(10);
     for (int i = 0; i < 10; i++)
         a[i] = rand(), setVal(1, 0, 10, i, a[i]);

     for (int i = 0; i < 10; i++)
         for (int j = i + 1; j <= 10; j++)
             assert(getMin(1, 0, 10, i, j) == (*min_element(a.begin() + i, a.begin() + j)));*/

    int n, k;
    cin >> n >> k;
    vector<S> a(n);
    set<int> tmp;
    for (auto& i : a)
        cin >> i.l >> i.r >> i.p, tmp.insert(i.l), tmp.insert(i.r);

    vector<int> _t;
    for (int i : tmp)
        _t.push_back(i);

    if (tmp.count(1) == 0)
        die();

    if (tmp.count(k) == 0)
        die();

    vector<int> tt(_t.size());
    tt[0] = 0;
    for (int i = 1; i < (int)tt.size(); i++)
        tt[i] = tt[i - 1] + min(2, _t[i] - _t[i - 1]);

    for (auto& i : a) {
        i._l = i.l;
        i._r = i.r;
        i.l = tt[int(lower_bound(_t.begin(), _t.end(), i.l) - _t.begin())];
        i.r = tt[int(lower_bound(_t.begin(), _t.end(), i.r) - _t.begin())];
    }

    //for (auto& i : a)
    //    cout << i.l << ' ' << i.r << endl;

    k = tt[int(lower_bound(_t.begin(), _t.end(), k) - _t.begin())];

    vector<long long> dp(k + 1, INF), last(k + 1, INF);

    sort(a.begin(), a.end());

    set<int> dpp;

    for (auto& i : a) {
        if (i.l == 0) {
            if (i.p < dp[i.r])
                dp[i.r] = i.p, last[i.r] = i.p;
        } else {
            if (dpp.lower_bound(i.l) != dpp.end() && (*dpp.lower_bound(i.l)) < i.r && 2 < dp[i.r])
                dp[i.r] = 2, last[i.r] = i.p;
        }

        if (dp[i.r] != INF)
            dpp.insert(i.r);
    }

    //for (int i = 0; i <= k; i++)
    //    cout << dp[i] << endl;

    cout << (dp[k] == INF ? -1ll : dp[k]) << endl;

    return 0;
}
