#pragma comment(linker, "/STACK:1000000000")
#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<string>
#include<map>
#include<cassert>
#include<queue>

#define int long long

using namespace std;

struct seg {
	int32_t l, r, p;
	seg() {}
	seg(int32_t l, int32_t r, int32_t p) : l(l), r(r), p(p) {}
	bool operator<(const seg& b) const {
		return l < b.l;
	}
};

int32_t main() {
	//freopen("input.in", "r", stdin);
	int n, k;
	cin >> n >> k;
	vector<seg> segs(n);
	set<int32_t> evs;
	for (int i = 0; i < n; i++) {
		int32_t l, r, x;
		scanf("%d%d%d", &l, &r, &x);
		segs[i] = (seg(l, r + 1, x));
		evs.insert(l);
		evs.insert(r + 1);
	}
	sort(segs.begin(), segs.end());
	evs.insert(1);
	evs.insert(k + 1);

	map<int, int> diff;
	int32_t c = 0;
	for (auto &el : evs) {
		diff[el] = c;
		c++;
	}
	
	vector<vector<int> > ids(c);

	for (int i = 0; i < n; i++) {
		ids[diff[segs[i].l]].push_back(i);
	}

	int inf = 2e9 + 1;
	int l = 0, r = inf;
	while (r - l > 1) {
		int mid = l + r >> 1;

		bool was = false;
		queue<pair<int, int> > q;
		q.push({ 0, -1 });
		while (!q.empty()) {
			int cv = q.front().first;
			if (cv == c - 1) {
				was = true;
				break;
			}
			int cid = q.front().second;
			q.pop();

			int maxp = mid - (cid == -1 ? 0 : segs[cid].p);
			int minr = cid == -1 ? -1 : segs[cid].r;

			for (auto &el : ids[cv]) {
				int sp = segs[el].p;
				int sr = segs[el].r;
				int sl = segs[el].l;
				if (sp > maxp || sr < minr)
					continue;
				for (int tr = (minr == -1 ? diff[sl] + 1 : diff[minr] + 1); tr < diff[sr]; tr++)
					q.push({ tr, el });
				q.push({ diff[sr], -1 });
			}
		}

		if (was)
			r = mid;
		else
			l = mid;
	}

	cout << (r == inf ? -1 : r);

}