#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <functional>
#include <cstdio>
#include <cassert>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>



#define pb push_back
#define mp make_pair
#define ppb pop_back
#define len(v) ((int)(v.size()))


typedef long long ll;


using namespace std;


char string_in_buffer[256];

void fast_scan(int &x) { scanf("%d", &x); }
void fast_scan(ll &x) { scanf("%lld", &x); }
void fast_scan(double &x) { scanf("%lf", &x); }
void fast_scan(string &s) {
	scanf("%s", string_in_buffer);
	s = string(string_in_buffer);
}
template<class T>
void fast_scan(vector<T> &v) {
	for (T &x : v) {
		fast_scan(x);
	}
}

void fast_print(const int &x) { printf("%d", x); }
void fast_print(const ll &x) { printf("%lld", x); }
void fast_print(const string &s) { printf("%s", s.c_str()); }
void fast_print(const double &x) { printf("%.20lf", x); }

template<class T>
void fast_print(const vector<T> &v) {
	if (v.empty()) return;
	for (int i = 0; i < len(v) - 1; i++) {
		fast_print(v[i]);
		fast_print(" ");
	}
	fast_print(v.back());
}

namespace smart_io {
	bool first_line_print = true;
	bool first_print = false;
	string print_start = "";
	void precall_print() {
		fast_print(print_start);
		print_start = "\n";
		first_print = true;
	}
}

template<class T>
istream &operator,(istream &is, T &x) {
	fast_scan(x);
	return is;
}

template<class T>
ostream &operator,(ostream &os, const T &x) {
	if (!smart_io::first_print) {
		fast_print(" ");
	} else {
		smart_io::first_print = false;
	}
	fast_print(x);
	return os;
}


#define scan cin,
#define print smart_io::precall_print(); cout,

// tree<int, int, less<int>, rb_tree_tag, tree_order_statistics_node_update> index;
map<int, int> index;

int main() {
	freopen("input.txt", "r", stdin);
	int n;
	scan n;
	vector<int> v(n);
	scan v;
	ll left = 0;
	ll right = 1e9 + 2;
	while (right - left > 1) {
		ll mid = (left + right) / 2;
		index.clear();
		bool can = true;
		int cur = v[0];
		for (int i = 1; i < n; i++) {
			int next = v[i];
			if (next > cur) {
				cur = next;
				continue;
			}

			index[next - 1]++;
			int it = next - 1;
			while (it >= -1 && index[it] >= mid) {
				index[it - 1]++;
				it--;
			}
			if (it <= -1) {
				can = false;
				break;
			}

			auto iter = index.find(it);
			iter++;
			while (iter != index.end()) {
				auto tdel = iter;
				iter++;
				index.erase(tdel);
			}

			cur = next;
		}
		// print can, mid;
		if (can) {
			right = mid;
		} else {
			left = mid;
		}
	}
	print right;
}