#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <functional>
#include <cstdio>
#include <cassert>



#define pb push_back
#define mp make_pair
#define ppb pop_back
#define len(v) ((int)(v.size()))


typedef long long ll;


using namespace std;


char string_in_buffer[256];

void fast_scan(int &x) { scanf("%d", &x); }
void fast_scan(ll &x) { scanf("%lld", &x); }
void fast_scan(double &x) { scanf("%lf", &x); }
void fast_scan(string &s) {
	scanf("%s", string_in_buffer);
	s = string(string_in_buffer);
}
template<class T>
void fast_scan(vector<T> &v) {
	for (T &x : v) {
		fast_scan(x);
	}
}

void fast_print(const int &x) { printf("%d", x); }
void fast_print(const ll &x) { printf("%lld", x); }
void fast_print(const string &s) { printf("%s", s.c_str()); }
void fast_print(const double &x) { printf("%.20lf", x); }

template<class T>
void fast_print(const vector<T> &v) {
	if (v.empty()) return;
	for (int i = 0; i < len(v) - 1; i++) {
		fast_print(v[i]);
		fast_print(" ");
	}
	fast_print(v.back());
}

namespace smart_io {
	bool first_line_print = true;
	bool first_print = false;
	string print_start = "";
	void precall_print() {
		fast_print(print_start);
		print_start = "\n";
		first_print = true;
	}
}

template<class T>
istream &operator,(istream &is, T &x) {
	fast_scan(x);
	return is;
}

template<class T>
ostream &operator,(ostream &os, const T &x) {
	if (!smart_io::first_print) {
		fast_print(" ");
	} else {
		smart_io::first_print = false;
	}
	fast_print(x);
	return os;
}


#define scan cin,
#define print smart_io::precall_print(); cout,
#define int long long

typedef pair<int, int> pii;

map<int, int> which;
map<int, int> rev_which;
set<int> all_cords;


struct Req {
	int left, right, dump;
	int dp = -1;

	Req() {}

	Req(int _left, int _right, int _dump) {
		left = _left;
		right = _right;
		dump = _dump;
	}
};

signed main() {
	freopen("input.txt", "r", stdin);
	int n, m;
	scan n, m;
	vector<Req> v(n);
	vector<vector<Req>> seg_at;
	map<int, int> max_ovf;
	for (int i = 0; i < n; i++) {
		int l, r, d;
		scan l, r, d;
		l--;r--;
		v[i] = Req(l, r, d);
		all_cords.insert(l);
		all_cords.insert(r);
	}
	{
		int iter = 0;
		for (auto x : all_cords) {
			which[x] = iter;
			rev_which[iter++] = x;
			// print x, "->", iter - 1;
		}
	}

	{
		for (int i = 0; i < n; i++) {
			v[i].left = which[v[i].left];
			v[i].right = which[v[i].right];
		}
	}

	seg_at.resize(2e5);
	for (int i = 0; i < n; i++) {
		seg_at[v[i].right].pb(v[i]);
	}

	int rez = 1e16;
	rev_which[-1] = -1;
	which[-1] = -1;
	max_ovf[-1] = 0;
	for (int i = 0; i < len(seg_at); i++) {
		for (Req &r : seg_at[i]) {
			int rev = rev_which[r.left] - 1;
			if (which.find(rev) != which.end()) {
				rev = which[rev];
				if (max_ovf.find(rev) != max_ovf.end()) {
					r.dp = max(max_ovf[rev], r.dump);
				}
			}
			for (int j = r.left; j < r.right; j++) {
				for (Req sub : seg_at[j]) {
					// print sub.left, sub.right;
					if (sub.dp == -1) continue;
					if (sub.left >= r.left) continue;
					int w = max(sub.dp, sub.dump + r.dump);
					if (r.dp == -1 || r.dp > w) {
						r.dp = w;
					}
				}
			}
			if (r.dp != -1) {
				if (max_ovf.find(i) == max_ovf.end() || max_ovf[i] > r.dp) {
					max_ovf[i] = r.dp;
				}
			}
		}
		// print "IMP", i, max_ovf[i];
	}
	int last = which[m - 1];
	if (which.find(m - 1) == which.end()) {
		print -1;
		return 0;
	}
	if (max_ovf.find(last) != max_ovf.end()) {
		print max_ovf[last];
	} else {
		print -1;
	}
}