#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <string>
#include <functional>
#include <cstdio>
#include <cassert>



#define pb push_back
#define mp make_pair
#define ppb pop_back
#define len(v) ((int)(v.size()))


typedef long long ll;


using namespace std;


char string_in_buffer[256];

void fast_scan(int &x) { scanf("%d", &x); }
void fast_scan(ll &x) { scanf("%lld", &x); }
void fast_scan(double &x) { scanf("%lf", &x); }
void fast_scan(string &s) {
	scanf("%s", string_in_buffer);
	s = string(string_in_buffer);
}
template<class T>
void fast_scan(vector<T> &v) {
	for (T &x : v) {
		fast_scan(x);
	}
}

void fast_print(const int &x) { printf("%d", x); }
void fast_print(const ll &x) { printf("%lld", x); }
void fast_print(const string &s) { printf("%s", s.c_str()); }
void fast_print(const double &x) { printf("%.20lf", x); }

template<class T>
void fast_print(const vector<T> &v) {
	if (v.empty()) return;
	for (int i = 0; i < len(v) - 1; i++) {
		fast_print(v[i]);
		fast_print(" ");
	}
	fast_print(v.back());
}

namespace smart_io {
	bool first_line_print = true;
	bool first_print = false;
	string print_start = "";
	void precall_print() {
		fast_print(print_start);
		print_start = "\n";
		first_print = true;
	}
}

template<class T>
istream &operator,(istream &is, T &x) {
	fast_scan(x);
	return is;
}

template<class T>
ostream &operator,(ostream &os, const T &x) {
	if (!smart_io::first_print) {
		fast_print(" ");
	} else {
		smart_io::first_print = false;
	}
	fast_print(x);
	return os;
}


#define scan cin,
#define print smart_io::precall_print(); cout,
#define int long long

typedef pair<int, int> pii;

map<int, int> which;
map<int, int> rev_which;
set<int> all_cords;


struct Req {
	int left, right, dump;
	int dp = -1;

	Req() {}

	Req(int _left, int _right, int _dump) {
		left = _left;
		right = _right;
		dump = _dump;
	}
};

signed main() {
	freopen("input.txt", "r", stdin);
	int n, m;
	scan n, m;
	vector<Req> v(n);
	vector<vector<Req>> seg_at;
	map<int, int> max_ovf;
	for (int i = 0; i < n; i++) {
		int l, r, d;
		scan l, r, d;
		l--;r--;
		v[i] = Req(l, r, d);
		all_cords.insert(l);
		all_cords.insert(r);
	}

	if (n <= 10) {
		int _min = -1;
		for (int mask = 0; mask < (1<<n); mask++) {
			vector<pair<Req, int>> events;
			for (int i = 0; i < n; i++) {
				if (mask & (1<<i)) {
					events.pb(mp(v[i], 0));
					events.pb(mp(v[i], 1));
				}
			}
			int _maxm = 0;
			auto prep = [](pair<Req, int> t){
				if (t.second) return t.first.right;
				return t.first.left;
			};
			sort(events.begin(), events.end(), [&prep](pair<Req, int> a, pair<Req, int> b){
				return mp(prep(a), a.second) < mp(prep(b), b.second);
			});
			int _last = -1;
			int _cur = 0;
			bool can = true;
			for (pair<Req, int> p : events) {
				int border = prep(p);
				if (border > _last + 1 && _cur == 0) {
					can = false;
					break;
				}
				_last = max(_last, p.first.right);
				if (!p.second) {
					_cur += p.first.dump;

				} else {
					_cur -= p.first.dump;

				}

				_maxm = max(_cur, _maxm);
			}
			if (_last != m - 1) can = false;
			if (can) {
				if (_min == -1 || _maxm < _min) {
					_min = _maxm;
				}
			}
		}
		print _min;
		return 0;
	}

	{
		int iter = 0;
		for (auto x : all_cords) {
			which[x] = iter;
			rev_which[iter] = x;
			iter++;
			// print x, "->", iter - 1;
		}
	}

	{
		for (int i = 0; i < n; i++) {
			v[i].left = which[v[i].left];
			v[i].right = which[v[i].right];
		}
	}

	seg_at.resize(2e5);
	for (int i = 0; i < n; i++) {
		seg_at[v[i].right].pb(v[i]);
	}

	int rez = 1e16;
	rev_which[-1] = -1;
	which[-1] = -1;
	max_ovf[-1] = 0;
	vector<int> pref(len(seg_at), 0);
	for (int i = 0; i < len(seg_at); i++) {
		for (Req &r : seg_at[i]) {
			int rev = rev_which[r.left] - 1;
			if (which.find(rev) != which.end()) {
				rev = which[rev];
				if (max_ovf.find(rev) != max_ovf.end()) {
					r.dp = max(max_ovf[rev], r.dump);
				}
			}

			int t = pref[i - 1];
			if (r.left > 0) {
				t -= pref[r.left - 1];
			}
			if (t > 0) {
				if (r.dp == -1 || r.dp > 2) {
					r.dp = 2;
				}
			}
				
			if (r.dp != -1) {
				if (max_ovf.find(i) == max_ovf.end() || max_ovf[i] > r.dp) {
					max_ovf[i] = r.dp;
					if (i == 0) {
						pref[i] = 1;
					} else {
						pref[i] = pref[i - 1] + 1;
					}
				}
			}
		}
	}

	if (which.find(m - 1) == which.end()) {
		print -1;
		return 0;
	}

	if (max_ovf.find(which[m - 1]) == max_ovf.end()) {
		print -1;
		return 0;
	} else {
		print max_ovf[which[m - 1]];
	}
}