// ol(2017)d2tC.cpp:      .
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <unordered_map>

using namespace std;

struct vert
{
	long long l, r, p;
	vert(long long le = -1, long long ri = -1, long long pr = -1)
	{
		l = le, r = ri, p = pr;
	}
};

bool dfs(unordered_map<long long, vector<vert> > g, long long v, long long wend)
{
	vector<vert> vars = g[v];
	for (long long i = 0; i < vars.size(); i++)
	{
		if (vars[i].r == wend)
			return 1;
		if (dfs(g, vars[i].r + 1, wend))
			return 1;
	}
	return 0;
}

bool cmpl(vert a, vert b)
{
	return a.l < b.l;
}


int main()
{
	long long n, k;
	cin >> n >> k;
	vector<vert> place(n);
	unordered_map<long long, vector<vert> > g;
	for (auto &x : place)
	{
		cin >> x.l >> x.r >> x.p;
		g[x.l].push_back(x);
	}
	if (dfs(g, 1, k))
	{
		cout << 1;
		cin >> n;
		return 0;
	}
	long long p = 0;
	sort(place.begin(), place.end(), cmpl);
	for (long long i = 0; i < n; i++)
	{
		if (place[i].l - 1 > p)
		{
			cout << -1;
			cin >> n;
			return 0;
		}
		p = max(p, place[i].r);
	}
	cout << 2;
	cin >> n;
    return 0;
}

