import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {

    FastScaner in;
    PrintWriter out;

    class Pair {
        long a, b;
    }

    Pair ask(long v) {
        out.println("X " + v);
        out.flush();
        Pair pair = new Pair();
        pair.a = in.nextLong();
        if (pair.a != -1)
            pair.b = in.nextLong();
        return pair;
    }

    boolean ans(long v) {
        out.println("N " + v);
        out.flush();
        return in.next().equals("Correct");
    }

    boolean play() {
        long v = 2, cur = 1;
        while (true) {
            Pair p = ask(v);
            if (p.a == -1)
                return false;
            if (p.a == 0)
                break;
            cur = Math.max(cur, p.b);
            v *= 2;
        }
        return ans(cur);
    }

    void solve() {
        int g = in.nextInt();
        for (int i = 0; i < g; i++)
            if (!play())
                break;
    }

    void run() {
        out = new PrintWriter(System.out);
        in = new FastScaner();
        solve();
        out.close();
    }

    public static void main(String[] args) {
        (new Main()).run();
    }

    class FastScaner {
        StringTokenizer st;
        BufferedReader br;

        FastScaner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens())
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            return st.nextToken();
        }

        Integer nextInt() {
            return Integer.parseInt(next());
        }

        Long nextLong() {
            return Long.parseLong(next());
        }
    }
}
