import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Main {

    FastScaner in;
    PrintWriter out;

    class Pair {
        long a, b;
    }

    Pair ask(long v) {
        out.println("X " + v);
        out.flush();
        Pair pair = new Pair();
        pair.a = in.nextLong();
        if (pair.a != -1)
            pair.b = in.nextLong();
        return pair;
    }

    boolean ans(long v) {
        out.println("N " + v);
        out.flush();
        return in.next().equals("Correct");
    }

    boolean can(List<Pair> list, long v) {
        long val = (1L << v);
        Pair p = ask(val);
        list.add(p);
        return p.a != 0;
    }

    boolean play() {
        int cur = 0;
        List<Pair> list = new ArrayList<>();
        Pair pr = new Pair(); pr.a = 1; pr.b = 1;
        list.add(pr);
        for (int i = 5; i >= 0; i--) {
            if (can(list, cur + (1 << i)))
                cur += (1 << i);
        }
        long ank = -1;
        for (int i = list.size() - 1; i >= 0; i--) {
            Pair p = list.get(i);
            if (p.a != 0) {
                ank = p.b;
                break;
            }
        }
        return ans(ank);
    }

    void solve() {
        int g = in.nextInt();
        for (int i = 0; i < g; i++)
            if (!play())
                break;
    }

    void run() {
        out = new PrintWriter(System.out);
        in = new FastScaner();
        solve();
        out.close();
    }

    public static void main(String[] args) {
        (new Main()).run();
    }

    class FastScaner {
        StringTokenizer st;
        BufferedReader br;

        FastScaner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens())
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            return st.nextToken();
        }

        Integer nextInt() {
            return Integer.parseInt(next());
        }

        Long nextLong() {
            return Long.parseLong(next());
        }
    }
}
