import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.StringTokenizer;

public class C {

	public static class Check implements Comparable<Check> {
		int l;
		int r;

		public Check(int l, int r) {
			this.l = l;
			this.r = r;
		}

		public Check(Segment s) {
			this(s.l, s.r);
		}

		@Override
		public int compareTo(Check o) {
			// TODO Auto-generated method stub
			if (this.l != o.l) {
				return this.l - o.l;
			}
			return this.r - o.r;
		}
	}

	public static class Segment implements Comparable<Segment> {
		int l;
		int r;
		int p;

		public Segment(int l, int r, int p) {
			this.l = l;
			this.r = r;
			this.p = p;
		}

		@Override
		public int compareTo(Segment o) {
			// TODO Auto-generated method stub
			return this.r - o.r;
		}
	}

	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(in.readLine());
		PrintWriter out = new PrintWriter(System.out);
		int n = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		Segment[] s = new Segment[n];
		for (int i = 0; i < s.length; i++) {
			st = new StringTokenizer(in.readLine());
			s[i] = new Segment(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()),
					Integer.parseInt(st.nextToken()));
		}
		Check[] ch = new Check[n];
		for (int i = 0; i < ch.length; i++) {
			ch[i] = new Check(s[i]);
		}
		int last = 0;
		Arrays.sort(ch);
		Arrays.sort(s);
		for (int i = 0; i < ch.length; i++) {
			if (ch[i].l <= last + 1) {
				last = Math.max(last, ch[i].r);
			}
		}
		if (last < k) {
			out.print(-1);
			out.close();
			return;
		}
//		ArrayList<Integer> a = new ArrayList<>();
//		a.add(0);
//		int[] back = new int[s.length];
//		for (int i = 0; i < s.length; i++) {
//			if (a.get(a.size() - 1) != s[i].r) {
//				a.add(s[i].r);
//			}
//			back[i] = a.size() - 1;
//		}
		long[] max = new long[n + 1];
		long[] lastMax = new long[n + 1];
		for (int i = 1; i < lastMax.length; i++) {
			max[i] = Long.MAX_VALUE / 2;
			lastMax[i] = Long.MAX_VALUE / 2;
		}
		int[] l = new int[n];
		int[] r = new int[n + 1];
		for (int i = 0; i < l.length; i++) {
			l[i] = s[i].l;
			r[i + 1] = s[i].r;
		}
		int[] next = new int[n];
		for (int i = 0; i < next.length; i++) {
			int left = -1;
			int right = n;
			while (left + 1 < right) {
				int m = (left + right) / 2;
				if (r[m] >= l[i] - 1) {
					right = m;
				} else {
					left = m;
				}
			}
			next[i] = right;
		}
		boolean allOne = true;
		for (int i = 0; i < s.length; i++) {
			if (s[i].p != 1) {
				allOne = false;
				break;
			}
		}
		if (allOne) {
			HashSet<Integer> h = new HashSet<>();
			h.add(0);
			for (int i = 0; i < ch.length; i++) {
				if (h.contains(ch[i].l - 1)) {
					h.add(ch[i].r);
				}
			}
			if (h.contains(k)) {
				out.print(1);
			} else {
				out.print(2);
			}
//			boolean[] end = new boolean[a.size()];
//			end[0] = true;
//			for (int i = 0; i < ch.length; i++) {
//				int l = -1;
//				int r = a.size();
//				while (l + 1 < r) {
//					int m = (l + r) / 2;
//					if (a.get(m) < ch[i].l) {
//						l = m;
//					} else {
//						r = m;
//					}
//				}
//				if (a.get(l) == ch[i].l - 1 && end[l]) {
//					end[back[i]] = true;
//				}
//			}
//			if (end[a.size() - 1]) {
//				out.print(1);
//			} else {
//				out.print(2);
//			}
		} else {
			for (int i = 0; i < s.length; i++) {
				int j = next[i];
				while (j > 0 && r[j - 1] == r[j]) {
					j--;
				}
				for (; r[j] < r[i + 1]; j++) {
					long m = 0;
					if (max[j] == Long.MAX_VALUE / 2 || lastMax[j] == Long.MAX_VALUE / 2) {
						continue;
					}
					if (r[j] == l[i] - 1) {
						m = Math.max(s[i].p, max[j]);
					} else {
						m = Math.max(s[i].p + lastMax[j], max[j]);
					}
					lastMax[i + 1] = s[i].p;
					max[i + 1] = Math.min(m, max[i + 1]);
				}
			}
//			for (int i = 0; i < max.length; i++) {
//				System.out.println(max[i] + " " + lastMax[i]);
//			}
			long ans = Long.MAX_VALUE;
			for (int i = 0; i < r.length; i++) {
				if (r[i] == k) {
					ans = Math.min(ans, max[i]);
				}
			}
			out.print(ans);
		}
		in.close();
		out.close();
	}

}
