#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iterator>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define for1(i, n) for(int i = 1; i <= (int)n; i++)
#define all(v) v.begin(), v.end()

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int MAXN = (int)6e3 + 7;
const ll INF = (ll)2e9 + 10;

struct event{
	int l, r, p;
} a[MAXN];

vi g, bucket[MAXN];
int start[MAXN];
int dp[MAXN][MAXN];

bool f(ll m) {
	for1(i, (int)g.size() - 1) {
		//dp[i] = INF;
		fill(&dp[i][0], &dp[i][MAXN], INF);
		for (int pos : bucket[i]) {
			for (int j = start[pos] - 1; j >= 0; j--) {
				if (dp[start[pos] - 1][j] < INF && a[pos].p <= m) {
					dp[i][start[pos]] = min(dp[i][start[pos]], a[pos].p);
				}
			}
			for (int j = start[pos]; j < i; j++) {
				for (int w = j; w >= 0; w--) {
					//if (dp[j] + a[pos].p <= m) {
						//dp[i] = min(dp[i], a[pos].p);
					//}
					if (dp[j][w] + a[pos].p <= m) {
						dp[i][j] = min(dp[i][j], a[pos].p);
					}
				}
			}
		}
	}
	int minim = INF;
	for (int w = 0; w < g.size(); w++) {
		minim = min(minim, dp[(int)g.size() - 1][w]);
	}
	return minim < INF;
}
void solve() {
	int n, k;
	scanf("%d%d", &n, &k);
	g.push_back(0);
	g.push_back(k);
	forn(i, n) {
		scanf("%d%d%d", &a[i].l, &a[i].r, &a[i].p);
		g.push_back(a[i].l - 1);
		g.push_back(a[i].r);
	}
	sort(all(g));
	g.resize(unique(all(g)) - g.begin());

	forn(i, n) {
		int pos = lower_bound(all(g), a[i].r) - g.begin();
		bucket[pos].push_back(i);
		pos = lower_bound(all(g), a[i].l) - g.begin();
		start[i] = pos;
	}
	ll l = -1, r = INF;
	while (r - l > 1) {
		ll m = (l + r) / 2;
		if (f(m)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	if (r == INF) {
		r = -1;
	}
	cout << r;
	return;
}